/*
//  NSMenu(iTeXMac).h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Sep 22 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <AppKit/NSMenu.h>

@class NSString;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= NSMenu(iTeXMac)

@interface NSMenu(iTeXMac)
/*"Class methods"*/
+ (NSMenu *) hierarchicalMenuAtPath: (NSString *) aFullPath action: (SEL) aSelector target: (id) aTarget;
/*"Setters and Getters"*/
- (id <NSMenuItem>) deepItemWithTitle: (NSString *) aTitle;
- (id <NSMenuItem>) deepItemWithAction: (SEL) aSelector;
- (id <NSMenuItem>) deepItemWithRepresentedObject: (id) anObject;
- (BOOL) isRootMenu;
- (id <NSMenuItem>) itemWithAction: (SEL) aSelector;
- (id <NSMenuItem>) itemWithRepresentedObject: (id) anObject;
- (int) indexOfItemWithAction: (SEL) aSelector;
- (int) indexOfItemWithTarget: (id) aTarget;
- (void) deepSetTarget: (id) aTarget;
- (void) deepSetAutoenablesItems: (BOOL) aFlag;
/*"Main methods"*/
- (void) deselectItemsWithAction: (SEL) anAction;
- (void) removeItemsWithAction: (SEL) anAction;
- (void) removeItemsWithRepresentedObject: (id) anObject;
- (void) deepEnableItems;
- (NSMenu *) deepCopy;
- (NSMenu *) deepCopyWithZone: (NSZone *) aZone;
- (void) makeCellSizeSmall;
- (void) deepMakeCellSizeSmall;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= NSMenu(iTeXMac)
