/*
//  iTMHelpButton.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Mon Sep 24 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <AppKit/AppKit.h>
#import "iTMHelpButton.h"

#define dIsLargeButtonSize NO

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMHelpButton
/*"Description forthcoming."*/
@implementation iTMHelpButton
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-initWithFrame
- (id) initWithFrame: (NSRect) irrelevant;
/*"No target set here.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    self = [super initWithFrame: NSMakeRect(0,0,32,32)];
    [self setBordered: YES];
    [self setTitle: @""];
    if(dIsLargeButtonSize)
        [[self cell] setBezelStyle: NSCircularBezelStyle];
    else
        [[self cell] setBezelStyle: NSRoundedBezelStyle];
    [[self cell] setHighlightsBy: NSChangeGrayCellMask];//[NSContentsCellMask];
    [self setAction: @selector(showHelp:)];
    [self setTarget: self];
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= drawRect:
- (void) drawRect: (NSRect) aRect;
/*"Draws a button (inherited method), then draws a question mark.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    float alpha = [self isEnabled]? 0.66: 0.4;
    float fontSize = dIsLargeButtonSize? 20:14;
    NSDictionary * attributes;
    NSString * QM = @"?";
    NSSize size;
    NSFont * font = [NSFont fontWithName: @"Times-Bold" size: 18];
    if(!font) font = [NSFont boldSystemFontOfSize: fontSize];
    attributes = [[NSDictionary dictionaryWithObjectsAndKeys: font, NSFontAttributeName,
                    [[NSColor blackColor] colorWithAlphaComponent: alpha], NSForegroundColorAttributeName, nil] retain];
    size = [QM sizeWithAttributes: attributes];
    [super drawRect: aRect];
    [QM drawAtPoint: NSMakePoint(NSMidX([self bounds])-size.width/2, NSMidY([self bounds])-size.height/2-2)
        withAttributes: attributes];
    [attributes release];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= showHelp:
- (void) showHelp: (id) sender;
/*"When the receiver is in a palette, it should always be valid. Its target should be itself. Does nothing.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: IS IT RELEVANT?
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= description
- (NSString *) description;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [NSString stringWithFormat: @"<%@ %@>", [super description], NSStringFromSelector([self action])];
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMHelpButton

