/*
//  iTMNavigationFormatter.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Jul 03 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import "iTMNavigationFormatter.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMNavigationFormatter
/*"Description forthcoming."*/
@implementation iTMNavigationFormatter
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= init
- (id) init;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use methodForSelector instead of getLineStart
"*/
{
    self = [super init];
    [self setPositiveFormat: @"#0"];
    {
        NSAttributedString * string = [[NSAttributedString alloc] initWithString: @"..."];
        [self setAttributedStringForNotANumber: string];
        [self setAttributedStringForZero: string];
        [self setAttributedStringForNil: string];
        [string release];
    }
    [self setMinimum: [NSDecimalNumber zero]];
    [self setMaximum: [NSDecimalNumber notANumber]];
    [self setAllowsFloats: NO];
    [self setHasThousandSeparators: NO];
    [self setNavigationFormat: NSLocalizedStringFromTableInBundle(@"Page %1$@ of %2$@", @"Basic",
                                                [NSBundle bundleForClass: [self class]], "Navigation format")];
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= dealloc
- (void) dealloc;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setNavigationFormat: nil];
    [super dealloc];
    return;
}	 
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= navigationFormat
- (NSString *) navigationFormat;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use methodForSelector instead of getLineStart
"*/
{
    return [[_NavigationFormat copy] autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= setNavigationFormat:
- (void) setNavigationFormat: (NSString *) aFormat;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(![aFormat isEqualToString: _NavigationFormat])
    {
        [_NavigationFormat release];
        _NavigationFormat = [aFormat copy];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= stringForObjectValue:
- (NSString *) stringForObjectValue: (id) anObject;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use methodForSelector instead of getLineStart
"*/
{
    return [NSString stringWithFormat: [self navigationFormat],
        [super stringForObjectValue: anObject],
        [super stringForObjectValue: [self maximum]]];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= editingStringForObjectValue:
- (NSString *) editingStringForObjectValue:(id) anObject;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use methodForSelector instead of getLineStart
"*/
{
    return [NSString string];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= isPartialStringValid:newEditingString:errorDescription:
- (BOOL) isPartialStringValid: (NSString **) partialStringPtr
proposedSelectedRange: (NSRangePointer) proposedSelRangePtr
originalString: (NSString *) origString
originalSelectedRange: (NSRange) origSelRange
errorDescription: (NSString **) error;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    id anObject;
    NSString * localError;
    BOOL result;
    if(!error)
        error = &localError;
    result = [self getObjectValue: &anObject forString: *partialStringPtr errorDescription: error];
    if(!result)
    {
        *partialStringPtr = [[origString copy] autorelease];
	*proposedSelRangePtr = origSelRange;
    }
    return result;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMNavigationFormatter

