/*
//  iTMSessionManager.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Fri Nov 30 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSObject.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMUDRememberSessionsKey;
extern NSString * const iTMUDLastSessionNameKey;
extern NSString * const iTMUDSmartSaveSessionKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMSessionManager

@interface iTMSessionManager : NSObject
{
@private
    id _SD;
}
/*"Class methods"*/
+ (void) initialize;
+ (id) sharedSessionManager;
+ (void) applicationDidFinishLaunching: (NSNotification *) aNotification;
/*"Setters and Getters"*/
- (NSString *) sessionsDirectoryPath;
/*"Main methods"*/
- (void) openSession: (id) irrelevant;
- (void) saveSession: (id) irrelevant;
- (void) prepareSessionForSaving;
- (void) saveSession;
- (void) removeSession: (id) irrelevant;
- (void) changeSession: (id) irrelevant;
- (NSString *) panel: (id) sender userEnteredFilename: (NSString *) filename confirmed: (BOOL) aFlag;
- (void) documentControllerWillCloseAll: (NSNotification *) aNotification;
- (void) documentControllerDidCloseAll: (NSNotification *) aNotification;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMSessionManager
