/*
//  iTMMacrosController(Macros).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Jan 10 2002.
//  Copyright © 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMMacrosController(Macros).h"
#import "iTMProjectsManager.h"
#import "iTMProjectDocument(Accessors).h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacrosController(Macros)
/*"This part is in the general section because it covers the messages that lie upon the project manager: all the
#{xxxMacrosPathForDocument:}."*/
@implementation iTMMacrosController(Macros)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  textMacrosMenuForDocument:
#define MACROMENU(selector, key)\
- (NSString *) selector: (NSDocument *) aDocument;\
{\
    return [[[iTMProjectsManager defaultManager] projectForDocument: aDocument] stringForKey: key];\
}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
MACROMENU(docMacrosPathForDocument, iTMPDMacrosPathDocKey);
MACROMENU(gfxMacrosPathForDocument, iTMPDMacrosPathGfxKey);
MACROMENU(mathMacrosPathForDocument, iTMPDMacrosPathMathKey);
MACROMENU(miscMacrosPathForDocument, iTMPDMacrosPathMiscKey);
MACROMENU(textMacrosPathForDocument, iTMPDMacrosPathTextKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  templatesPathForDocument:
- (NSString *) templatesPathForDocument: (id) aDocument;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [[[iTMProjectsManager defaultManager] projectForDocument: aDocument] stringForKey: iTMPDMacrosPathTmplKey];
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacrosController(Macros)

