/*
//  iTMRepAlbumView.h
//  TBR Tutorial
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Jun 27 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/
#import <Cocoa/Cocoa.h>

extern NSString * const iTMMagnificationDidChangeNotification;

extern NSString * const iTMMagnificationKey;
extern NSString * const iTMUDRepAlbumMarginKey;
extern NSString * const iTMUDCurrentRepMagnificationKey;
extern NSString * const iTMUDPreferredRepMagnificationKey;
extern NSString * const iTMUDStickToWindowKey;
extern NSString * const iTMUDStickToWindowModeKey;

typedef enum
{
    iTMStickToActualMode = 0,
    iTMStickToPreferredMode = 1,
    iTMStickToWidthMode = 2,
    iTMStickToHeightMode = 3,
    iTMStickToViewMode = 4
} iTMStickToWindowMode;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepAlbumView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

@interface iTMRepAlbumView : NSView
{
@private
    NSDecimalNumber * _Magnification;
    BOOL _CanStick;
    BOOL _ParametersHaveChanged;
}
/*"Setters and getters."*/
- (NSDecimalNumber *) preferredMagnification;
- (NSDecimalNumber *) magnification;
- (void) setMagnification: (NSDecimalNumber *) aMagnification;
- (void) setMagnificationWithMode: (iTMStickToWindowMode) mode;
- (NSDecimalNumber *) innerMagnification;
- (NSDecimalNumber *) outerMagnification;
- (NSDecimalNumber *) ratioContentVersusDocumentWidth;
- (NSDecimalNumber *) ratioContentVersusDocumentHeight;
- (NSString *) currentMagnificationKey;
- (NSString *) preferredMagnificationKey;
- (BOOL) parametersHaveChanged;
- (void) setParametersHaveChanged: (BOOL) aFlag;
/*"Main mathods."*/
- (void) enclosingScrollViewFrameDidChange:  (NSNotification*) notification;
- (void) registerCurrentMagnification;
- (void) prepareToUpdate;
- (void) update;
- (id) representation;
- (void) awakeFromNib;
- (NSView *) newSubview;
- (void) updateSubview: (NSView *) subview;
/*"Overriden methods."*/
- (void) setNeedsDisplay: (BOOL) aFlag;
- (void) drawRect: (NSRect) rect;
- (void) dealloc;
@end

@interface NSView(iTMRepAlbumView)
- (NSPoint) absoluteFocus;
@end


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepAlbumView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
