/*
//  iTMRepWindowController.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Jan 06 2002.
//  Copyright © 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMUDAutoUpdatesViewKey;
extern NSString * const iTMUDSmartUpdatesViewKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepWindowController

@interface iTMRepWindowController : NSWindowController
{
@private
    id _TD;
    IBOutlet id _Album;/*"Album view"*/
    // automatic update...
    NSDate * _QFMD;
    NSDate * _NQFMD;
    BOOL _UpdateIsLocked;//Critical: problem with key window and the dock menu... in automatic update (see engineer also)
}
/*"Class methods"*/
+ (void) initialize;
/*"Setters and Getters"*/
- (id) album;
- (void) setAlbum: (NSView *) aView;
- (id) toolbarDelegate;
- (void) setToolbarDelegate: (id) argument;
/*"Main methods"*/
- (NSString *) toolbarIdentifier;
- (void) installToolbarWithIdentifier: (NSString *) anIdentifier;
/*"Overriden methods"*/
- (void) windowWillLoad;
- (void) windowDidLoad;
- (void) setDocument: (NSDocument *) aDocument;
- (void) dealloc;
@end

@interface iTMRepWindowController(Toolbar)
- (Class) repToolbarDelegateClass;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepWindowController
