/*
//  iTMHistoryButton.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Sep 25 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSGeometry.h>
#import "iTMHistoryButton.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMHistoryButton
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
@implementation iTMHistoryButton
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- button
+ (iTMHistoryButton *) button;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    iTMHistoryButton * result = [self alloc];
    result = [result initWithFrame: NSMakeRect(0,0,32,32)];
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- initWithFrame:
- (id) initWithFrame: (NSRect) irrelevant;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    self = [super initWithFrame: NSMakeRect(0,0,32,32)];
    [self setBordered: YES];
    [self setTitle: @""];
    [[self cell] setBezelStyle: NSRoundedBezelStyle];
    [[self cell] setHighlightsBy: NSChangeGrayCellMask];//[NSContentsCellMask];
    [self setCenteredArrow: NO];
    [self setMixedEnabled: YES];
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- drawRect:
- (void) drawRect: (NSRect) aRect;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [super drawRect: aRect];
    [self displayIcon];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- displayIcon
- (void) displayIcon;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return;
}
@end

@implementation iTMForwardButton
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- displayIcon
- (void) displayIcon;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    float alpha = [self isEnabled]? 0.66: 0.4;
    NSBezierPath * path = [[NSBezierPath bezierPath] retain];
    NSPoint center = NSZeroPoint;
    NSRect aRect = [self bounds];
    [path setLineJoinStyle: NSRoundLineJoinStyle];
    [path moveToPoint: NSMakePoint(NSMidX(aRect), NSMidY(aRect)-1.5)];
    center = [path currentPoint];
    [NSColor setIgnoresAlpha: NO];
    [[[NSColor blackColor] colorWithAlphaComponent: alpha] set];
    [path relativeMoveToPoint: NSMakePoint(+4,+0)];
    [path relativeMoveToPoint: NSMakePoint(+4.62,+0)];
    [path relativeLineToPoint: NSMakePoint(-6.93,+5)];
    [path relativeLineToPoint: NSMakePoint(0,-10)];
    [path closePath];
    [path relativeMoveToPoint: NSMakePoint(-9.93,+0)];
    [path appendBezierPathWithArcWithCenter: [path currentPoint] radius: 2 startAngle: 0 endAngle: 360];	 
    [path relativeMoveToPoint: NSMakePoint(-7,+0)];
    [path appendBezierPathWithArcWithCenter: [path currentPoint] radius: 2 startAngle: 0 endAngle: 360];	 
    [path closePath];
    {
        NSAffineTransform * transform = [[NSAffineTransform transform] retain];
        [transform translateXBy: 3 yBy: 3];
        [transform scaleBy: 0.8];
        [path transformUsingAffineTransform: transform];
        [transform release];
    }
    [path fill];
    [path release];
    return;
}
@end

@implementation iTMBackButton
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- displayIcon
- (void) displayIcon;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    float alpha = [self isEnabled]? 0.66: 0.4;
    NSBezierPath * path = [[NSBezierPath bezierPath] retain];
    NSPoint center = NSZeroPoint;
    NSRect aRect = [self bounds];
    [path setLineJoinStyle: NSRoundLineJoinStyle];
    [path moveToPoint: NSMakePoint(NSMidX(aRect), NSMidY(aRect)-1.5)];
    center = [path currentPoint];
    [NSColor setIgnoresAlpha: NO];
    [[[NSColor blackColor] colorWithAlphaComponent: alpha] set];
    [path relativeMoveToPoint: NSMakePoint(-4,+0)];
    [path relativeMoveToPoint: NSMakePoint(-4.62,+0)];
    [path relativeLineToPoint: NSMakePoint(+6.93,-5)];
    [path relativeLineToPoint: NSMakePoint(0,+10)];
    [path closePath];
    [path relativeMoveToPoint: NSMakePoint(+9.93,+0)];
    [path appendBezierPathWithArcWithCenter: [path currentPoint] radius: 2 startAngle: 0 endAngle: 360];	 
    [path relativeMoveToPoint: NSMakePoint(+3,+0)];
    [path appendBezierPathWithArcWithCenter: [path currentPoint] radius: 2 startAngle: 0 endAngle: 360];	 
    [path closePath];
    {
        NSAffineTransform * transform = [[NSAffineTransform transform] retain];
        [transform translateXBy: 3 yBy: 3];
        [transform scaleBy: 0.8];
        [path transformUsingAffineTransform: transform];
        [transform release];
    }
    [path fill];
    [path release];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMHistoryButton

