/*
//  iTMMagnificationFormatter.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Sep 25 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMMagnificationFormatter.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMMagnificationFormatter
/*"Description forthcoming."*/
@implementation iTMMagnificationFormatter
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- init
- (id) init;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List: use methodForSelector instead of getLineStart
"*/
{
    self = [super init];
    [self setPositiveFormat: @"#0 %"];
    {
        NSAttributedString * string = [[NSAttributedString alloc] initWithString: @"..."];
        [self setAttributedStringForNotANumber: string];
        [self setAttributedStringForZero: string];
        [self setAttributedStringForNil: string];
        [string release];
    }
    [self setMinimum: [NSDecimalNumber zero]];
    [self setMaximum: [NSDecimalNumber notANumber]];
    #warning YES or NO?
    [self setAllowsFloats: YES];
    [self setHasThousandSeparators: NO];
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- stringForObjectValue:
- (NSString *) stringForObjectValue: (id) anObject;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List: use methodForSelector instead of getLineStart
"*/
{
    if([anObject respondsToSelector: @selector(floatValue)])
        return [super stringForObjectValue: [NSDecimalNumber numberWithFloat: 100*[anObject floatValue]]];
    else
        return @"?";
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- editingStringForObjectValue:
- (NSString *) editingStringForObjectValue:(id) anObject;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List: use methodForSelector instead of getLineStart
"*/
{
    return [NSString string];
}
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- isPartialStringValid:newEditingString:errorDescription:
- (BOOL) isPartialStringValid: (NSString **) partialStringPtr
proposedSelectedRange: (NSRangePointer) proposedSelRangePtr
originalString: (NSString *) origString
originalSelectedRange: (NSRange) origSelRange
errorDescription: (NSString **) error;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List: I don't know if it is really needed, test...
"*/
{
#warning TEST (JL)
    id anObject;
    NSString * localError;
    BOOL result;
    if(!error)
        error = &localError;
    result = [self getObjectValue: &anObject forString: *partialStringPtr errorDescription: error];
    if(!result)
    {
        *partialStringPtr = [[origString copy] autorelease];
	*proposedSelRangePtr = origSelRange;
    }
    return result;
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- getObjectValue:forString:errorDescription:
- (BOOL) getObjectValue: (id *) objectPtr forString: (NSString *) string errorDescription: (NSString **) errorPtr;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    NSScanner * scanner = [NSScanner scannerWithString: string];
    float F;
    if([scanner scanFloat: &F] && (F>0) &&(F<=6400))
        *objectPtr = [NSDecimalNumber numberWithFloat: F/100];
    else
        *objectPtr = nil;
    return (*objectPtr != nil);
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMMagnificationFormatter

