/*
//  iTMPDFAlbumView.m
//  TBR Tutorial
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Jun 27 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import "iTMPDFAlbumView.h"
//#import "iTMPDFDocument.h"
#import "iTMPDFView.h"
#import "NSView(iTeXMac).h"

NSString * const iTMUDCurrentPDFMagnificationKey = @"iTMCurrentPDFMagnification";
NSString * const iTMUDPreferredPDFMagnificationKey = @"iTMPreferredPDFMagnification";

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPDFAlbumView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

@interface NSView(iTMPDFAlbumView)
- (void) setCurrentPage: (int) argument;
@end

@implementation iTMPDFAlbumView
/*"This class draws a photo frame around each subviews. We definitely can not use NSImage
ability to draw this kind of frame as it is because this AppKit class scales the image.
So, the proportions are not respected at all. This could be annoying for precise measurements.
Only one usefull method is implemented #{drawrect:}, the others are for private use."*/
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  initialize
+ (void) initialize;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [super initialize];
    [[NSUserDefaults standardUserDefaults] registerDefaults:
        [NSDictionary dictionaryWithObjectsAndKeys:
            [NSDecimalNumber one], iTMUDCurrentPDFMagnificationKey,
            [NSDecimalNumber one], iTMUDPreferredPDFMagnificationKey, nil]];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  awakeFromNib
- (void) awakeFromNib;
/*"Registers for NSViewFrameDidChangeNotification sent by the enclosing scroll view."*/
{
    [super awakeFromNib];
    _CurrentPage = -1;
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= currentPage
- (int) currentPage;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return _CurrentPage;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= setCurrentPage:
- (void) setCurrentPage: (int) aCurrentPage;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    aCurrentPage = MIN(aCurrentPage, [[self representation] pageCount] - 1);
    if(aCurrentPage != _CurrentPage)
    {
        _CurrentPage = aCurrentPage;
        [self setParametersHaveChanged: YES];
        [self setNeedsDisplay: YES];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  preferredMagnificationKey
- (NSString *) preferredMagnificationKey;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return iTMUDPreferredPDFMagnificationKey;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  currentMagnificationKey
- (NSString *) currentMagnificationKey;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return iTMUDCurrentPDFMagnificationKey;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  newSubview
- (NSView *) newSubview;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return [[[iTMPDFView alloc] initWithFrame: NSZeroRect] autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  updateSubview:
- (void) updateSubview: (NSView *) subview;
/*"Description forthcoming. Subclasses will append their own update process.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [super updateSubview: subview];
    [subview setCurrentPage: [self currentPage]];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPDFAlbumView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
