/*
//  iTMPDFDocument.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Jun 24 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import <Foundation/NSString.h>
#import <Foundation/NSPathUtilities.h>
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "NSResponder(iTeXMac).h"
#import "NSWindow(iTeXMac).h"
#import "iTMPDFDocument.h"
//#import "iTMRepDocument(Magnification).h"
//#import "iTMPDFDocument(Navigation).h"
#import "iTMPDFWindowController.h"
#import "iTMNavigationFormatter.h"
#import "iTMFlagsChangedView.h"

#warning bad design: must be read in the info.plist
NSString * const iTMPDFDocumentType = @"Adobe PDF Document";// this must appear in the info.plist

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMPDFDocument  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

@implementation iTMPDFDocument
#if 1
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  isPDFDocument
- (BOOL) isPDFDocument;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return [[[[self fileName] pathExtension] lowercaseString] isEqualToString: @"pdf"];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  representationWCClass
- (Class) representationWCClass;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return [iTMPDFWindowController class];
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= rootFileName
- (NSString *) rootFileName;
/*"Returns the core file name dot the identifier. Lazy initialization.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if(!_RFN)
    {
        NSString * CFN = [self coreFileName];
        if([CFN length])
        {
            NSString * IFN = [self identifier];
            if([IFN length])
                _RFN = [[CFN stringByAppendingPathExtension: IFN] retain];
            else
                _RFN = [CFN retain];
        }
        else
            _RFN = [@"" retain];
    }
    return _RFN;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= coreFileName
- (NSString *) coreFileName;
/*"The principal part of the filename, without any extension, neither "pdf" nor any identifier.
"foo.[identifieri.]extension" will return "foo". Lazy initialization.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if(!_CFN)
    {
        NSString * FN = [self fileName];
        NSArray * source = [[FN lastPathComponent] componentsSeparatedByString: @"."];
        if([source count] > 0)
            _CFN = [[[FN stringByDeletingLastPathComponent]
                            stringByAppendingPathComponent: [source objectAtIndex: 0]] retain];
        else
            _CFN = [@"" retain];
    }
    return _CFN;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= identifier
- (NSString *) identifier;
/*""foo.identifier[.identifieri].extension" will return "identifier[.identifieri]".
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if(!_IFN)
    {
        NSMutableArray * MA = [[[[self fileName] lastPathComponent] componentsSeparatedByString: @"."] mutableCopy];
        if([MA count] > 1)
        {
            [MA removeObjectAtIndex: 0];
            [MA removeObjectAtIndex: [MA count] - 1];
            _IFN = [[MA componentsJoinedByString: @"."] retain];
        }
        else
            _IFN = [@"" retain];
        [MA release];
    }
    return _IFN;
}
@end

@implementation iTMPDFDocument(Cocoa)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  dealloc
- (void) dealloc;
/*"Description forthcoming."*/
{
    [[NSNotificationCenter defaultCenter] removeObserver: self];
    [self setFileName: nil];// to erase some internal caches (_?FN instance variables)
    [super dealloc];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  setFileName:
- (void)  setFileName: (NSString *) aFN;
/*"Erase the cached core file name, root file name and identifier.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [_CFN release];
    [_RFN release];
    [_IFN release];
    _CFN = nil;
    _RFN = nil;
    _IFN = nil;
    [super setFileName: aFN];
    return;
}
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMPDFDocument  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
