/*
//  iTMPrintView.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Jul 17 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  History:
//  replaces Koch's PrintView
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMPrintView.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMPrintView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
@implementation iTMPrintView
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- initWithRepresentation:
- (id) initWithRepresentation: (id) aRepresentation;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([aRepresentation respondsToSelector: @selector(bounds)])
        self = [super initWithFrame: [aRepresentation bounds]];
    if([aRepresentation respondsToSelector: @selector(boundingBox)])
        self = [super initWithFrame: [aRepresentation boundingBox]];
    else
        self = [super initWithFrame: NSMakeRect(0.0, 0.0, [aRepresentation size].width, [aRepresentation size].height)];
    [self setRepresentation: aRepresentation];
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- initWithFrame:
- (id) initWithFrame: (NSRect) aRect;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    NSAssert1(NO, @"-[iTMPrintView initWithFrame:] out of purpose: report bug for object %@", [self description]);
    return nil;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- drawRect:
- (void) drawRect: (NSRect) aRect;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    NSEraseRect([self bounds]);
    [[self representation] draw];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- pageCount
- (int) pageCount;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([[self representation] respondsToSelector: @selector(pageCount)])
        return [[self representation] pageCount];
    else
        return 1;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- knowsPageRange:
- (BOOL) knowsPageRange: (NSRangePointer) range;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    range->location = 1;
    range->length = [self pageCount];
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- isVerticallyCentered
- (BOOL) isVerticallyCentered;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- isHorizontallyCentered
- (BOOL) isHorizontallyCentered;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- rectForPage:
- (NSRect) rectForPage: (int) pageNumber;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    pageNumber = MAX(pageNumber, 1);
    pageNumber = MIN(pageNumber, [self pageCount]);
    if([[self representation] respondsToSelector: @selector(setCurrentPage:)])
        [[self representation] setCurrentPage: pageNumber - 1];
    return [self frame];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- representation
- (id) representation;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    return _ImageRep;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- setRepresentation:
- (void) setRepresentation: (id) anImageRep;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if(![anImageRep isEqual: _ImageRep])
    {
        [_ImageRep release];
        _ImageRep = [anImageRep retain];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- dealloc
- (void) dealloc;
{
    [self setRepresentation: nil];
    [super dealloc];
}
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- iTMPrintView  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
