/*
//  iTMRepWindowController(iTMMagnification).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Jan 26 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMRepWindowController(iTMMagnification).h"
#import "iTMRepAlbumView.h"
#import "iTMMagnificationFormatter.h"

@interface NSDocument(iTMRepWindowController)
- (NSData *) data;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  iTMRepWindowController(iTMMagnification)
/*"The window controller is the delegate of the window to catch all the messages. It is a window controller of an iTMRepDocument."*/
@implementation iTMRepWindowController(iTMMagnification)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  displayZoomIn:...
- (IBAction) displayZoomIn: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnification: [[self album] innerMagnification]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  displayZoomOut:...
- (IBAction) displayZoomOut: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnification: [[self album] outerMagnification]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleActualSize:
- (IBAction) toggleActualSize: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey])
        [[NSUserDefaults standardUserDefaults]
            setObject: [NSNumber numberWithInt: iTMStickToActualMode]
                forKey: iTMUDStickToWindowModeKey];
    [self displayActualSize: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- toggleStickToWindow:
- (void) toggleStickToWindow: (id) sender;
/*"Description Forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    BOOL flag = [[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey];
    [[NSUserDefaults standardUserDefaults] setObject: [NSNumber numberWithBool: !flag] forKey: iTMUDStickToWindowKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=  displayActualSize:...
- (IBAction) displayActualSize: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    #warning preferred magnification should be implemented
    [[self album] setMagnification: [[self album] preferredMagnification]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleFitToWidth:...
- (IBAction) toggleFitToWidth: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey])
        [[NSUserDefaults standardUserDefaults]
            setObject: [NSNumber numberWithInt: iTMStickToWidthMode]
                forKey: iTMUDStickToWindowModeKey];
    [self displayFitToWidth: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=  displayFitToWidth:...
- (IBAction) displayFitToWidth: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnificationWithMode: iTMStickToWidthMode];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-  toggleFitToHeight:...
- (IBAction) toggleFitToHeight: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey])
        [[NSUserDefaults standardUserDefaults]
            setObject: [NSNumber numberWithInt: iTMStickToHeightMode]
                forKey: iTMUDStickToWindowModeKey];
    [self displayFitToHeight: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-  displayFitToHeight:...
- (IBAction) displayFitToHeight: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnificationWithMode: iTMStickToHeightMode];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleFitToView:...
- (IBAction) toggleFitToView: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey])
        [[NSUserDefaults standardUserDefaults]
            setObject: [NSNumber numberWithInt: iTMStickToViewMode]
                forKey: iTMUDStickToWindowModeKey];
    [self displayFitToView: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  displayFitToView:...
- (IBAction) displayFitToView: (id) sender
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnificationWithMode: iTMStickToViewMode];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  displayAtMagnification:
- (void) displayAtMagnification: (id) sender;
/*"Description forthcoming. From the menu items
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([sender representedObject])
        [[self album] setMagnification: [sender representedObject]];
    else
    {
        iTMMagnificationFormatter * MF = [[iTMMagnificationFormatter alloc] init];
        NSDecimalNumber * number;
        if([MF getObjectValue: &number forString: [sender title] errorDescription: nil])
            [[self album] setMagnification: number];
        else
        {
            [sender setAction: NULL];
            NSLog(@"Unexpected sender(action): %@", sender);
        }
        [MF release];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  displayAtStepperMagnification:
- (void) displayAtStepperMagnification: (id) sender;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    if([sender intValue]>0)
        [self displayZoomIn: sender];
    else
        [self displayZoomOut: sender];
    [sender setIntValue: 0];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  magnificationFieldSetMagnification:
- (void) magnificationFieldSetMagnification: (id) sender;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    [[self album] setMagnification: [sender objectValue]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToolbarItem:
- (BOOL) validateToolbarItem: (id) anItem;
/*"Description forthcoming.
History: jerome.laurens@u-bourgogne.fr
To Do List:
"*/
{
    SEL action = [anItem action];
    if(action == @selector(displayAtMagnification:))
        return [[self document] data]!=nil;
    else if(action == @selector(printDocument:))
        return [[self document] data]!=nil;
    else
        return NO;
    #warning add the stepper ?
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMenuItem:
- (BOOL) validateMenuItem: (id) anItem;
/*" This concerns only the magnification menu items of the PDF Display menu and the
corresponding ones in the popup Fit button. Only takes into account the upper limit
of the magnification."*/
{
#warning JL
    SEL action = [anItem action];
    BOOL hasRepresentation = ([[self document] data] != nil);
    if(action == @selector(displayZoomIn:))
        return hasRepresentation;// &&
                    //([self magnification] < [[[self newMagnificationFormatter] maximum] floatValue]);
    else if(action == @selector(displayZoomOut:) ||
            action == @selector(displayAtMagnification:) ||
            action == @selector(displayActualSize:) ||
            action == @selector(displayFitToWidth:) ||
            action == @selector(displayFitToHeight:) ||
            action == @selector(displayFitToView:))
        return hasRepresentation;
    else if(action == @selector(toggleStickToWindow:))
    {
        [anItem setState: ([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey]?
            NSOnState: NSOffState)];
        return YES;
    }
    else if(action == @selector(toggleActualSize:))
    {
        [anItem setState:
            (([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey] &&
                ([[NSUserDefaults standardUserDefaults] integerForKey: iTMUDStickToWindowModeKey] == iTMStickToActualMode))?
                    NSOnState: NSOffState)];
        return YES;
    }
    else if(action == @selector(toggleFitToWidth:))
    {
        [anItem setState:
            (([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey] &&
                ([[NSUserDefaults standardUserDefaults] integerForKey: iTMUDStickToWindowModeKey] == iTMStickToWidthMode))?
                    NSOnState: NSOffState)];
        return YES;
    }
    else if(action == @selector(toggleFitToHeight:))
    {
        [anItem setState:
            (([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey] &&
                ([[NSUserDefaults standardUserDefaults] integerForKey: iTMUDStickToWindowModeKey] == iTMStickToHeightMode))?
                    NSOnState: NSOffState)];
        return YES;
    }
    else if(action == @selector(toggleFitToView:))
    {
        [anItem setState:
            (([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDStickToWindowKey] &&
                ([[NSUserDefaults standardUserDefaults] integerForKey: iTMUDStickToWindowModeKey] == iTMStickToViewMode))?
                    NSOnState: NSOffState)];
        return YES;
    }
    else
        return NO;
}
@end


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  iTMRepWindowController(iTMMagnification)

