/*
//  iTMLogFontColorPrefPane.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Mar 05 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMPreferencePane.h"
#import "iTMTextView.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMLogFontColorPrefPane

@interface iTMLogFontColorPrefPane : iTMPreferencePane
{
    NSString * _FontKey;
    NSString * _ColorKey;
    NSPopUpButton * syntaxPopUp;
    NSPopUpButton * textViewPopUp;
    NSTextField * syntaxFontNameTextField;
    NSTextField * generalFontNameTextField;
    NSTextField * syntaxFontSizeTextField;
    NSTextField * generalFontSizeTextField;
    NSTabView * tabView;
    iTMTextView * textView;
    NSColorWell * syntaxColorWell;
    NSColorWell * textViewColorWell;
}
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSString *) fontKey;
- (void) setFontKey: (NSString *) argument;
- (NSString *) colorKey;
- (void) setColorKey: (NSString *) argument;
- (NSString *) initialTextViewContents;
- (NSColorWell *) currentWell;
- (NSPopUpButton *) currentPopUp;
- (NSTextField *) fontNameTextField;
- (NSTextField *) fontSizeTextField;
- (NSString *) initialTextViewContents;
/*"Main methods"*/
- (void) popUpSyntaxAttributes: (id) sender;
- (void) popUpTextViewAttributes: (id) sender;
- (IBAction) showFontPanel: (id) sender;
- (IBAction) toggleUseSyntaxColoring: (id) sender;
- (void) validateToggleUseSyntaxColoring: (id) sender;
- (IBAction) toggleUseTextViewColors: (id) sender;
- (void) validateToggleUseTextViewColors: (id) sender;
- (void) changeFont: (id) fontManager;
- (void) changeColor: (id) colorPanel;
- (void) validateUserInterface;
/*"Overriden methods"*/
- (void) dealloc;
- (void) loadWindow;
//- (void) willSelect;
- (void) didSelect;
//- (void) willUnselect;
//- (void) didUnselect;
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMLogFontColorPrefPane
