/*
//  iTMPreferencePane.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Mar 05 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@class iTMSettings;
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPreferencePane

@interface iTMPreferencePane : NSObject
{
@private
    NSWindow * _Window;
    NSView * _MainView;
    NSView * _InitialFirstResponder;
    iTMSettings * _PPUD;
    NSUndoManager * _PPUM;
    BOOL _HUM;
}
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSString *) mainNibName;
- (NSWindow *) window;
- (void) setWindow: (NSWindow *) argument;
- (NSView *) mainView;
- (void) setMainView: (NSView *) argument;
- (iTMSettings *) preferences;
- (void) setPreferences: (iTMSettings *) argument;
- (NSUndoManager *) undoManager;
- (void) setUndoManager: (NSUndoManager *) argument;
- (BOOL) hasUndoManager;
- (void) setHasUndoManager: (BOOL) argument;
- (void) setInitialFirstResponder: (NSView *) view;
- (NSView *) initialFirstResponder;
#if 0
- (NSString *) stringForKey: (NSString *) defaultName;
- (NSArray *) arrayForKey: (NSString *) defaultName;
- (NSDictionary *) dictionaryForKey: (NSString *)  defaultName;
- (NSData *) dataForKey: (NSString *) defaultName;
- (NSArray *) stringArrayForKey: (NSString *) defaultName;
- (int) integerForKey: (NSString *) defaultName; 
- (float) floatForKey: (NSString *) defaultName; 
- (BOOL) boolForKey: (NSString *) defaultName;  
- (id) objectForKey: (NSString *) key;
- (void) setObject: (id) object forKey: (NSString *) key;
#endif
- (BOOL) canApplyChangeNow;  
- (BOOL) canRevertChangeNow;  
/*"Main methods"*/
- (void) willSelect;
- (void) didSelect;
- (void) willUnselect;
- (void) didUnselect;
- (void) writeAndSynchronizeUserDefaults;
- (void) userDefaultsWrittenAndSynchronized;
- (void) loadWindow;
- (void) validateUserInterface;
- (void) discardAnyChange;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPreferencePane
