/*
//  iTMTeTeXPrefPane.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Mar 13 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMPreferencePane.h"

typedef enum
{
      iTMInstallationStandard = 1,
      iTMInstallationFink = 2,
      iTMInstallationOther = 10
} iTMInstallationType;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXPrefPane

@interface iTMTeTeXPrefPane : iTMPreferencePane
{
@private
    int ghostScriptInstallationType;
    int docInstallationType;
    int TeXMFInstallationType;
    NSDictionary * _StandardDictionary;
    NSDictionary * _FinkDictionary;
    int teTeXInstallationType;
}
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
- (IBAction) ghostScriptBrowse: (id) sender;
- (IBAction) ghostScriptField: (id) sender;
- (IBAction) ghostScriptRadio: (id) sender;
- (IBAction) docBrowse: (id) sender;
- (IBAction) docField: (id) sender;
- (IBAction) docParse: (id) sender;
- (IBAction) docRadio: (id) sender;
- (IBAction) teTeXBrowse: (id) sender;
- (IBAction) teTeXField: (id) sender;
- (IBAction) teTeXRadio: (id) sender;
- (IBAction) TeXMFBrowse: (id) sender;
- (IBAction) TeXMFField: (id) sender;
- (IBAction) TeXMFRadio: (id) sender;
- (IBAction) validateGhostScriptBrowse: (id) sender;
- (IBAction) validateGhostScriptField: (id) sender;
- (IBAction) validateGhostScriptRadio: (id) sender;
- (IBAction) validateDocBrowse: (id) sender;
- (IBAction) validateDocField: (id) sender;
- (IBAction) validateDocParse: (id) sender;
- (IBAction) validateDocRadio: (id) sender;
- (IBAction) validateTeTeXBrowse: (id) sender;
- (IBAction) validateTeTeXField: (id) sender;
- (IBAction) validateTeTeXRadio: (id) sender;
- (IBAction) validateTeXMFBrowse: (id) sender;
- (IBAction) validateTeXMFField: (id) sender;
- (IBAction) validateTeXMFRadio: (id) sender;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXPrefPane
