/*
//  iTMDefaultsController.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Mon Mar 04 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "NSView(iTeXMac).h"
#import "iTMDefaultsController.h"
#import "iTMPreferencePane.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMDefaultsController
/*"Description forthcoming."*/
@implementation iTMDefaultsController
static id _iTMSharedDefaultsController = nil;
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= sharedDefaultsController
+ (id) sharedDefaultsController;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    static BOOL firstTime = YES;
    if(firstTime && !_iTMSharedDefaultsController)
    {
        NSString * mainNibName = NSStringFromClass([self class]);
        NSString * path;
        path = [[NSBundle bundleForClass: [self class]] pathForResource: mainNibName
                        ofType: @"nib"];//[ inDirectory: @"Preferences"];
        if(![path length])
            path = [[NSBundle bundleForClass: [self class]] pathForResource: mainNibName ofType: @"nib"];
        if(![path length])
            path = [[NSBundle mainBundle] pathForResource: mainNibName ofType: @"nib"];//[ inDirectory: @"Preferences"];
        if(![path length])
            path = [[NSBundle mainBundle] pathForResource: mainNibName ofType: @"nib"];
        if(![path length])
            NSLog(@"-[sharedDefaultsController loadWindow]: Unable to find a nib file named %@", mainNibName);
        else
        {
            _iTMSharedDefaultsController = [self allocWithZone: [NSApp zone]];
            _iTMSharedDefaultsController = [_iTMSharedDefaultsController initWithWindowNibPath: path
                                                    owner: _iTMSharedDefaultsController];
        }
        firstTime = NO;
    }
    return _iTMSharedDefaultsController;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= initWithWindow:
- (id) initWithWindow: (NSWindow *) window;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/26/2002
To Do List:
"*/
{
    if(_iTMSharedDefaultsController)
    {
        if(![self isEqual: _iTMSharedDefaultsController])
            [super dealloc];
        return [_iTMSharedDefaultsController retain];
    }
    else if(self = [super initWithWindow: window])
    {
        [self setWindowFrameAutosaveName: NSStringFromClass([self class])];
    }
    return _iTMSharedDefaultsController = self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= dealloc
- (void) dealloc;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [[NSNotificationCenter defaultCenter] removeObserver: self];
    [_CurrentPane autorelease];
    _CurrentPane = nil;
    [super dealloc];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= windowDidLoad
- (void) windowDidLoad;
/*"The first object inited is the shared one. All the pref panes are the represented objects of their icon buttons.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    NSString * path = [[NSBundle mainBundle]
                pathForResource: @"iTMPreferencePanes" ofType: @"plist"];//[ inDirectory: @"Preferences"];
    if([path length])
    {
        NSArray * RA = [NSArray arrayWithContentsOfFile: path];
        if([RA count])
        {
            NSEnumerator * E = [RA objectEnumerator];
            NSDictionary * D;
            while(D = [E nextObject])
            {
                if([D isKindOfClass: [NSDictionary class]])
                {
                    NSString * className = [D objectForKey: @"Name"];
                    if([className isKindOfClass: [NSString class]])
                    {
                        Class C = NSClassFromString(className);
                        id object = [[[C alloc]init] autorelease];
                        if([object isKindOfClass: [iTMPreferencePane class]])
                        {
                            NSButtonCell * C = [[[NSButtonCell alloc]init]autorelease];
                            {
                                NSString * title = [D objectForKey: @"Label"];
                                if([title isKindOfClass: [NSString class]])
                                    [C setTitle: title];
                            }
                            {
                                NSString * path = [[NSBundle mainBundle] pathForResource: className
                                        ofType: @"tif"];//[ inDirectory: @"Preferences"];
                                if(![path length])
                                    path = [[NSBundle mainBundle] pathForResource: className
                                        ofType: @"tiff"];//[ inDirectory: @"Preferences"];
                                if([path length])
                                    [C setImage: [[[NSImage alloc] initWithContentsOfFile: path] autorelease]];
                            }
                            [C setFont: [NSFont systemFontOfSize: [NSFont smallSystemFontSize]]];
                            [C setBezelStyle: NSShadowlessSquareBezelStyle];
                            [C setHighlightsBy: NSChangeGrayCellMask | NSChangeBackgroundCellMask];
                            [C setShowsStateBy: NSChangeBackgroundCellMask];
                            [C setBordered: NO];
                            [C setBezeled: NO];
                            [C setButtonType: NSOnOffButton];
                            [C setState: NSOffState];
                            [C setImagePosition: NSImageAbove];
                            [C setRepresentedObject: object];
                            [iconMatrix addColumnWithCells: [NSArray arrayWithObject: C]];
                        }
                        else
                            NSLog(@"-[iTMDefaultsController windowDidLoad] Bad iTMPreferencePanes.plist(3)<%@>.\n\
                            Reinstall.", className);
                    }
                    else
                        NSLog(@"-[iTMDefaultsController windowDidLoad] Bad iTMPreferencePanes.plist(2).\nReinstall.");
                }
                else
                    NSLog(@"-[iTMDefaultsController windowDidLoad] Bad iTMPreferencePanes.plist(1).\nReinstall.");
            }
            [iconMatrix setBackgroundColor: [NSColor controlBackgroundColor]];
            [iconMatrix removeColumn: 0];
            [iconMatrix calcSize];
            {
                NSSize cellSize = [iconMatrix cellSize];
                cellSize.width += 10;
                cellSize.height = [[[iconMatrix enclosingScrollView] contentView] frame].size.height;
                [iconMatrix setCellSize: cellSize];
            }
            [iconMatrix sizeToCells];
            [iconMatrix setNeedsDisplay: YES];
            _MinPaneHeight = MAX(50, [paneView frame].size.height);
            [iconMatrix setAllowsEmptySelection: NO];
            [iconMatrix setTarget: self];
            [iconMatrix setAction: @selector(selectPrefPane:)];
            [_CurrentPane autorelease];
            _CurrentPane = nil;
            [self selectPrefPane: iconMatrix];
            [[NSNotificationCenter defaultCenter]
                removeObserver: self
                    name: NSWindowDidBecomeMainNotification
                        object: nil];
            [[NSNotificationCenter defaultCenter]
                addObserver: self
                    selector: @selector(windowDidBecomeMain:)
                        name: NSWindowDidBecomeMainNotification
                            object: [self window]];
            return;
        }
    }
    NSLog(@"-[iTMDefaultsController windowDidLoad] Bad iTMPreferencePanes.plist.\nReinstall.");
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= windowDidBecomeMain:
- (void) windowDidBecomeMain: (NSNotification *) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [_CurrentPane validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Ok:
- (void) Ok: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [self close];
    [[NSUserDefaults standardUserDefaults] synchronize];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= cancel:
- (void) cancel: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [self close];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= apply:
- (void) apply: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    if([_CurrentPane canApplyChangeNow])
        [_CurrentPane writeAndSynchronizeUserDefaults];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateApply:
- (void) validateApply: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: [_CurrentPane canApplyChangeNow]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= revert:
- (void) revert: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    if([_CurrentPane canRevertChangeNow])
        [_CurrentPane discardAnyChange];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRevert:
- (void) validateRevert: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: [_CurrentPane canRevertChangeNow]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= resetStandardUserDefaults:
- (void) resetStandardUserDefaults: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    NSBundle * B = [NSBundle bundleForClass: [self class]];
    NSBeginCriticalAlertSheet(
        NSLocalizedStringFromTableInBundle(@"iTeXMac Preferences", @"Preferences", B,"Panel title"),
            NSLocalizedStringFromTableInBundle( @"Don't Revert", @"Preferences", B, "Button title"),
                NSLocalizedStringFromTableInBundle( @"Revert", @"Preferences", B, "Button title"),//alt
                    nil,//other
    [self window],
    self,
    NULL,
    @selector(resetSheetDidDismiss:returnCode:contextInfo:),
    nil,
    NSLocalizedStringFromTableInBundle( @"Really want to revert to factory defaults?",
                        @"Preferences", B, "Panel Information"));
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateResetStandardUserDefaults:
- (void) validateResetStandardUserDefaults: (id) sender;
/*"The first object inited is the shared one.
Designated initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  updateSheetDidDismiss:returnCode:contextInfo:
- (void) resetSheetDidDismiss: (NSWindow *) sheet returnCode: (int) returnCode contextInfo: (void *) irrelevant;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    if(returnCode == NSAlertAlternateReturn)
    {
        NSEnumerator * E = [[iconMatrix cells] objectEnumerator];
        NSCell * C;
        while(C = [E nextObject])
            [[C representedObject] discardAnyChange];
        [NSUserDefaults resetStandardUserDefaults];
        [[NSUserDefaults standardUserDefaults] synchronize];
        [_CurrentPane validateUserInterface];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= selectPrefPane:
- (void) selectPrefPane: (id) sender;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    iTMPreferencePane * newPane = [[sender selectedCell]representedObject];
    if(![newPane isEqual: _CurrentPane])
    {
        [_CurrentPane willUnselect];
        {
            NSView * V = [newPane mainView];
            NSArray * views = [paneView subviews];
            while([[paneView subviews] count]>0)
                [[views objectAtIndex: 0] removeFromSuperviewWithoutNeedingDisplay];
            [_CurrentPane didUnselect];
            [newPane willSelect];
            if(V)
            {
                float newPaneHeight = MAX(_MinPaneHeight, [V frame].size.height+10);
                float oldPaneHeight = [paneView frame].size.height;
                NSRect frameRect = [[self window] frame];
                float deltaHeight = newPaneHeight - oldPaneHeight;
                frameRect.size.height += deltaHeight;
                frameRect.origin.y -= deltaHeight;
                frameRect.size.width = MAX(frameRect.size.width, [V frame].size.width+10);
                [[self window] setFrame: frameRect display: YES animate: YES];
                [V setFrameOrigin: [paneView frame].origin];
                [paneView addSubview: V];
                [V centerInSuperview];
                [V setAutoresizingMask: NSViewMinXMargin | NSViewMaxXMargin | NSViewMinYMargin | NSViewMaxYMargin];
            }
            else
                NSLog(@"No view for %@, %@", newPane, paneView);
        }
        [_CurrentPane autorelease];
        _CurrentPane = [newPane retain];
        [paneView setNeedsDisplay: YES];
        if([[[_CurrentPane initialFirstResponder] window] isEqual: [self window]])
            [[self window] setInitialFirstResponder: [_CurrentPane initialFirstResponder]];// KEY loop?
        [newPane didSelect];
    }
    else
        NSLog(@"NO CHANGE");
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMDefaultsController

