/*
//  iTMTeTeXPrefPane.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Mar 13 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <cocoa/cocoa.h>
#import "iTMTeTeXPrefPane.h"
#import "iTMTeTeXController.h"
#import "iTMSettings.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXPrefPane
/*"Description forthcoming."*/
@implementation iTMTeTeXPrefPane
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  initialize
+ (void) initialize;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super initialize];
    [iTMTeTeXController initialize];// critical to have default values
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  init
- (id) init;
/*"Designated Initializer.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    if(self = [super init])
    {
        [_StandardDictionary autorelease];
        _StandardDictionary = nil;
        [_FinkDictionary autorelease];
        _FinkDictionary = nil;
    }
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  dealloc
- (void) dealloc;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    [_StandardDictionary autorelease];
    _StandardDictionary = nil;
    [_FinkDictionary autorelease];
    _FinkDictionary = nil;
    [super dealloc];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  loadWindow
- (void) loadWindow;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super loadWindow];
    if(!_StandardDictionary)
        _StandardDictionary = [[[iTMTeTeXController sharedTeTeXController]standardPathsDictionary] retain];
    if(!_FinkDictionary)
        _FinkDictionary = [[[iTMTeTeXController sharedTeTeXController]finkPathsDictionary] retain];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  chooseDirectoryFromRunningOpenPanelForKey:
- (void) chooseDirectoryFromRunningOpenPanelForKey: (NSString*) aKey;
{
    NSOpenPanel * OP = [NSOpenPanel openPanel];
    [OP setAllowsMultipleSelection: NO];
    [OP setCanChooseFiles: NO];
    [OP setCanChooseDirectories: YES];
    [OP setResolvesAliases: NO];
    [OP setTreatsFilePackagesAsDirectories: NO];
    [OP beginSheetForDirectory: nil
        file: nil
            types: nil
                modalForWindow: [[self mainView]window]
                    modalDelegate: self
                        didEndSelector: @selector(openPanelDidEnd:returnCode:key:)
                            contextInfo: aKey];
    return;
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  openPanelDidEnd:returnCode:key:
- (void) openPanelDidEnd: (NSOpenPanel *) sheet returnCode: (int) returnCode key: (NSString *) aKey
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(returnCode == NSOKButton)
    {
        NSAssert1(([aKey isKindOfClass: [NSString class]] && [aKey length]),
            @"-[iTMTeXPrefPane openPanelDidEnd:returnCode:key:] Bad context info: %@", aKey);
        [[self preferences] setObject: [[sheet filenames]objectAtIndex: 0] forKey: aKey];
        [self validateUserInterface];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  ghostScriptBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  teTeXBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  TeXMFBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docBrowse
#define BROWSE(browse, type, key, oldKey)\
- (IBAction) browse: (id) sender;\
{\
    [self chooseDirectoryFromRunningOpenPanelForKey: key];\
    if([[[self preferences] stringForKey: key] isEqualToString: [_StandardDictionary objectForKey: key]])\
        type = iTMInstallationStandard;\
    else if([[[self preferences] stringForKey: key] isEqualToString: [_FinkDictionary objectForKey: key]])\
        type = iTMInstallationFink;\
    else\
    {\
        type = iTMInstallationOther;\
        [[NSUserDefaults standardUserDefaults]setObject:\
            [[self preferences] stringForKey: key]\
                forKey: oldKey];\
    }\
    return;\
}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
BROWSE(ghostScriptBrowse, ghostScriptInstallationType, iTMUDGSBinariesPATHKey, iTMUDGSBinariesOtherPATHKey);
BROWSE(teTeXBrowse, teTeXInstallationType, iTMUDTeTeXBinariesPATHKey, iTMUDTeTeXBinariesOtherPATHKey);
BROWSE(TeXMFBrowse, TeXMFInstallationType, iTMUDTeXMFPATHKey, iTMUDTeXMFOtherPATHKey);
BROWSE(docBrowse, docInstallationType, iTMUDTeXMFDocPATHKey, iTMUDTeXMFDocOtherPATHKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docParse
- (IBAction) docParse: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    #warning NYI
    NSBeep();
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateDocParse
- (void) validateDocParse: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  ghostScriptRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  teTeXRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  TeXMFRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docRadio
#define RADIO(type, action, key, otherKey)\
- (void) action: (id) sender;\
{\
    type = [[sender selectedCell]tag];\
    if(type == iTMInstallationStandard)\
        [[self preferences] setObject: [[[iTMTeTeXController sharedTeTeXController] standardPathsDictionary] objectForKey: key]\
            forKey: key];\
    else if(type == iTMInstallationFink)\
        [[self preferences] setObject: [[[iTMTeTeXController sharedTeTeXController] finkPathsDictionary] objectForKey: key]\
            forKey: key];\
    else\
    {\
        [[self preferences] setObject: [[self preferences] objectForKey: otherKey] forKey: key];\
            NSLog(@"%@: %@", key, [[self preferences] objectForKey: key]);\
            NSLog(@"%@: %@", otherKey, [[self preferences] objectForKey: otherKey]);}\
    [self validateUserInterface];\
    return;\
}
RADIO(ghostScriptInstallationType, ghostScriptRadio, iTMUDGSBinariesPATHKey, iTMUDGSBinariesOtherPATHKey);
RADIO(teTeXInstallationType, teTeXRadio, iTMUDTeTeXBinariesPATHKey, iTMUDTeTeXBinariesOtherPATHKey);
RADIO(TeXMFInstallationType, TeXMFRadio, iTMUDTeXMFPATHKey, iTMUDTeXMFOtherPATHKey);
RADIO(docInstallationType, docRadio, iTMUDTeXMFDocPATHKey, iTMUDTeXMFDocOtherPATHKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  ghostScriptField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  teTeXField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  TeXMFField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docField
#define FIELD(key, action)\
- (void) action: (id) sender;\
{\
    [[self preferences] setObject: [sender stringValue] forKey: key];\
    [self validateUserInterface];\
    return;\
}
FIELD(iTMUDGSBinariesPATHKey, ghostScriptField);
FIELD(iTMUDTeTeXBinariesPATHKey, teTeXField);
FIELD(iTMUDTeXMFPATHKey, TeXMFField);
FIELD(iTMUDTeXMFDocPATHKey, docField);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateGhostScriptField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeTeXField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeXMFField
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateDocField
#define VALIDATEFIELD(key, type, validator)\
- (void) validator: (id) sender;\
{\
    [sender setStringValue: [[self preferences] stringForKey: key]];\
    [sender setEnabled: (type == iTMInstallationOther)];\
    return;\
}
VALIDATEFIELD(iTMUDGSBinariesPATHKey, ghostScriptInstallationType, validateGhostScriptField);
VALIDATEFIELD(iTMUDTeTeXBinariesPATHKey, teTeXInstallationType, validateTeTeXField);
VALIDATEFIELD(iTMUDTeXMFPATHKey, TeXMFInstallationType, validateTeXMFField);
VALIDATEFIELD(iTMUDTeXMFDocPATHKey, docInstallationType, validateDocField);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateGhostScriptRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeTeXRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeXMFRadio
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateDocRadio
#define VALIDATERADIO(type, validator)\
- (void) validator: (id) sender;\
{\
    [sender deselectAllCells];\
    [sender selectCellWithTag: type];\
    return;\
}
VALIDATERADIO(ghostScriptInstallationType, validateGhostScriptRadio);
VALIDATERADIO(teTeXInstallationType, validateTeTeXRadio);
VALIDATERADIO(TeXMFInstallationType, validateTeXMFRadio);
VALIDATERADIO(docInstallationType, validateDocRadio);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateGhostScriptBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeTeXBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTeXMFBrowse
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateDocBrowse
#define VALIDATEBROWSE(type, validator)\
- (void) validator: (id) sender;\
{\
    [sender setEnabled: (type == iTMInstallationOther)];\
    return;\
}
VALIDATEBROWSE(ghostScriptInstallationType, validateGhostScriptBrowse);
VALIDATEBROWSE(teTeXInstallationType, validateTeTeXBrowse);
VALIDATEBROWSE(TeXMFInstallationType, validateTeXMFBrowse);
VALIDATEBROWSE(docInstallationType, validateDocBrowse);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  tabView:didSelectTabViewItem:
- (void) tabView: (NSTabView *) tabView didSelectTabViewItem: (NSTabViewItem *) tabViewItem;
/*"Just validates the interface.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self validateUserInterface];
    [[self window]setInitialFirstResponder: [tabViewItem initialFirstResponder]];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXPrefPane

