/*
//  iTMTeXInputPrefPane.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Mar 05 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMTeXInputPrefPane.h"
#import "iTMTextMacro.h"
#import "iTMTextWatcher.h"
#import "iTMTextView.h"
#import "iTMTeXWindowController.h"
#import "iTMSettings.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXInputPrefPane
/*"Description forthcoming."*/
@implementation iTMTeXInputPrefPane
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  initialize:
+ (void) initialize;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super initialize];
    [iTMTeXWindowController initialize];
    [iTMTextMacro initialize];
    [iTMTextView initialize];
    [iTMTextWatcher initialize];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  macroTabAnchorFieldEdited:
- (IBAction) macroTabAnchorFieldEdited: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setObject: [sender stringValue] forKey: iTMUDTabAnchorStringKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMacroTabAnchorFieldEdited:
- (void) validateMacroTabAnchorFieldEdited: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [[self preferences] stringForKey: iTMUDTabAnchorStringKey]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  spacesFieldEdited:
- (IBAction) spacesFieldEdited: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setInteger: [sender intValue] forKey: iTMUDNumberOfSpacesForTabKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateSpacesFieldEdited:
- (void) validateSpacesFieldEdited: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setIntValue: [[self preferences] integerForKey: iTMUDNumberOfSpacesForTabKey]];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleContinuousSpellChecking:
- (IBAction) toggleContinuousSpellChecking: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDContinuousSpellCheckingKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleContinuousSpellChecking:
- (void) validateToggleContinuousSpellChecking: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDContinuousSpellCheckingKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleMatchDelimiter:
- (IBAction) toggleMatchDelimiter: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDMatchDelimiterKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleMatchDelimiter:
- (void) validateToggleMatchDelimiter: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDMatchDelimiterKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  togglePreserveIndentation:
- (IBAction) togglePreserveIndentation: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDAutoIndentNewlineKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTogglePreserveIndentation:
- (void) validateTogglePreserveIndentation: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDAutoIndentNewlineKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleSmartInsert:
- (IBAction) toggleSmartInsert: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDSmartInsertKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleSmartInsert:
- (void) validateToggleSmartInsert: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDSmartInsertKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleSmartInsertDelete:
- (IBAction) toggleSmartInsertDelete: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDSmartInsertDeleteEnabledKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleSmartInsertDelete:
- (void) validateToggleSmartInsertDelete: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDSmartInsertDeleteEnabledKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleUseSpacesAsTabs:
- (IBAction) toggleUseSpacesAsTabs: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDUseSpacesAsTabsKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleUseSpacesAsTabs:
- (void) validateToggleUseSpacesAsTabs: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDUseSpacesAsTabsKey]? NSOnState: NSOffState)];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleShiftDelete:
- (IBAction) toggleShiftDelete: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDShiftDeleteKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleShiftDelete:
- (void) validateToggleShiftDelete: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDShiftDeleteKey]? NSOnState: NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toggleSmartSelection:
- (void) toggleSmartSelection: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: 
"*/
{
    [[self preferences] setBool: ([sender state] != NSOffState) forKey: iTMUDSmartSelectionKey];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateToggleSmartSelection:
- (void) validateToggleSmartSelection: (id) sender;
/*"Default implementation does nothing.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([[self preferences] boolForKey: iTMUDSmartSelectionKey]? NSOnState: NSOffState)];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXInputPrefPane

