/*
//  iTMProjectDocument(Accessors).h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Oct 02 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMProjectDocument.h"

extern NSString * const iTMPDIsGenericKey;

extern NSString * const iTMPDRootInputKey;
extern NSString * const iTMPDRootOutputKey;
extern NSString * const iTMPDDirectoryKey;
extern NSString * const iTMPDInputExtensionKey;
extern NSString * const iTMPDOutputExtensionKey;
extern NSString * const iTMPDCustomIdentifierKey;

extern NSString * const iTMPDCustomIdentKey;

extern NSString * const iTMPDCompileEngineKey;
extern NSString * const iTMPDCompileFormatKey;
extern NSString * const iTMPDCompileBaseKey;
extern NSString * const iTMPDKeepsDVIKey;
extern NSString * const iTMPDKeepsPSKey;
extern NSString * const iTMPDMLTeXKey;
extern NSString * const iTMPDInteractionKey;
extern NSString * const iTMPDOutputIdentKey;
extern NSString * const iTMPDRootKey;

extern NSString * const iTMPDCompileSilentlyKey;
extern NSString * const iTMPDUseCustomCompileKey;
extern NSString * const iTMPDCompileScriptKey;
extern NSString * const iTMPDTypesetSilentlyKey;
extern NSString * const iTMPDUseCustomTypesetKey;
extern NSString * const iTMPDTypesetScriptKey;

extern NSString * const iTMPDBibTeXSilentlyKey;
extern NSString * const iTMPDBibTeXScriptKey;
extern NSString * const iTMPDBMinXReferencesKey;

extern NSString * const iTMPDIndexScriptKey;
extern NSString * const iTMPDIndexSilentlyKey;
extern NSString * const iTMPDICompressBlankKey;
extern NSString * const iTMPDIGermanOrderingKey;
extern NSString * const iTMPDILetterOrderingKey;
extern NSString * const iTMPDIndexOutputKey;
extern NSString * const iTMPDIndexStartingKey;
extern NSString * const iTMPDINoImplicitRangeKey;
extern NSString * const iTMPDIndexStyleKey;
extern NSString * const iTMPDUseIndexStyleKey;
extern NSString * const iTMPDUseIndexOutputKey;

extern NSString * const iTMPDRenderDVIKey;
extern NSString * const iTMPDRenderPSKey;
extern NSString * const iTMPDRenderEPSKey;

extern NSString * const iTMPDMacrosPathDocKey;
extern NSString * const iTMPDMacrosPathGfxKey;
extern NSString * const iTMPDMacrosPathMathKey;
extern NSString * const iTMPDMacrosPathMiscKey;
extern NSString * const iTMPDMacrosPathTextKey;
extern NSString * const iTMPDMacrosPathTmplKey;

@class iTMTerminalController, NSMutableDictionary, NSString;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Accessors)

@interface iTMProjectDocument(Accessors)
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSMutableDictionary *) projectDictionary;
- (void) setProjectDictionary: (NSDictionary *) argument;
- (iTMTerminalController *) terminal;
- (void) setTerminal: (iTMTerminalController *) aTerminal;
- (NSString *) absoluteOutput;
- (NSString *) absoluteDirectory;
- (NSString *) absoluteInput;
- (NSString *) relativeRoot;
- (NSString *) absoluteRoot;
- (void) setAbsoluteInput: (NSString *) argument smart: (BOOL) aFlag;
- (void) setAbsoluteInput: (NSString *) argument;
- (void) _SetAbsoluteInput: (NSString *) argument;
- (NSString *) relativeInput;
- (void) setRelativeInput: (NSString *) argument smart: (BOOL) aFlag;
- (void) setRelativeInput: (NSString *) argument;
- (void) _SetRelativeInput: (NSString *) argument;
- (BOOL) isAbsolute;
- (void) setAbsolute: (BOOL) aFlag;
- (void) _SetAbsolute: (BOOL) aFlag;
- (BOOL) isCustomIdent;
- (void) setCustomIdent: (BOOL) aFlag;
- (BOOL) isCustomTypeset;
- (void) setCustomTypeset: (BOOL) aFlag;
- (BOOL) isCustomCompile;
- (void) setCustomCompile: (BOOL) aFlag;
- (NSDictionary *) environmentDictionary;
- (NSString *) stringForKey: (NSString *) aKey;
- (void) setString: (NSString *) argument forKey: (NSString *) aKey;
- (BOOL) boolForKey: (NSString *) aKey;
- (void) setBool: (BOOL) aFlag forKey: (NSString *) aKey;
- (NSString *) rootFileNameByConverting: (NSString *) argument;
- (NSString *) projectName;
- (void) setProjectName: (NSString *) argument;
- (NSString *) coreFileName;
/*"Main methods"*/
- (void) prepareProjectDictionaryForSaving;
- (void) prepareProjectManagement;
- (void) prepareRoot;
- (void) fixErrorsPopUp;
- (void) readInputHeader;
- (void) cleanOutlets;
- (void) setOutputIdentifier: (NSString *) argument;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Accessors)
