/*
//  iTMProjectDocument(Cocoa).h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Dec 11 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMProjectDocument.h"

extern NSString * const iTMUDTerminalBehindKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMProjectDocument(Cocoa)

@interface iTMProjectDocument(Cocoa)
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
/*"Overriden methods"*/
+ (void) initialize;
- (id) init;
- (void) dealloc;
- (void) makeWindowControllers;
- (void) showWindows;
- (BOOL) windowShouldClose: (id) sender;
- (BOOL) validateMenuItem: (id) sender;
- (BOOL) validateToolbarItem: (id) sender;
- (BOOL) writeToFile: (NSString *) fileName ofType: (NSString *) type;
- (void) setFileName: (NSString *) fileName;
- (NSData *) dataRepresentationOfType: (NSString *) aType;
- (BOOL) loadDataRepresentation: (NSData *) data ofType: (NSString *) aType;
- (NSFileWrapper *) fileWrapperRepresentationOfType: (NSString *) aType;
- (BOOL) loadFileWrapperRepresentation: (NSFileWrapper *) wrapper ofType: (NSString *) docType;
- (BOOL) isDocumentEdited;
- (void) updateChangeCount: (NSDocumentChangeType) change;
- (BOOL) textView: (NSTextView *) textView clickedOnLink: (id) link atIndex: (unsigned) charIndex;
- (void) textDidChange: (NSNotification *) aNotification;
@end

@interface NSDocument(iTMProjectDocumentCocoa)
- (void) setCurrentPage: (int) pageNumber;
@end

@interface NSWindowController(iTMProjectDocumentCocoa)
- (void) highlightAndScrollLineToVisible: (int) lineNumber;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMProjectDocument(Cocoa)
