/*
//  iTMProjectEngineer.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Dec 02 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSObject.h>

extern NSString * const iTMTTProjectKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMProjectEngineer

@interface iTMProjectEngineer : NSObject
/*"Class methods"*/
+ (id) sharedProjectEngineer;
+ (int) numberOfErrorsInLogAtPath: (NSString *) aPath;
+ (int) numberOfErrorsInBlgAtPath: (NSString *) aPath;
/*"Setters and Getters"*/
- (NSString *) pathForAuxiliaryExecutable: (NSString *) argument;
- (NSDictionary *) envDictionaryByCompletingEnvDictionary: (NSDictionary *) aDictionary;
/*"Main methods"*/
- (void) makeIndex: (id) sender;
- (void) terminalDidMakeIndex: (id) aTerminal userInfo: (NSDictionary *) userInfo;
- (void) bibTeX: (id) sender;
- (void) terminalDidBibTeX: (id) aTerminal userInfo: (NSDictionary *) userInfo;
- (void) compile: (id) sender;
- (void) terminalDidCompile: (id) aTerminal userInfo: (NSDictionary *) userInfo;
- (void) typeset: (id) sender;
- (void) terminalDidTypeset: (id) aTerminal userInfo: (NSDictionary *) userInfo;
- (BOOL) validateMenuItem: (id) anItem;
- (NSDictionary *) envDictionaryByCompletingEnvDictionary: (NSDictionary *) aDictionary;
- (void) render: (id) sender;
/*"Overriden methods"*/
- (id) init;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMProjectEngineer
