/*
//  iTMProjectsManager.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Oct 07 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMPCDefaultGenericProjectKey;

@class iTMProjectDocument;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectsManager

@interface iTMProjectsManager : NSObject
{
    NSMenu * _APM;
    NSMenuItem * _SPMI;
    NSMenuItem * _PMI;
    NSMenuItem * _NPMI;
    int _NumberOfOpenProjects;
    iTMProjectDocument * _CAP;
    iTMProjectDocument * _CP;
    NSString * _PMIiTM;
    NSImage * _TerminalImage;
    NSImage * _RunningTerminalImage;
}
/*"Class methods"*/
+ (id) defaultManager;
/*"Setters and Getters"*/
- (id) projectForDocument: (id) argument;
- (id) currentProject;
- (void) setCurrentProject: (iTMProjectDocument *) argument;
- (id) currentActiveProject;
- (void) setCurrentActiveProject: (iTMProjectDocument *) aPD;
- (NSMenuItem *) projectMenuItem;
- (void) setProjectMenuItem: (NSMenuItem *) aMI;
- (NSMenuItem *) noProjectMenuItem;
- (void) setNoProjectMenuItem: (NSMenuItem *) aMI;
- (NSMenu *) showProjectsMenu;
- (NSMenuItem *) showProjectsMenuItem;
- (void) setShowProjectsMenuItem: (NSMenuItem *) aM;
- (NSMenu *) activeProjectsMenu;
- (void) setActiveProjectsMenu: (NSMenu *) aM;
- (NSString *) projectMenuItemTitleSeed;
- (void) setProjectMenuItemTitleSeed: (NSString *) argument;
- (NSString *) titleForProject: (iTMProjectDocument *) aDocument;
- (iTMProjectDocument *) projectForName: (NSString *) aName;
- (iTMProjectDocument *) projectForSource: (id) source;
/*"Main methods"*/
- (void) activateProject: (id <NSMenuItem>) sender;
- (void) addInTypesetSubmenus: (iTMProjectDocument *) document;
- (void) createTypesetSubmenusWith: (iTMProjectDocument *) document;
- (void) deleteTypesetSubmenus;
- (void) removeInTypesetSubmenus: (iTMProjectDocument *) document;
- (void) showProject: (id) sender;
- (void) showTerminal: (id) sender;
- (void) showInput: (id) sender;
- (void) showOutput: (id) sender;
- (void) synchronizeActiveAndShowMenus;
- (void) addDocument: (NSDocument *) document;
- (void) removeDocument: (NSDocument *) document;
- (void) loadGenericProjects: (id) sender;
- (BOOL) validateMenuItem: (id) anItem;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectsManager
