/*
//  iTMTeTeXController.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Dec 18 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMUDTeXMFPATHKey;
extern NSString * const iTMUDTeTeXBinariesPATHKey;
extern NSString * const iTMUDGSBinariesPATHKey;
extern NSString * const iTMUDTeXMFDocPATHKey;
extern NSString * const iTMUDTeXMFOtherPATHKey;
extern NSString * const iTMUDTeTeXBinariesOtherPATHKey;
extern NSString * const iTMUDGSBinariesOtherPATHKey;
extern NSString * const iTMUDTeXMFDocOtherPATHKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXController

@interface iTMTeTeXController : NSWindowController
{
@private
    NSMenu * _FAQs;
    NSMenu * _Docs;
    NSDictionary * _SPD;
    NSDictionary * _FPD;
    id docButton;
    id FAQButton;
}
/*"Class methods"*/
+ (void) initialize;
+ (id) sharedTeTeXController;
/*"Setters and Getters"*/
- (NSMenu *) TeXMFFAQsMenu;
- (NSMenu *) TeXMFDocsMenu;
- (NSString *) GSBinariesPath;
- (NSString *) TeTeXBinariesPath;
- (NSString *) TeXMFDocumentationPath;
- (NSString *) TeXMFFAQsPath;
- (NSDictionary *) standardPathsDictionary;
- (NSDictionary *) finkPathsDictionary;
/*"Main methods"*/
- (void) createMenus: (NSTimer *) aTimer;
- (void) openTeXMFDocumentation: (id <NSMenuItem>) sender;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeTeXController
