/*
//  iTMVirtualProject.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Dec 06 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMProjectDocument(Accessors).h"
#import "iTMProjectWindowController.h"
#import "iTMGeneralProject.h"
#import "iTMResourcesController(GeneralProject).h"
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMAbstractProject
/*"Description forthcoming."*/
@implementation iTMAbstractProject
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= isVoid
- (BOOL) isVoid;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: For compatibility
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= isStrongGeneric
- (BOOL) isStrongGeneric;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMenuItem:
- (BOOL) validateMenuItem: (id) sender;
/*" Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: FULL implementation missing
"*/
#warning Implementation missing
{
    SEL action = [sender action];
    if((action == @selector(saveDocument:)) ||(action == @selector(saveDocumentTo:)))
        return YES;
    else if((action == @selector(saveDocumentAs:)))
        return NO;
    else
        return [super validateMenuItem: sender];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateUserInterface
- (void) validateUserInterface;
/*"Sends a #{validateUserInterfaceItems} to the window content view.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    [super validateUserInterface];
    [[[self windowController] typesetTextView] setEditable: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= isDocumentEdited
- (BOOL) isDocumentEdited;
/*"If the document is generic, the inherited method is not called and the changes are not reflected in the window close button. As a consequence, the user will not be prompted to save generic projects while terminating the application.
Version History: jerome.laurens@u-bourgogne.fr (10/08/2001)
- < 1.1: 03/10/2002
To Do List: Does not work?
"*/
{
    return NO;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= updateChangeCount:
- (void) updateChangeCount: (NSDocumentChangeType) change;
/*"A patch to synchronize the UI with #{validateUserInterface} each time a change is made.
Version History: jerome.laurens@u-bourgogne.fr (10/08/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super updateChangeCount: change];
    [[[self windowController] window] setDocumentEdited: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateGenericChecked:
- (void) validateGenericChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: IMPLEMENT THE UNDO
"*/
{
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRootEdited:
- (IBAction) validateRootEdited: (NSControl *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSString * string = [self isAbsolute]? [self absoluteInput]: [self relativeInput];
    if(![[sender stringValue] isEqualToString: string]) [sender setStringValue: string];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChooseRoot:
- (void) validateChooseRoot: (id) sender;
/*"Action by a button. Opens a panel to choose a root file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRelativeAbsolute:
- (IBAction) validateRelativeAbsolute: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender selectCellWithTag: ([self isAbsolute]? 1: 0)];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomIdentChecked:
- (void) validateCustomIdentChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: NSOffState];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateOutputIdentEdited:
- (IBAction) validateOutputIdentEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [self stringForKey: iTMPDCustomIdentifierKey]];
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomCompileChecked:
- (IBAction) validateCustomCompileChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: NO];
    [sender setState: ([self isCustomCompile]? NSOnState: NSOffState)];
//    [[[self windowController] window] makeFirstResponder: [[self windowController] compileTextField]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomTypesetChecked:
- (IBAction) validateCustomTypesetChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: NO];
    [sender setState: ([self isCustomTypeset]? NSOnState: NSOffState)];
    [[[self windowController] typesetTextView] setEditable: [self isCustomTypeset]];
    [[[self windowController] window] makeFirstResponder: [[self windowController] typesetTextView]];
    return;
}
@end
@implementation iTMVirtualProject
static id _iTMVirtualProject;
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= virtualProject
+ (id) virtualProject;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return _iTMVirtualProject? _iTMVirtualProject:
        (_iTMVirtualProject = [[self allocWithZone:
            [NSApp zone]]
                initWithContentsOfFile: [[iTMResourcesController sharedResourcesController] virtualProjectPath]
                    ofType: [[[iTMResourcesController sharedResourcesController] virtualProjectPath] pathExtension]]);
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= writeToFile:ofType:
- (BOOL) writeToFile: (NSString *) fileName ofType: (NSString *) type;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use file wrappers instead.
"*/
{
    if(![fileName isEqualToString: [[iTMResourcesController sharedResourcesController] virtualProjectPath]] ||
        ([[NSFileManager defaultManager] fileExistsAtPath: fileName isDirectory: nil] &&
            (NSOKButton ==  NSRunInformationalAlertPanel(
                NSLocalizedStringFromTableInBundle(@"iTeXMac Virtual Project", @"Project",
                        [NSBundle bundleForClass: [self class]], "Panel title"),
                    NSLocalizedStringFromTableInBundle(@"Please confirm save operation.", @"Project",
                            [NSBundle bundleForClass: [self class]], "Save is a critical operation."),
                        nil,
                            NSLocalizedStringFromTableInBundle(@"Cancel", @"Project",
                                    [NSBundle bundleForClass: [self class]], "Title of Cancel button"),
                                nil))))
    	return [super writeToFile: fileName ofType: type];
    else
        return NO;
}
@end

@implementation iTMRenderProject
/*"It is used only for rendering operations: translate dvi, ps and eps files into pdf ones."*/
static id _iTMRenderProject;
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= renderProject
+ (id) renderProject;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return _iTMRenderProject? _iTMRenderProject:
        (_iTMRenderProject = [[self allocWithZone:
            [NSApp zone]]
                initWithContentsOfFile: [[iTMResourcesController sharedResourcesController] renderProjectPath]
                    ofType: [[[iTMResourcesController sharedResourcesController] renderProjectPath] pathExtension]]);
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= init
- (id) init;
/*"Description frthcmng. Oh, sorry, here they are: "o, o, i".
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(self = [super init])
    {
        [self setProjectDictionary: nil];
    }
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= writeToFile:ofType:
- (BOOL) writeToFile: (NSString *) fileName ofType: (NSString *) type;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: use file wrappers instead.
"*/
{
    if(![fileName isEqualToString: [[iTMResourcesController sharedResourcesController] renderProjectPath]] ||
        ([[NSFileManager defaultManager] fileExistsAtPath: fileName isDirectory: nil] &&
            (NSOKButton ==  NSRunInformationalAlertPanel(
                NSLocalizedStringFromTableInBundle(@"iTeXMac Render Project", @"Project",
                        [NSBundle bundleForClass: [self class]], "Panel title"),
                    NSLocalizedStringFromTableInBundle(@"Please confirm save operation.", @"Project",
                            [NSBundle bundleForClass: [self class]], "Save is a critical operation."),
                        nil,
                            NSLocalizedStringFromTableInBundle(@"Cancel", @"Project",
                                    [NSBundle bundleForClass: [self class]], "Title of Cancel button"),
                                nil))))
    	return [super writeToFile: fileName ofType: type];
    else
        return NO;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMVirtualProject

