/*
//  iTMGenericProjectsManager.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Dec 01 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSObjCRuntime.h>
#import <Foundation/NSString.h>
#import <Foundation/NSPathUtilities.h>
#import <Foundation/Foundation.h>
#import <Foundation/NSArray.h>
#import <Foundation/NSDictionary.h>
#import <Foundation/Foundation.h>
#import <AppKit/NSCell.h>
#import <AppKit/NSApplication.h>
#import <AppKit/AppKit.h>
#import <AppKit/NSCell.h>
#import "iTMGenericProjectsManager.h"
#import "iTMResourcesController(GenericProjects).h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMGenericProjectsManager
/*"Description forthcoming."*/
@implementation iTMGenericProjectsManager
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customizeGenericProjects:
+ (void) customizeGenericProjects: (id) irrelevant;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [NSApp runModalForWindow:
        [[[[self alloc] initWithWindowNibName: NSStringFromClass([self class])] autorelease] window]];
    return;
}
#define iTMCLEANSETTER(outlet, value) [self->outlet autorelease];outlet = [value mutableCopy]
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= initWithWindowNibName
- (id) initWithWindowNibName: (NSString *) aName;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    self = [super initWithWindowNibName: aName];
    iTMCLEANSETTER(_GenericProjects, [self genericProjectsFromLibrary]);
    iTMCLEANSETTER(_HiddenGenericProjects, [self hiddenGenericProjectsFromLibrary]);
    iTMCLEANSETTER(_AllGenericProjects, [self allGenericProjectsFromLibrary]);
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= dealloc
- (void) dealloc;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self->_GenericProjects autorelease];
    self->_GenericProjects = nil;
    [self->_HiddenGenericProjects autorelease];
    self->_HiddenGenericProjects = nil;
    [self->_AllGenericProjects autorelease];
    self->_AllGenericProjects = nil;
    [self setTableView: nil];
    [super dealloc];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericProjectOK:
- (void) genericProjectOK: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [NSApp stopModalWithCode: NSOKButton];
    [[sender window] orderOut: self];
    {
        NSString * usedPath = [[iTMResourcesController sharedResourcesController] genericProjectsPath];
        NSString * hiddenPath = [[iTMResourcesController sharedResourcesController] hiddenGenericProjectsPath];
        NSFileWrapper * usedWrapper = [[NSFileWrapper alloc] initWithPath: usedPath];
        NSFileWrapper * hiddenWrapper = [[NSFileWrapper alloc] initWithPath: hiddenPath];
        NSEnumerator * enumerator = [self->_GenericProjects objectEnumerator];
    //            [[[NSFileManager defaultManager] directoryContentsAtPath: source] objectEnumerator];
        NSString * path;
        if(!hiddenWrapper)
            hiddenWrapper = [[NSFileWrapper alloc] initDirectoryWithFileWrappers: nil];
        while(path = [enumerator nextObject])
        {
            NSString * key = [path lastPathComponent];
            if(![[usedWrapper fileWrappers] objectForKey: key])
            {
                NSFileWrapper * FW = [[hiddenWrapper fileWrappers] objectForKey: key];
                if(FW)
                {
                    [usedWrapper addFileWrapper: FW];
                    [usedWrapper writeToFile: usedPath atomically: YES updateFilenames: YES];
                    [hiddenWrapper removeFileWrapper: FW];
                }
            }
        }
        enumerator = [self->_HiddenGenericProjects objectEnumerator];
        while(path = [enumerator nextObject])
        {
            NSString * key = [path lastPathComponent];
            NSFileWrapper * FW = [[usedWrapper fileWrappers] objectForKey: key];
            if(FW)
            {
                [hiddenWrapper addFileWrapper: FW];
                [hiddenWrapper writeToFile: hiddenPath atomically: YES updateFilenames: YES];
                [usedWrapper removeFileWrapper: FW];
            }
        }
        [usedWrapper writeToFile: usedPath atomically: YES updateFilenames: YES];
        [hiddenWrapper writeToFile: hiddenPath atomically: YES updateFilenames: YES];
        [usedWrapper autorelease];
        [hiddenWrapper autorelease];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericProjectCancel:
- (void) genericProjectCancel: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [NSApp stopModalWithCode: NSOKButton];
    [[sender window] orderOut: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericProjectSwitch:
- (void) genericProjectSwitch: (NSTableView *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    int index = [sender clickedRow];
    id project = NSLocationInRange(index, NSMakeRange(0, [self->_AllGenericProjects count]))?
        [self->_AllGenericProjects objectAtIndex: index]: nil;
    NSAssert(project!=nil, @"Out of range...");
    if([self->_GenericProjects indexOfObject: project] == NSNotFound)
    {
        [self->_HiddenGenericProjects removeObject: project];
        [self->_GenericProjects addObject: project];
    }
    else
    {
        [self->_GenericProjects removeObject: project];
        [self->_HiddenGenericProjects addObject: project];
    }
    [sender reloadData];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericProjectReveal:
- (void) genericProjectReveal: (NSTableView *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    int index = [sender clickedRow];
    id project = NSLocationInRange(index, NSMakeRange(0, [self->_AllGenericProjects count]))?
        [self->_AllGenericProjects objectAtIndex: index]: nil;
    NSAssert(project!=nil, @"Out of range...");
//    NSLog(@"genericProjectReveal %@", project);
    [[NSWorkspace sharedWorkspace] selectFile: [project stringByDeletingLastPathComponent]
        inFileViewerRootedAtPath: [project stringByDeletingLastPathComponent]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= setTableView:
- (void) setTableView: (NSTableView *) argument;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(argument && ![argument isKindOfClass: [NSTableView class]])
        [NSException raise: NSInvalidArgumentException format: @"-[%@ %@] NSTableView argument expected: %@.",
            [self class], NSStringFromSelector(_cmd), argument];
    {
        [_TableView autorelease];
        _TableView = [argument retain];
        if(_TableView)
        {
            NSTableColumn * TC = [_TableView numberOfColumns]? [[_TableView tableColumns] objectAtIndex: 0]: nil;
            if(TC)
            {
                NSButtonCell * BC = [[[NSButtonCell alloc] init] autorelease];
                [BC setButtonType: NSSwitchButton];
                [BC setShowsStateBy: NSContentsCellMask];
                [BC setBordered: NO];
                [BC setBezeled: NO];
                [BC setTarget: self];
                [BC setAction: @selector(genericProjectSwitch:)];
                [TC setDataCell: BC];
                [_TableView setDataSource: self];
                [_TableView setDelegate: self];
                [_TableView setTarget: self];
                [_TableView setDoubleAction: @selector(genericProjectReveal:)];
            }
            else
                NSLog(@"Sot Riz, No tabeule colle Hum nez.");
        }
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= tableView
- (id) tableView;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return _TableView;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= numberOfRowsInTableView:
- (int) numberOfRowsInTableView: (NSTableView *) tableView;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [self->_AllGenericProjects count];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= tableView:objectValueForTableColumn:row:
- (id) tableView: (NSTableView *) tableView objectValueForTableColumn: (NSTableColumn *) tableColumn row: (int) row;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return NSLocationInRange(row, NSMakeRange(0, [self->_AllGenericProjects count])) &&
            [[tableColumn identifier] isEqualToString: @"Name"]?
                [[[self->_AllGenericProjects objectAtIndex: row] lastPathComponent] stringByDeletingPathExtension]:
                nil;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= tableView:willDisplayCell:forTableColumn:row:
- (void) tableView: (NSTableView *) tableView willDisplayCell: (id) cell forTableColumn: (NSTableColumn *) tableColumn row: (int) row;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(NSLocationInRange(row, NSMakeRange(0, [self->_AllGenericProjects count])) &&
            [[tableColumn identifier] isEqualToString: @"Box"])
    {
        id project = [self->_AllGenericProjects objectAtIndex: row];
        int index = [self->_GenericProjects indexOfObject: project];
        [cell setState: (index != NSNotFound? NSOnState: NSOffState)];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericProjectsFromLibrary
- (NSArray *) genericProjectsFromLibrary;
/*"Description forthcoming. Subclassing iTMProjectDocument will cause problems here (correspondance type<->classe).
Ask cocoa-dev.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: Do not use the info.plist facilities.
"*/
{
    NSMutableArray * MA = [NSMutableArray array];
    NSEnumerator * enumerator = [[[iTMResourcesController sharedResourcesController] genericProjects] objectEnumerator];
    NSString * path;
    while(path = [enumerator nextObject])
        if([path isKindOfClass: [NSString class]] && [[path pathExtension] isEqualToString: @"pTeXMac"])
                [MA addObject: path];
    return [MA sortedArrayUsingSelector: @selector(compare:)];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= hiddenGenericProjectsFromLibrary
- (NSArray *) hiddenGenericProjectsFromLibrary;
/*"Description forthcoming. Subclassing iTMProjectDocument will cause problems here. Ask cocoa-dev.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: Do not use the info.plist facilities.
"*/
{
    NSMutableArray * MA = [NSMutableArray array];
    NSEnumerator * enumerator = [[[iTMResourcesController sharedResourcesController] hiddenGenericProjects] objectEnumerator];
    NSString * path;
    while(path = [enumerator nextObject])
        if([path isKindOfClass: [NSString class]] && [[path pathExtension] isEqualToString: @"pTeXMac"])
                [MA addObject: path];
    return [MA sortedArrayUsingSelector: @selector(compare:)];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= allGenericProjectsFromLibrary
- (NSArray *) allGenericProjectsFromLibrary;
/*"Description forthcoming. Subclassing iTMProjectDocument will cause problems here. Ask cocoa-dev.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSMutableArray * MA = [[[self genericProjectsFromLibrary] mutableCopy] autorelease];
    [MA addObjectsFromArray: [self hiddenGenericProjectsFromLibrary]];
    return [MA sortedArrayUsingSelector: @selector(compareLastPathComponents:)];
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMGenericProjectsManager

