/*
//  iTMHelpersController.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Dec 22 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMHelpersController.h"
#import "iTMStatusNotification.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMHelpersController
/*"Description forthcoming."*/
@implementation iTMHelpersController
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  auxiliaryExecutablesPath
+ (NSString *) auxiliaryExecutablesPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    #warning not the same for a framework and an app bundle
    return [[[NSBundle bundleForClass: [self class]] executablePath] stringByDeletingLastPathComponent];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  pathForAuxiliaryExecutable
+ (NSString *) pathForAuxiliaryExecutable: (NSString *) argument;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    static BOOL firstTimeError = YES;
    NSString * result = [[NSBundle bundleForClass: [self class]] pathForAuxiliaryExecutable: argument];
    if(![result length])
        result = [[NSBundle bundleForClass: [self class]] pathForResource: argument ofType: nil];
    if(![result length])
        if(firstTimeError)
        {
            NSRunCriticalAlertPanel(
                NSLocalizedStringFromTableInBundle(@"iTeXMac Installation Problem",
                            @"Project", [NSBundle bundleForClass: [self class]], "Panel Title"),
                NSLocalizedStringFromTableInBundle(@"No auxiliary executable for: %@",
                            @"Project", [NSBundle bundleForClass: [self class]], "status info format, 1%@"),
                nil, nil, nil, argument);
            firstTimeError = NO;
        }
        else
        {
            [[iTMStatusNotificationCenter defaultCenter] postNotificationWithStatus:
                [NSString stringWithFormat: NSLocalizedStringFromTableInBundle(@"No auxiliary executable for: %@",
                            @"Project", [NSBundle bundleForClass: [self class]], "status info format, 1%@"), argument]];
        }
    return result;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  compileMakerPath
+ (NSString *) compileMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"compileMaker"];
}
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  compileMakerPath
+ (NSString *) compileMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"compileMaker"];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  typesetMakerPath
+ (NSString *) typesetMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"typesetMaker"];
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  typesetMakerPath
+ (NSString *) typesetMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"typesetMaker"];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  pathMakerPath
+ (NSString *) pathMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"pathMaker"];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  bibliographyMakerPath
+ (NSString *) bibliographyMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"bibliographyMaker"];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  indexMakerPath
+ (NSString *) indexMakerPath;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr 
- 1: 09/02/2001
To Do List:
"*/
{
    return [self pathForAuxiliaryExecutable: @"indexMaker"];
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMHelpersController

