/*
//  iTMProjectDocument(Action).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Oct 02 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: jerome.laurens@u-bourgogne.fr(format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSString.h>
#import "NSView(iTeXMac).h"
#import "iTMProjectDocument.h"
#import "iTMProjectDocument(Action).h"
#import "iTMProjectDocument(Accessors).h"
//#import "iTMResourcesController.h"
#import "iTMProjectWindowController.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Action)
/*"Description forthcoming."*/
@implementation iTMProjectDocument(Action)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= fileView =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= genericChecked:
- (IBAction) genericChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: IMEPLEMENT THE UNDO
"*/
{
    if ([sender state] != NSOffState)
        [self becomeGeneric];
    else
        [self becomeNormal];
    [self validateUserInterface];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateGenericChecked:
- (void) validateGenericChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: IMEPLEMENT THE UNDO
"*/
{
    [sender setState: ([self isGeneric]? NSOnState: NSOffState)];
    [sender setEnabled: ![self isStrongGeneric] && ![self isVoid]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= rootEdited:
- (IBAction) rootEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if([self isAbsolute])
        [self setAbsoluteInput: [sender stringValue] smart: YES];
    else
        [self setRelativeInput: [sender stringValue] smart: YES];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRootEdited:
- (IBAction) validateRootEdited: (NSControl *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSString * string = [self isAbsolute]? [self absoluteInput]: [self relativeInput];
    if(![[sender stringValue] isEqualToString: string]) [sender setStringValue: string];
    [sender setEnabled: YES];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  chooseOneFileForWindow:withDidEndSelector:
- (IBAction) chooseOneFileForWindow: (NSWindow *) window withDidEndSelector: (SEL) aSelector;
/*"Action by a button. Opens a panel to choose a root file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSOpenPanel * OP = [NSOpenPanel openPanel];
    [OP setCanChooseDirectories: NO];
    [OP setCanChooseFiles: YES];
    [OP setAllowsMultipleSelection: NO];
    [OP setResolvesAliases: YES];
    [OP setTreatsFilePackagesAsDirectories: NO];
    [[[OP contentView] viewWithTag: NSFileHandlingPanelOKButton]
                setTitle: NSLocalizedStringFromTableInBundle(@"Choose", @"Project",
                                    [NSBundle bundleForClass: [self class]], "Title of button")];
    [OP beginSheetForDirectory: [NSHomeDirectory() stringByAppendingPathComponent: @"Documents"]
        file: @""
            types: nil//.fmt files
                modalForWindow: window
                    modalDelegate: self
                        didEndSelector: aSelector
                            contextInfo: nil];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseRoot:
- (IBAction) chooseRoot: (id) sender;
/*"Action by a button. Opens a panel to choose a root file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self chooseOneFileForWindow: [sender window] withDidEndSelector: @selector(_didChooseRoot:returnCode:irrelevant:)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  _didChooseRoot:returnCode:irrelevant:
- (void) _didChooseRoot: (NSOpenPanel *) sheet returnCode: (int) returnCode irrelevant: (void *) arg;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/

{
    if ((returnCode == NSOKButton) && ([[sheet filenames] count] == 1))
    {
        [self becomeNormal];
        [self setAbsoluteInput: [[sheet filenames] objectAtIndex: 0]];
        [self validateUserInterface];
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChooseRoot:
- (void) validateChooseRoot: (id) sender;
/*"Action by a button. Opens a panel to choose a root file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: YES];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= relativeAbsolute:
- (IBAction) relativeAbsolute: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setAbsolute: ([[sender selectedCell] tag]!=0)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRelativeAbsolute:
- (IBAction) validateRelativeAbsolute: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender selectCellWithTag: ([self isAbsolute]? 1: 0)];
    [sender setEnabled: (![self isGeneric]&&[[self fileName] length] && [[self absoluteInput] length])];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customIdentChecked:
- (IBAction) customIdentChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setCustomIdent: ([sender state] != NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomIdentChecked:
- (void) validateCustomIdentChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setState: ([self isVoid]? NSOffState: ([self isCustomIdent]? NSOnState: NSOffState))];
    [sender setEnabled: YES];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= outputIdentEdited:
- (IBAction) outputIdentEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setString: [sender stringValue] forKey: iTMPDCustomIdentifierKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateOutputIdentEdited:
- (IBAction) validateOutputIdentEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [self stringForKey: iTMPDCustomIdentifierKey]];
    [sender setEnabled: [self isCustomIdent]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customCompileChecked:
- (IBAction) customCompileChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setCustomCompile: ([sender state] != NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomCompileChecked:
- (IBAction) validateCustomCompileChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: YES];
    [sender setState: ([self isCustomCompile]? NSOnState: NSOffState)];
//    [[[self windowController] window] makeFirstResponder: [[self windowController] compileTextView]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  customCompileEdited:
- (IBAction) customCompileEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setString: [sender stringValue] forKey: iTMPDCompileScriptKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateCustomCompileEdited:
- (void) validateCustomCompileEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
//    NSLog(@"validateCustomCompileEdited: <%@>", [self stringForKey: iTMPDCompileScriptKey]);
    [sender setStringValue: [self stringForKey: iTMPDCompileScriptKey]];
    [sender setEnabled: [self isCustomCompile]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customTypesetChecked:
- (IBAction) customTypesetChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setCustomTypeset: ([sender state] != NSOffState)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCustomTypesetChecked:
- (IBAction) validateCustomTypesetChecked: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: ![self isVoid]];
    [sender setState: ([self isCustomTypeset]? NSOnState: NSOffState)];
    [[[self windowController] typesetTextView] setEditable: [self isCustomTypeset]];
    [[[self windowController] window] makeFirstResponder: [[self windowController] typesetTextView]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= compileActionChecked()
#define compileActionChecked(action, key)\
- (IBAction) action: (id) sender;\
{[self setBool: ([sender state] != NSOffState) forKey: key];[sender setEnabled: ![self isCustomCompile]];return;}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= compileSilentlyChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= keepsDVIChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= keepsPSChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= mlTeXChecked:
compileActionChecked(compileSilentlyChecked, iTMPDCompileSilentlyKey);
compileActionChecked(keepsDVIChecked, iTMPDKeepsDVIKey);
compileActionChecked(keepsPSChecked, iTMPDKeepsPSKey);
compileActionChecked(mlTeXChecked, iTMPDMLTeXKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= interactionSelected:
- (IBAction) interactionSelected: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setString: [[sender selectedItem] title] forKey: iTMPDInteractionKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateInteractionSelected:
- (void) validateInteractionSelected: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/
{
    [sender setEnabled: NO];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChecked()
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCompileSilentlyChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateKeepsDVIChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateKeepsPSChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMlTeXChecked:
#define validateChecked(action, key)\
- (void) action: (id) sender;\
{int state = [self boolForKey: key]? NSOnState: NSOffState;[sender setState: state];\
[sender setEnabled: ![self isCustomCompile]];return;}
validateChecked(validateCompileSilentlyChecked, iTMPDCompileSilentlyKey);
validateChecked(validateKeepsDVIChecked, iTMPDKeepsDVIKey);
validateChecked(validateKeepsPSChecked, iTMPDKeepsPSKey);
validateChecked(validateMlTeXChecked, iTMPDMLTeXKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseEngine:
- (IBAction) chooseEngine: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseFormat:
- (IBAction) chooseFormat: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseBase:
- (IBAction) chooseBase: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChoose()
#define validateChoose(validate)\
- (void) validate: (id) sender;{[sender setEnabled: NO];return;}
validateChoose(validateChooseEngine);
validateChoose(validateChooseFormat);
validateChoose(validateChooseBase);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= actionEdited()
#define actionEdited(edited, key)\
- (void) edited: (id) sender;{[self setString: [sender stringValue] forKey: key];return;}
actionEdited(engineEdited, iTMPDCompileEngineKey);
actionEdited(formatEdited, iTMPDCompileFormatKey);
actionEdited(baseEdited, iTMPDCompileBaseKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateEngineEdited:
- (void) validateEngineEdited: (NSComboBox *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [self stringForKey: iTMPDCompileEngineKey]];
    [sender setEnabled: ![self isCustomCompile]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateFormatEdited:
- (void) validateFormatEdited: (NSComboBox *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender reloadData];
    [sender setStringValue: [self stringForKey: iTMPDCompileFormatKey]];
    [sender setEnabled: ![self isCustomCompile]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateBaseEdited:
- (void) validateBaseEdited: (NSComboBox *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender reloadData];
    [sender setStringValue: [self stringForKey: iTMPDCompileBaseKey]];
    [sender setEnabled: ![self isCustomCompile]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= actionChecked()
#define actionChecked(action, validateAction, key)\
- (IBAction) action: (id) sender;{[self setBool: ([sender state] != NSOffState) forKey: key];return;}\
- (IBAction) validateAction: (id) sender;\
{\
    int state = [self boolForKey: key]? NSOnState: NSOffState;\
    [sender setState: state];\
    return;\
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= bibTeXView: =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= bibTeXSilentlyChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateBibTeXSilentlyChecked:
actionChecked(bibTeXSilentlyChecked, validateBibTeXSilentlyChecked, iTMPDBibTeXSilentlyKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= minXReferencesChosen:
- (void) minXReferencesChosen: (NSTextField *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: 
"*/
{
    [self setString: [sender stringValue] forKey: iTMPDBMinXReferencesKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMinXReferencesChosen:
- (void) validateMinXReferencesChosen: (NSTextField *) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: 
"*/
{
    [sender setIntValue: [[self stringForKey: iTMPDBMinXReferencesKey] intValue]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= bibTeXSilentlyChecked:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMakeIndexSilentlyChecked:
actionChecked(makeIndexSilentlyChecked, validateMakeIndexSilentlyChecked, iTMPDIndexSilentlyKey);
actionChecked(compressBlankChecked, validateCompressBlankChecked, iTMPDICompressBlankKey);
actionChecked(germanOrderingChecked, validateGermanOrderingChecked, iTMPDIGermanOrderingKey);
actionChecked(letterOrderingChecked, validateLetterOrderingChecked, iTMPDILetterOrderingKey);
actionChecked(noImplicitRangeChecked, validateNoImplicitRangeChecked, iTMPDINoImplicitRangeKey);
actionChecked(indexStyleChecked, validateIndexStyleChecked, iTMPDUseIndexStyleKey);
actionChecked(indexOutputChecked, validateIndexOutputChecked, iTMPDUseIndexOutputKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseIndexOutput:
- (IBAction) chooseIndexOutput: (id) sender;
/*"Action by a button. Opens a panel to choose a root file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self chooseOneFileForWindow: [sender window] withDidEndSelector: @selector(_didChooseIndexOutput:returnCode:irrelevant:)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  _didChooseIndexOutput:returnCode:irrelevant:
- (void) _didChooseIndexOutput: (NSOpenPanel *) sheet returnCode: (int) returnCode irrelevant: (void *) arg;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/

{
    if ((returnCode == NSOKButton) && ([[sheet filenames] count] == 1))
        [self setString: [[sheet filenames] objectAtIndex: 0] forKey: iTMPDIndexOutputKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChooseIndexOutput:
- (IBAction) validateChooseIndexOutput: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: [self boolForKey: iTMPDUseIndexOutputKey]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= chooseIndexStyle:
- (IBAction) chooseIndexStyle: (id) sender;
/*"Action by a button. Opens a panel to choose a file.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self chooseOneFileForWindow: [sender window] withDidEndSelector: @selector(_didChooseIndexStyle:returnCode:irrelevant:)];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  _didChooseIndexStyle:returnCode:irrelevant:
- (void) _didChooseIndexStyle: (NSOpenPanel *) sheet returnCode: (int) returnCode irrelevant: (void *) arg;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: NYI
"*/

{
    if ((returnCode == NSOKButton) && ([[sheet filenames] count] == 1))
        [self setString: [[sheet filenames] objectAtIndex: 0] forKey: iTMPDIndexStyleKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateChooseIndexStyle:
- (IBAction) validateChooseIndexStyle: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setEnabled: [self boolForKey: iTMPDUseIndexStyleKey]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= indexStyleEdited
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= indexOutputEdited
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= indexStartingEdited
actionEdited(indexStyleEdited, iTMPDIndexStyleKey);
actionEdited(indexOutputEdited, iTMPDIndexOutputKey);
actionEdited(indexStartingEdited, iTMPDIndexStartingKey);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateIndexStyleEdited:
- (IBAction) validateIndexStyleEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [self stringForKey: iTMPDIndexStyleKey]];
    [sender setEnabled: [self boolForKey: iTMPDUseIndexStyleKey]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateIndexOutputEdited:
- (IBAction) validateIndexOutputEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [sender setStringValue: [self stringForKey: iTMPDIndexOutputKey]];
    [sender setEnabled: [self boolForKey: iTMPDUseIndexOutputKey]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateIndexStartingEdited:
- (IBAction) validateIndexStartingEdited: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    int indexStartingValue = [[self stringForKey: iTMPDIndexStartingKey] intValue];
    [sender setEnabled: (indexStartingValue>0)];
    [sender setIntValue: indexStartingValue];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= indexStartingChosen:
- (IBAction) indexStartingChosen: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSString * option;
    switch([sender indexOfSelectedItem])
    {
        case 0:
            option = @"any";
            break;
        case 1:
            option = @"odd";
            break;
        case 2:
            option = @"even";
            break;
        default:
            option = [NSString stringWithFormat: @"%d", MAX([[self stringForKey: iTMPDIndexStartingKey] intValue], 1)];
            break;
    }
    [self setString: option forKey: iTMPDIndexStartingKey];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateIndexStartingChosen:
- (IBAction) validateIndexStartingChosen: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSString * option = [self stringForKey: iTMPDIndexStartingKey];
    int index = 3;
    if([option isEqualToString: @"any"])
        index = 0;
    else if([option isEqualToString: @"odd"])
        index = 1;
    else if([option isEqualToString: @"even"])
        index = 2;
    [sender selectItemAtIndex: index];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= MACROSEDITED(selector, key) :
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosDocEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosGfxEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosMathEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosMiscEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosTextEdited:
#define MACROSEDITED(selector, key) - (void) selector: (id) sender;\
{[self setString: [sender stringValue] forKey: key];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
MACROSEDITED(macrosDocEdited,iTMPDMacrosPathDocKey)
MACROSEDITED(macrosGfxEdited,iTMPDMacrosPathGfxKey)
MACROSEDITED(macrosMathEdited,iTMPDMacrosPathMathKey)
MACROSEDITED(macrosMiscEdited,iTMPDMacrosPathMiscKey)
MACROSEDITED(macrosTextEdited,iTMPDMacrosPathTextKey)
MACROSEDITED(macrosTmplEdited,iTMPDMacrosPathTmplKey)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= VALIDATEMACROSEDITED(selector, key) :
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMacrosDocEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMacrosGfxEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMacrosMathEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMacrosMiscEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateMacrosTextEdited:
#define VALIDATEMACROSEDITED(selector, key) - (void) selector: (id) sender;\
{NSString * string = [self stringForKey: key];[sender setObjectValue: string];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
VALIDATEMACROSEDITED(validateMacrosDocEdited,iTMPDMacrosPathDocKey)
VALIDATEMACROSEDITED(validateMacrosGfxEdited,iTMPDMacrosPathGfxKey)
VALIDATEMACROSEDITED(validateMacrosMathEdited,iTMPDMacrosPathMathKey)
VALIDATEMACROSEDITED(validateMacrosMiscEdited,iTMPDMacrosPathMiscKey)
VALIDATEMACROSEDITED(validateMacrosTextEdited,iTMPDMacrosPathTextKey)
VALIDATEMACROSEDITED(validateMacrosTmplEdited,iTMPDMacrosPathTmplKey)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= RENDEREDITED(selector, key) :
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= renderDVIEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= renderPSEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= renderEPSEdited:
#define RENDEREDITED(selector, key) - (void) selector: (id) sender;\
{[self setString: [sender stringValue] forKey: key];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
RENDEREDITED(renderDVIEdited,iTMPDRenderDVIKey)
RENDEREDITED(renderPSEdited,iTMPDRenderPSKey)
RENDEREDITED(renderEPSEdited,iTMPDRenderEPSKey)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= VALIDATERENDEREDITED(selector, key) :
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRenderDVIEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRenderEPSEdited:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateRenderPSEdited:
#define VALIDATERENDEREDITED(selector, key) - (void) selector: (id) sender;\
{[sender setObjectValue: [self stringForKey: key]];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
VALIDATERENDEREDITED(validateRenderDVIEdited,iTMPDRenderDVIKey)
VALIDATERENDEREDITED(validateRenderEPSEdited,iTMPDRenderEPSKey)
VALIDATERENDEREDITED(validateRenderPSEdited,iTMPDRenderPSKey)
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Action)

