/*
//  iTMProjectDocument(Navigation).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr (11/28/2001) on Thu Oct 04 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "NSControl(iTeXMac).h"
#import "iTMProjectDocument.h"
#import "iTMProjectDocument(Navigation).h"
#import "iTMProjectDocument(Accessors).h"
#import "iTMProjectWindowController.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Navigation)
/*"Description forthcoming."*/
@implementation iTMProjectDocument(Navigation)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= fileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customCompileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= builtInCompileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= customTypesetView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= builtInTypesetView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= helpersView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= bibTeXView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= makeIndexView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= macrosView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= renderView:
#define selectProjectTabView(selectAction, itemIdentifier)\
- (IBAction) selectAction: (id) sender;\
{\
    [self reallyMakeWindowControllers];\
    [self makeWindows];\
    [[self windowController] switchToPaneWithIdentifier: itemIdentifier];\
    [self validateUserInterface];\
    [self showWindows];\
    return;\
}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr (11/28/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
selectProjectTabView(fileView, iTMPWCInputIdentifier);
selectProjectTabView(builtInCompileView, iTMPWCBuiltInCompileIdentifier);
selectProjectTabView(builtInTypesetView, iTMPWCBuiltInTypesetIdentifier);
selectProjectTabView(helpersView, iTMPWCBibTeXIdentifier);
selectProjectTabView(bibTeXView, iTMPWCBibTeXIdentifier);
selectProjectTabView(makeIndexView, iTMPWCMakeIndexIdentifier);
selectProjectTabView(macrosView, iTMPWCMacrosIdentifier);
selectProjectTabView(renderView, iTMPWCRenderIdentifier);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  customCompileView:
- (IBAction) customCompileView: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr (11/28/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self reallyMakeWindowControllers];
    [self makeWindows];
    [[self windowController] switchToPaneWithIdentifier: iTMPWCCustomCompileIdentifier];
    [self readInputHeader];
    [self validateUserInterface];
    [self showWindows];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  customTypesetView:
- (IBAction) customTypesetView: (id) sender;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr (11/28/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self reallyMakeWindowControllers];
    [self makeWindows];
    [[self windowController] switchToPaneWithIdentifier: iTMPWCCustomTypesetIdentifier];
    [self readInputHeader];
    [[[self windowController] typesetTextView] setString: [self stringForKey: iTMPDTypesetScriptKey]];
    [self validateUserInterface];
    [self showWindows];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= compileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= typesetView:
- (IBAction) compileView: (id) sender;{[self customCompileView: sender];return;}
- (IBAction) typesetView: (id) sender;{[self customTypesetView: sender];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr (11/28/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateView()
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateFileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateCompileView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateTypesetView:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= validateHelpersView:
#define validateView(validate, identifier)\
- (IBAction) validate: (id) sender;\
{[sender setEnabled: ![[self windowController] alreadySwitchedToPaneWithIdentifier: identifier]];return;}
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr (11/28/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
validateView(validateFileView, iTMPWCInputIdentifier);
validateView(validateMacrosView, iTMPWCMacrosIdentifier);
validateView(validateRenderView, iTMPWCRenderIdentifier);
validateView(validateCompileView, iTMPWCCompileIdentifier);
validateView(validateTypesetView, iTMPWCTypesetIdentifier);
validateView(validateHelpersView, iTMPWCHelpersIdentifier);
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMProjectDocument(Navigation)

