/*
//  iTMProjectWindow.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Mon Mar 25 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "NSWindow(iTeXMac).h"
#import "iTMProjectWindow.h"
#import "iTMWindowsObserver.h"
#import "iTMSettings.h"


//  iTMProjectWindow
/*"Description forthcoming."*/
@implementation iTMProjectWindow
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= initialize
+ (void) initialize;
/*"Sends an #{+initialize} to the iTMWindowsObserver class object. See the NSWindow category Observer.
Version History: jerome.laurens@u-bourgogne.fr (07/12/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super initialize];
    [iTMWindowsObserver initialize];
    [[NSUserDefaults standardUserDefaults] registerDefaults: [NSDictionary dictionaryWithObjectsAndKeys: 
                [NSNumber numberWithInt: iTMWindowFrameFixedMode], [iTMProjectWindow frameAutosaveModeKey],
                            nil]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= frameIdentifier
+ (NSString *) frameIdentifier;
/*"Related to the observation of the window position, see the NSWindow category Position.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    return @"Project Window";// return a hard string to allow subclassing
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= shouldBeObserved
+ (BOOL) shouldBeObserved;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
@end

//  iTMProjectWindow

