/*
//  iTMTeXDocument(Navigation).h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Aug 30 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMTeXDocument.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(Navigation)

@interface iTMTeXDocument(Navigation)
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
//- (void) fixNavigationMenusNotified: (NSNotification *) aNotification;
- (void) markButton: (id) sender;
- (void) validateMarkButton: (id) sender;
- (void) scrollTaggedToVisible: (id <NSMenuItem>) sender;
- (void) scrollIncludeToVisible: (id <NSMenuItem>) sender;
- (void) scrollInputToVisible: (id <NSMenuItem>) sender;
- (void) sectionButton: (id) sender;
- (void) validateSectionButton: (id) sender;
- (void) scrollToPreviousError: (id) sender;
- (void) scrollToNextError: (id) sender;
/*"Overriden methods"*/
@end

@interface NSInvocation(iTMTeXDocumentNavigation)
+ (void) delayInvocationWithTarget: (id) target action: (SEL) action sender: (id) sender
untilNotificationWithName: (NSString *) name isPostedFromObject: (id) object;
- (void) invokeNotified: (NSNotification *) aNotification;
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(Navigation)
