/*
//  iTMTeXDocument.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Dec 18 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSString.h>
#import <AppKit/NSDocument.h>

extern NSString * const iTMTeXDocumentType;
extern NSString * const iTMTextDocumentType;

extern NSString * const iTMUDKeepBackupFileKey;
extern NSString * const iTMUDLevelsOfUndoKey;

extern NSString * const iTMStatusNotification;
extern NSString * const iTMStatusKey;

@class iTMTextStorage;

@interface iTMTeXDocument : NSDocument 
{
    iTMTextStorage * _TextStorage;/*" holds the content of the tex document"*/
    id _SourceWC;		/*"source window controller."*/
    NSDictionary * _FileAttributes;
    id _Private1;
    id _Settings;
    struct __iTMTDFlags
    {
        unsigned int keepBackupFile: 1;
        unsigned int reserved: 31;
    } _iTMTDFlags;
}
/*"Public methods"*/
/*"Setters and Getters"*/
- (BOOL) isTeXDocument;
- (id) fileAttributes;
- (void) setFileAttributes: (NSDictionary *) argument;
- (id) cachedProject;
- (void) setCachedProject: (id) argument;
- (id) textStorage;
- (void) setTextStorage: (NSTextStorage *) argument;
- (id) sourceWindow;
- (id) sourceWC;
- (void) setSourceWC: (id) aWC;
- (id) textView;
- (unsigned int) lineEndingsUsed;
- (NSStringEncoding) stringEncoding;
- (void) setStringEncoding: (NSStringEncoding) argument;
- (BOOL) canSetStringEncoding;
/*"Main methods"*/
- (void) cleanCachedData;
- (void) userDefaultsDidChange: (NSNotification *) aNotification;
/*"Overriden methods"*/
@end





