/*
//  iTMTeXDocument(Navigation).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Aug 30 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSString.h>
#import <Foundation/NSThread.h>
#import <Foundation/Foundation.h>
#import "iTMTeXDocument(Navigation).h"
#import "iTMTeXWindowController.h"
#import "iTMTeXWindowController(Action).h"
#import "iTMListMenu.h"
#import "iTMLiteScanner.h"
#import "NSString(iTeXMac).h"
#import "NSMenu(iTeXMac).h"
#import "iTMProjectsManager.h"
#import "iTMProjectDocument.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(Navigation)
/*"Description forthcoming. This should live in a separate controller (caching info is needed)."*/
@implementation iTMTeXDocument(Navigation)
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  fixNavigationMenusInThread:
- (void) fixNavigationMenusInThread: (id) aSender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    [self validateMarkButton: [[self sourceWC] markButton]];
    [self validateSectionButton: [[self sourceWC] sectionButton]];
    NSLog(@"exiting my thread xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");
    [pool release];
//    [NSThread exit];
    NSLog(@"exiting my thread xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");
    return;
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  BUTTON()
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  markButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  sectionButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  labelButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  gfxButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  mathButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  miscButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  textButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  tmplButton:
#define BUTTON(selector) - (void) selector: (id) sender;{return;}
/*"This is for validation process: the mark button will ask its target for the #{validateMarkButton:} below...
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
BUTTON(markButton);
BUTTON(sectionButton);
BUTTON(labelButton);
BUTTON(docButton);
BUTTON(gfxButton);
BUTTON(mathButton);
BUTTON(miscButton);
BUTTON(textButton);
BUTTON(tmplButton);
#if 1
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMarkButton:
- (void) validateMarkButton: (id) sender;
/*"Description forthcoming. No consistency test.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    int tagNumber = 0;
    BOOL isCommand;
    /*" Here again we use C strings: UTF8 are not aligned..."*/
    const char * stringPtr = [[[self textView] string] lossyCString];
    const char * scanPtr = stringPtr;
    const char * max = strchr(stringPtr,'\0');
    const char * utf8Backslash = [[NSString stringWithUTF8String: "\\"] cString];
    NSString * title = [self fileName]? [[self fileName] stringByDeletingLastPathComponent]: [NSString string];
    NSMenu * markMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: title] autorelease];
    [markMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[markMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [markMenu addItemWithTitle:
            NSLocalizedStringFromTableInBundle(@"Marks:", @"TeX",
                            [NSBundle bundleForClass: [self class]], "Title of the first item of the mark menu")
                    action: NULL keyEquivalent: [NSString string]];
    [markMenu setAutoenablesItems: YES];
    while(YES)
    {
        const char * scanBackslash =  strstr(scanPtr, utf8Backslash);
        const char * scanComment = strchr(scanPtr, '%');
        while(YES)
        {
            if(!scanBackslash) scanBackslash = max;
            if(!scanComment) scanComment = max;
            if(scanComment < scanBackslash)
            {
                isCommand = NO;
                break;
            }
            else if(scanBackslash < max)
            {
                scanBackslash += strlen(utf8Backslash);
                if(scanBackslash < max)
                {
                    if (*(scanBackslash) == '%')
                    {
                        ++scanBackslash;
                        scanBackslash = strstr(scanBackslash, utf8Backslash);
                        scanComment = strchr(scanBackslash, '%');
                    }
                    else if(!strncmp(scanBackslash, utf8Backslash, strlen(utf8Backslash)))
                    {
                        scanBackslash += strlen(utf8Backslash);
                        scanBackslash = strstr(scanBackslash, utf8Backslash);
                    }
                    else
                    {
                        isCommand = YES;
                        break;
                    }
                }
                else
                {
                    isCommand = YES;
                    break;
                }
            }
            else
            {
                isCommand = YES;
                break;
            }
        }
        if(isCommand && (scanBackslash < max))
        {
            scanPtr = scanBackslash;
            if(!strncmp(scanPtr, "in", 2))
            {
                scanPtr+=2;
                if(!strncmp(scanPtr, "clude", 5))
                {
                    unsigned char bgroup = '{';//}
                    scanPtr+=5;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    if(* scanPtr == bgroup)
                    {//{
                        unsigned char egroup = '}';
                        scanPtr+=1;
                        //semi critical: read the comments here
                        scanBackslash = scanPtr;
                        scanPtr = strchr(scanPtr, egroup);
                        if(scanPtr)
                        {
                            NSString * object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                            [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                        action: @selector(scrollIncludeToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: title];
                                [MI setEnabled: ([[markMenu title] length] > 0)];
                            }
                        }
                    }
                }
                else if(!strncmp(scanPtr, "put", 3))
                {
                    scanPtr+=3;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    {
                        const char * SPACE = strchr(scanPtr, ' ');
                        const char * CR = strchr(scanPtr, '\r');
                        const char * LF = strchr(scanPtr, '\n');
                        scanBackslash = scanPtr;
                        scanPtr = SPACE? (CR? MIN(SPACE, CR): SPACE): CR;
                        scanPtr = scanPtr? (LF? MIN(LF, scanPtr): scanPtr): (LF? LF: strchr(scanPtr, '\0'));
                        {
                            NSString * object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                        action: @selector(scrollInputToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: object];
                                [MI setEnabled: ([[markMenu title] length] > 0)];
                            }
                        }
                    }
                }
            }
        }
        else if(scanComment < max)
        {
            scanPtr = ++scanComment;
            if((tagNumber<32))
            {
                while((* scanPtr == ' ')) ++scanPtr;
                if(!strncmp(scanPtr, "!", 1))
                {
                    scanPtr += 1;
                    while((* scanPtr == ' ')) ++scanPtr;
                    if(!strncasecmp(scanPtr, "itexmac", 7))
                    {
                        scanPtr += 7;
                        while((* scanPtr == ' ')) ++scanPtr;
                        if(!strncmp(scanPtr, "(", 1))//)
                        {
                            scanPtr += 1;
                            while((* scanPtr == ' ')) ++scanPtr;
                            if(!strncasecmp(scanPtr, "mark", 4))
                            {
                                scanPtr += 4;
                                while((* scanPtr == ' ')) ++scanPtr;//(
                                if(!strncmp(scanPtr, ")", 1))
                                {
                                    scanPtr += 1;
                                    while((* scanPtr == ' ')) ++scanPtr;
                                    if(!strncmp(scanPtr, ":", 1))
                                    {
                                        scanPtr += 1;
                                        while((* scanPtr == ' ')) ++scanPtr;
                                        {
                                            const char * CR = strchr(scanPtr, '\r');
                                            const char * LF = strchr(scanPtr, '\n');
                                            scanComment = scanPtr;
                                            scanPtr = CR? (LF? MIN(CR, LF): CR): (LF? LF: strchr(scanPtr, '\0'));
                                            {
                                                NSString * object = [[NSString stringWithCString: scanComment
                                                                length: (unsigned)(scanPtr - scanComment)]
                                                                    stringByRemovingTrailingWhites];
                                                NSString * title = ([object length] > 48)?
                                                        [NSString stringWithFormat: @"%@[...]",
                                                            [object substringWithRange: NSMakeRange(0,43)]]: object;
                                                if([title length] == 0)
                                                    title = @"...";
                                                {
                                                    NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                                            action: @selector(scrollTaggedToVisible:)
                                                                                keyEquivalent: [NSString string]];
                                                    [MI setTag: scanComment - stringPtr];
                                                    [MI setRepresentedObject: object];
                                                    ++tagNumber;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                const char * CR = strchr(scanPtr, '\r');
                const char * LF = strchr(scanPtr, '\n');
                scanPtr = CR? (LF? MIN(CR, LF): CR): (LF? LF: strchr(scanPtr, '\0'));
            }
        }
        else
            break;
    }
    [sender setMenu: markMenu];
    [sender setEnabled: YES];
    return;
}
#else
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMarkButton:
- (void) validateMarkButton: (id) sender;
/*"Description forthcoming. No consistency test.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    int tagNumber = 0;
    BOOL isCommand;
    NSString * string = [[self textView] string];
    unsigned scanLocation = 0;
    unsigned length = [string length];
    iTMLiteScanner * S = [iTMLiteScanner scannerWithString: string];// backslash scanner
    NSString * title = [self fileName]? [[self fileName] stringByDeletingLastPathComponent]: [NSString string];
    NSString * MITitle;
    NSString * bgroup = @"{";
    NSString * egroup = @"}";
    NSMenu * markMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: title] autorelease];
    [markMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[markMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [markMenu addItemWithTitle:
            NSLocalizedStringFromTableInBundle(@"Marks:", @"TeX",
                            [NSBundle bundleForClass: [self class]], "Title of the first item of the mark menu")
                    action: NULL keyEquivalent: [NSString string]];
    [markMenu setAutoenablesItems: YES];
    while([S scanString: @"\\in" intoString: nil])
    {
        if(([S scanString: @"put" intoString: nil]&&
                        [S scanCharactersFromSet: [NSCharacterSet letterCharacterSet] intoString: &title]) ||
            ([S scanString: @"clude" intoString: nil] &&
                [S scanString: bgroup intoString: nil] && [S scanUpToString: egroup intoString: &title]))
                        
        {
            title = [title stringByRemovingTrailingWhites];
            MITitle = ([title length] > 48)?
                                [NSString stringWithFormat: @"%@[...]",
                                        [MITitle substringWithRange: NSMakeRange(0,43)]]: title;
            if([MITitle length])
            {
                NSMenuItem * MI = [markMenu addItemWithTitle: MITitle
                                        action: @selector(scrollIncludeToVisible:)
                                            keyEquivalent: [NSString string]];
                [MI setTarget: self];
                [MI setRepresentedObject: title];
                [MI setEnabled: ([[markMenu title] length] > 0)];
            }
        }
    }

    /*" Here again we use C strings: UTF8 are not aligned..."*/
    
    #if 0
    
    const char * scanPtr = stringPtr;
    const char * max = strchr(stringPtr,'\0');
    const char * utf8Backslash = [[NSString stringWithUTF8String: "\\"] cString];
    while(YES)
    {
        const char * scanBackslash =  strstr(scanPtr, utf8Backslash);
        const char * scanComment = strchr(scanPtr, '%');
        while(YES)
        {
            if(!scanBackslash) scanBackslash = max;
            if(!scanComment) scanComment = max;
            if(scanComment < scanBackslash)
            {
                isCommand = NO;
                break;
            }
            else if(scanBackslash < max)
            {
                scanBackslash += strlen(utf8Backslash);
                if(scanBackslash < max)
                {
                    if (*(scanBackslash) == '%')
                    {
                        ++scanBackslash;
                        scanBackslash = strstr(scanBackslash, utf8Backslash);
                        scanComment = strchr(scanBackslash, '%');
                    }
                    else if(!strncmp(scanBackslash, utf8Backslash, strlen(utf8Backslash)))
                    {
                        scanBackslash += strlen(utf8Backslash);
                        scanBackslash = strstr(scanBackslash, utf8Backslash);
                    }
                    else
                    {
                        isCommand = YES;
                        break;
                    }
                }
                else
                {
                    isCommand = YES;
                    break;
                }
            }
            else
            {
                isCommand = YES;
                break;
            }
        }
        if(isCommand && (scanBackslash < max))
        {
            scanPtr = scanBackslash;
            if(!strncmp(scanPtr, "in", 2))
            {
                scanPtr+=2;
                if(!strncmp(scanPtr, "clude", 5))
                {
                    unsigned char bgroup = '{';//}
                    scanPtr+=5;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    if(* scanPtr == bgroup)
                    {//{
                        unsigned char egroup = '}';
                        scanPtr+=1;
                        //semi critical: read the comments here
                        scanBackslash = scanPtr;
                        scanPtr = strchr(scanPtr, egroup);
                        if(scanPtr)
                        {
                            NSString * object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                            [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                        action: @selector(scrollIncludeToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: title];
                                [MI setEnabled: ([[markMenu title] length] > 0)];
                            }
                        }
                    }
                }
                else if(!strncmp(scanPtr, "put", 3))
                {
                    scanPtr+=3;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    {
                        const char * SPACE = strchr(scanPtr, ' ');
                        const char * CR = strchr(scanPtr, '\r');
                        const char * LF = strchr(scanPtr, '\n');
                        scanBackslash = scanPtr;
                        scanPtr = SPACE? (CR? MIN(SPACE, CR): SPACE): CR;
                        scanPtr = scanPtr? (LF? MIN(LF, scanPtr): scanPtr): (LF? LF: strchr(scanPtr, '\0'));
                        {
                            NSString * object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                        action: @selector(scrollInputToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: object];
                                [MI setEnabled: ([[markMenu title] length] > 0)];
                            }
                        }
                    }
                }
            }
        }
        else if(scanComment < max)
        {
            scanPtr = ++scanComment;
            if((tagNumber<32))
            {
                while((* scanPtr == ' ')) ++scanPtr;
                if(!strncmp(scanPtr, "!", 1))
                {
                    scanPtr += 1;
                    while((* scanPtr == ' ')) ++scanPtr;
                    if(!strncasecmp(scanPtr, "itexmac", 7))
                    {
                        scanPtr += 7;
                        while((* scanPtr == ' ')) ++scanPtr;
                        if(!strncmp(scanPtr, "(", 1))//)
                        {
                            scanPtr += 1;
                            while((* scanPtr == ' ')) ++scanPtr;
                            if(!strncasecmp(scanPtr, "mark", 4))
                            {
                                scanPtr += 4;
                                while((* scanPtr == ' ')) ++scanPtr;//(
                                if(!strncmp(scanPtr, ")", 1))
                                {
                                    scanPtr += 1;
                                    while((* scanPtr == ' ')) ++scanPtr;
                                    if(!strncmp(scanPtr, ":", 1))
                                    {
                                        scanPtr += 1;
                                        while((* scanPtr == ' ')) ++scanPtr;
                                        {
                                            const char * CR = strchr(scanPtr, '\r');
                                            const char * LF = strchr(scanPtr, '\n');
                                            scanComment = scanPtr;
                                            scanPtr = CR? (LF? MIN(CR, LF): CR): (LF? LF: strchr(scanPtr, '\0'));
                                            {
                                                NSString * object = [[NSString stringWithCString: scanComment
                                                                length: (unsigned)(scanPtr - scanComment)]
                                                                    stringByRemovingTrailingWhites];
                                                NSString * title = ([object length] > 48)?
                                                        [NSString stringWithFormat: @"%@[...]",
                                                            [object substringWithRange: NSMakeRange(0,43)]]: object;
                                                if([title length] == 0)
                                                    title = @"...";
                                                {
                                                    NSMenuItem * MI = [markMenu addItemWithTitle: title
                                                                            action: @selector(scrollTaggedToVisible:)
                                                                                keyEquivalent: [NSString string]];
                                                    [MI setTag: scanComment - stringPtr];
                                                    [MI setRepresentedObject: object];
                                                    ++tagNumber;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                const char * CR = strchr(scanPtr, '\r');
                const char * LF = strchr(scanPtr, '\n');
                scanPtr = CR? (LF? MIN(CR, LF): CR): (LF? LF: strchr(scanPtr, '\0'));
            }
        }
        else
            break;
    }
    #endif
    [sender setMenu: markMenu];
    [sender setEnabled: YES];
    [pool release];
    return;
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= scrollToPreviousError:
- (void) scrollToPreviousError: (id) sender;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr (09/02/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[[iTMProjectsManager defaultManager] projectForDocument: self] showPreviousError: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= scrollToNextError:
- (void) scrollToNextError: (id) sender;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr (09/02/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[[iTMProjectsManager defaultManager] projectForDocument: self] showNextError: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  scrollLabelToVisible:
- (void) scrollLabelToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    unsigned modifierFlags = [[NSApp currentEvent] modifierFlags];
    if(modifierFlags & NSAlternateKeyMask)
    {
        iTMLiteScanner * S = [iTMLiteScanner scannerWithString: [[self textView] string]];
        NSString * string;
        [S setCharactersToBeSkipped: nil];
        [S setScanLocation: [sender tag]];
        if([S scanUpToString: //{
            @"}" intoString: &string])
            [[self textView] insertText: [NSString stringWithFormat: @"\\%@ref%@}",
                ((modifierFlags & NSShiftKeyMask)? @"eq": @""), string]];
    }
    else
        [self scrollTaggedToVisible: sender];
    return;
}
#if 1
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  scrollTaggedToVisible:
- (void) scrollTaggedToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    unsigned begin, end;
    [[[self textView] string] getLineStart: &begin end: &end contentsEnd: nil forRange: NSMakeRange([sender tag], 0)];
    [[self sourceWC] highlightAndScrollRangeToVisible: NSMakeRange(begin, end-begin)];
    return;
}
#else
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  scrollTaggedToVisible:
- (void) scrollTaggedToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    unsigned int location = 0;
    int index = 0;
    NSMenu * menu = [sender menu];
    int ceiling = [menu indexOfItem: sender];
    for(index = 0; index<=ceiling ; ++index)
        location += [[menu itemAtIndex: index] tag];
    {
        NSString * string = [[self textView] string];
        unsigned begin, end;
        [string getLineStart: &begin end: &end contentsEnd: nil forRange: NSMakeRange(location, 0)];
        [[self sourceWC] highlightAndScrollRangeToVisible: NSMakeRange(begin, end-begin)];
    }
    return;
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  notifyAllDelayedInvocations:
- (void) notifyAllDelayedInvocations: (id) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[NSNotificationCenter defaultCenter]
        postNotificationName: @"iTMTDPerformScrollIn[clude|put]ToVisible"
            object: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  scrollIncludeToVisible:
- (void) scrollIncludeToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [NSInvocation delayInvocationWithTarget: self
        action: @selector(_ScrollIncludeToVisible:)
            sender: sender
                untilNotificationWithName: @"iTMTDPerformScrollIn[clude|put]ToVisible"
                    isPostedFromObject: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  _ScrollIncludeToVisible:
- (void) _ScrollIncludeToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSString * path = [[[[sender menu] title]  stringByAppendingPathComponent:
                                [sender representedObject]] stringByStandardizingPath];
    if([[NSFileManager defaultManager] isReadableFileAtPath: path])
        [[NSDocumentController sharedDocumentController] openDocumentWithContentsOfFile: path display: YES];
    else
    {
        path = [path stringByAppendingPathExtension: @"tex"];
        if([[NSFileManager defaultManager] isReadableFileAtPath: path])
            [[NSDocumentController sharedDocumentController] openDocumentWithContentsOfFile: path display: YES];
        else
        {
            [sender setEnabled: NO];
            NSBeep();
        }
    }
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  scrollInputToVisible:
- (void) scrollInputToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [NSInvocation delayInvocationWithTarget: self
        action: @selector(_ScrollInputToVisible:)
            sender: sender
                untilNotificationWithName: @"iTMTDPerformScrollIn[clude|put]ToVisible"
                    isPostedFromObject: self];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  _ScrollInputToVisible:
- (void) _ScrollInputToVisible: (id <NSMenuItem>) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: include the tetex path...
"*/
{
    NSString * path = [[[[[sender menu] title]  stringByAppendingPathComponent:
                                [sender representedObject]] stringByResolvingSymlinksInPath] stringByStandardizingPath];
    if([[NSFileManager defaultManager] isReadableFileAtPath: path])
        [[NSDocumentController sharedDocumentController] openDocumentWithContentsOfFile: path display: YES];
    else
    {
        path = [path stringByAppendingPathExtension: @"tex"];
        if([[NSFileManager defaultManager] isReadableFileAtPath: path])
            [[NSDocumentController sharedDocumentController] openDocumentWithContentsOfFile: path display: YES];
        else
        {
            [sender setEnabled: NO];
            NSBeep();
        }
    }
    return;
}
#if 1
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateSectionButton:
- (void) validateSectionButton: (id) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
{
//    static unsigned int meter;
    const char * cString = [[[self textView] string] lossyCString];
    const char * scanPtr = cString;
    const char * backslashPtr;
    const char * egroupPtr;
    char bgroup = '{';
    char egroup = '}';
    #define partDepth 1
    #define chapterDepth 2
    #define sectionDepth 3
    #define subsectionDepth 4
    #define subsubsectionDepth 5
    #define subsubsubsectionDepth 6
    #define paragraphDepth 6
    #define subparagraphDepth 7
    #define subsubparagraphDepth 8
    #define includeDepth 9
    #define inputDepth 10
    unsigned sectionCount = 0, subsectionCount = 0, subsubsectionCount = 0;
    NSString * title = [self fileName]? [[self fileName] stringByDeletingLastPathComponent]: [NSString string];
    NSMenu * sectionMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: title] autorelease];
    [sectionMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[sectionMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [sectionMenu addItemWithTitle:
            NSLocalizedStringFromTableInBundle(@"Sections:", @"TeX",
                            [NSBundle bundleForClass: [self class]], "Title of the first item of the section menu")
                    action: NULL keyEquivalent: [NSString string]];
//    NSLog(@"validateSectionButton: index error = %d", indexError);
    while(backslashPtr = strchr(scanPtr, '\\'))
    {
        int depth = 0;
        scanPtr = backslashPtr + 1;
        if(*scanPtr == 's')
        {
            ++scanPtr;
            if(!strncmp(scanPtr, "ection", 6))
            {
                scanPtr+=6;
                depth = sectionDepth;
            }
            else if(!strncmp(scanPtr, "ub", 2))
            {
                scanPtr+=2;
                if(!strncmp(scanPtr, "section", 7))
                {
                    scanPtr+=7;
                    depth = subsectionDepth;
                }
                else if(!strncmp(scanPtr, "paragraph", 9))
                {
                    scanPtr+=9;
                    depth = subparagraphDepth;
                }
                else if(!strncmp(scanPtr, "sub", 3))
                {
                    scanPtr+=3;
                    if(!strncmp(scanPtr, "section", 7))
                    {
                        scanPtr+=7;
                        depth = subsubsectionDepth;
                    }
                    else if(!strncmp(scanPtr, "paragraph", 9))
                    {
                        scanPtr+=9;
                        depth = subsubparagraphDepth;
                    }
                    else if(!strncmp(scanPtr, "subsection", 10))
                    {
                        scanPtr+=10;
                        depth = subsubsubsectionDepth;
                    }
                }
            }
        }
        else if(!strncmp(scanPtr, "chapter", 7))
        {
            scanPtr+=7;
            depth = chapterDepth;
        }
        else if(!strncmp(scanPtr, "par", 3))
        {
            scanPtr+=3;
            if(*scanPtr == 't')
            {
                ++scanPtr;
                depth = partDepth;
            }
            else if(!strncmp(scanPtr, "agraph", 6))
            {
                scanPtr+=6;
                depth = paragraphDepth;
            }
        }
        else if(!strncmp(scanPtr, "in", 2))
        {
            scanPtr+=2;
            if(!strncmp(scanPtr, "clude", 5))
            {
                scanPtr+=5;
                depth = includeDepth;
            }
            else if(!strncmp(scanPtr, "put", 3))
            {
                scanPtr+=3;
                depth = inputDepth;
            }
        }
        if(depth)
        {
            NSString * title = nil;
            NSString * object = nil;
            NSMenuItem * MI = [[[NSMenuItem allocWithZone: [NSMenu menuZone]] init] autorelease];
            while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
            if(inputDepth == depth)
            {
                char * l1, * l2, * l3;
                l1 = strchr(scanPtr, ' ');
                l2 = strchr(scanPtr, '\r');
                l3 = l1? (l2? MIN(l1, l2): l1): l2;
                l2 = strchr(scanPtr, '\n');
                l1 = l3? (l2? MIN(l3, l2): l3): (l2? l2: strchr(scanPtr, '\0'));
                object = [NSString stringWithCString: scanPtr length:(unsigned)(l1-scanPtr)];
                [MI setAction: @selector(scrollInputToVisible:)];
                [MI setEnabled: ([[sectionMenu title] length] > 0)];
            }
            else if((* scanPtr == bgroup) && (egroupPtr = strchr(scanPtr, egroup)))
            {
                object = [NSString stringWithCString: ++scanPtr length:(unsigned)(egroupPtr-scanPtr)];
                [MI setAction: (depth == includeDepth? @selector(scrollIncludeToVisible:):
                    @selector(scrollTaggedToVisible:))];
                [MI setEnabled: ([[sectionMenu title] length] > 0)];
            }
            if([object length])
            {
                switch(depth)
                {
                    case partDepth:
                    case chapterDepth:
                        sectionCount = subsectionCount = subsubsectionCount = 0;
                    default:
                        title = object;
                        break;
                    case sectionDepth:
                        title = [NSString stringWithFormat: @"%d. %@", ++sectionCount, object];
                        subsectionCount = subsubsectionCount = 0;
                        break;
                    case subsectionDepth:
                        title = [NSString stringWithFormat: @"%d.%c. %@", sectionCount, ++subsectionCount+'a'-1, object];
                        subsubsectionCount = 0;
                        break;
                    case subsubsectionDepth:
                        title = [NSString stringWithFormat: @"%d.%c.%d. %@",
                                                    sectionCount, subsectionCount+'a'-1, ++subsubsectionCount, object];
                        break;
                    case paragraphDepth:
                        title = [NSString stringWithFormat: @"...%@", object];
                        break;
                    case subparagraphDepth:
                        title = [NSString stringWithFormat: @"....%@", object];
                        break;
                    case subsubparagraphDepth:
                        title = [NSString stringWithFormat: @".....%@", object];
                        break;
                 }
                if([title length] > 48)
                    title = [NSString stringWithFormat: @"%@[...]", [title substringWithRange: NSMakeRange(0,43)]];
                if([title length])
                {
                    [MI setTitle: title];
                    [MI setRepresentedObject: object];
                    [MI setTag: backslashPtr - cString];
                    [MI setTarget: self];
                    [sectionMenu addItem: MI];
                }
                else if(title)
                    NSBeep();
            }
            else if(title)
                NSBeep();
        }
        #if 0
        if(((unsigned)scanPtr)/1000 > meter)
        {
            meter = ((unsigned)scanPtr)/1000;
            NSLog(@"meter: %d", meter);
        }
        #endif
    }
    [sender setMenu: sectionMenu];
    [sender setEnabled: YES];
    return;
}
#else
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateSectionButton:
- (void) validateSectionButton: (id) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
{
//    static int meter = 0;
    NSString * string = [[self textView] string];
    NSScanner * S = [iTMLiteScanner scannerWithString: string];
    NSCharacterSet * noBackslashSet = [[NSCharacterSet characterSetWithCharactersInString: @"\\"] invertedSet];
    NSMenu * sectionMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: [NSString string]] autorelease];
    unsigned sectionCount = 0, subsectionCount = 0, subsubsectionCount = 0;
    [sectionMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[sectionMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [sectionMenu addItemWithTitle: NSLocalizedStringFromTableInBundle(@"Sections:", @"TeX",
                [NSBundle bundleForClass: [self class]], "Title of the first item of the mark menu")
                            action: NULL keyEquivalent: [NSString string]];
    NSLog(@"validateSectionButton");
    while(([S setCharactersToBeSkipped: noBackslashSet], ![S isAtEnd]))
    {
        NSString * title = nil;
        NSMenuItem * MI = nil;
        SEL action = NULL;
        if([S scanString: @"\\" intoString: nil])// always true
        {
            unsigned int lineStart = [S scanLocation] - 1;
            NSRange r = NSMakeRange(NSNotFound, 0);
            unsigned level = 0;
            [S setCharactersToBeSkipped: nil];
            [S setCaseSensitive: YES];
            if([S scanString: @"s" intoString: nil])
            {
                if([S scanString: @"e" intoString: nil])
                {
                    if([S scanString: @"ction" intoString: nil] &&
                        ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                            [S scanString: @"{" intoString: nil]))
                    {
                        r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                        action = @selector(scrollTaggedToVisible:);
                        level = 2;
                    }
                }
                else if([S scanString: @"ub" intoString: nil])
                {
                    if([S scanString: @"s" intoString: nil])
                    {
                        if([S scanString: @"ub" intoString: nil])
                        {
                            if([S scanString: @"section" intoString: nil] &&
                                ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                                    [S scanString: @"{" intoString: nil]))
                            {
                                r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                                action = @selector(scrollTaggedToVisible:);
                                level = 4;
                            }
                            else if([S scanString: @"paragraph" intoString: nil] &&
                                ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                                    [S scanString: @"{" intoString: nil]))
                            {
                                r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                                action = @selector(scrollTaggedToVisible:);
                                level = 7;
                            }
                        }
                        else if([S scanString: @"ection" intoString: nil] &&
                            ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                                [S scanString: @"{" intoString: nil]))
                        {
                            r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                            action = @selector(scrollTaggedToVisible:);
                            level = 3;
                        }
                    }
                    else if([S scanString: @"paragraph" intoString: nil] &&
                        ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                            [S scanString: @"{" intoString: nil]))
                    {
                        r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                        action = @selector(scrollTaggedToVisible:);
                        level = 6;
                    }
                }
            }
            else if([S scanString: @"par" intoString: nil])
            {
                if([S scanString: @"agraph" intoString: nil] &&
                    ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                        [S scanString: @"{" intoString: nil]))
                {
                    r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                    action = @selector(scrollTaggedToVisible:);
                    level = 5;
                }
                else if([S scanString: @"t" intoString: nil] &&
                        ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                            [S scanString: @"{" intoString: nil]))
                {
                    r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                    action = @selector(scrollTaggedToVisible:);
                    level = 0;
                }
            }
            else if([S scanString: @"in" intoString: nil])
            {
                if([S scanString: @"put" intoString: nil])
                {
                    if(([S setCharactersToBeSkipped: [NSCharacterSet whitespaceAndNewlineCharacterSet]],
                        [S scanCharactersFromSet: [[NSCharacterSet whitespaceAndNewlineCharacterSet] invertedSet]
                            intoString: &title]))
                    {
                        action = @selector(scrollInputToVisible:);
                        level = 0;
                    }
                }
                else if([S scanString: @"clude" intoString: nil] &&
                    ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceCharacterSet]],
                        [S scanString: @"{" intoString: nil]))
                {
                    r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                    action = @selector(scrollIncludeToVisible:);
                    level = 0;
                }
            }
            else if([S scanString: @"chapter" intoString: nil] &&
                ([S setCharactersToBeSkipped: [NSCharacterSet whitespaceCharacterSet]],
                    [S scanString: @"{" intoString: nil]))
            {
                r = [[self textStorage] doubleClickAtIndex: [S scanLocation] - 1];
                action = @selector(scrollTaggedToVisible:);
                level = 1;
            }
            // let us create the menu item now,
            if(r.length > 2)
            {
                r.location += 1;
                r.length -= 2;
                title = [string substringWithRange: r];
            }
            if([title length])
            {
                switch(level)
                {
                    case 0:
                    case 1:
                        sectionCount = subsectionCount = subsubsectionCount = 0;
                        break;
                    case 2:
                        title = [NSString stringWithFormat: @"%d. %@", ++sectionCount, title];
                        subsectionCount = subsubsectionCount = 0;
                        break;
                    case 3:
                        title = [NSString stringWithFormat: @".%d. %@", ++subsectionCount, title];
                        subsubsectionCount = 0;
                        break;
                    case 4:
                        title = [NSString stringWithFormat: @"..%d. %@", ++subsubsectionCount, title];
                        break;
                    case 5:
                        title = [NSString stringWithFormat: @"...%@", title];
                        break;
                    case 6:
                        title = [NSString stringWithFormat: @"....%@", title];
                        break;
                    case 7:
                        title = [NSString stringWithFormat: @".....%@", title];
                        break;
                 }
                if([title length] > 48)
                    title = [NSString stringWithFormat: @"%@...", [title substringWithRange: NSMakeRange(0,45)]];
                MI = [sectionMenu addItemWithTitle: title action: action keyEquivalent: [NSString string]];
                [MI setTag: lineStart];
                [MI setTarget: self];
            }
            else if(title)
                NSBeep();
        }
        else// not a comment line nor command
            break;
        #if 0
        if([S scanLocation]/1000 > meter)
        {
            meter = [S scanLocation]/1000;
            NSLog(@"meter: %d", meter);
        }
        #endif
    }
    [sender setMenu: sectionMenu];
    [sender setEnabled: YES];
    return;
}
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateLabelButton:
- (void) validateLabelButton: (id) sender;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
{
    int countL = 0;
    int countR = 0;
    BOOL isCommand;
    /*" We use C strings. With UTF8 strings, we should manage shifts. "*/
    const char * stringPtr = [[[self textView] string] lossyCString];
    const char * scanPtr = stringPtr;
    const char * max = strchr(stringPtr, '\0');
    const char * utf8Backslash = [[NSString stringWithUTF8String: "\\"] cString];
    NSString * title = [self fileName]? [[self fileName] stringByDeletingLastPathComponent]: [NSString string];
    NSMenu * labelMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: title] autorelease];
    NSMenu * refMenu = [[[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: [NSString string]] autorelease];

    [labelMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[labelMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [labelMenu addItemWithTitle:
            NSLocalizedStringFromTableInBundle(@"Labels:", @"TeX",
                            [NSBundle bundleForClass: [self class]], "Title of the first item of the labels menu")
                    action: NULL keyEquivalent: [NSString string]];
    [labelMenu setAutoenablesItems: NO];

    [refMenu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
    [[refMenu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
    [refMenu setAutoenablesItems: NO];

    while(YES)
    {
        const char * scanBackslash =  strstr(scanPtr, utf8Backslash);
        const char * scanComment = strchr(scanPtr, '%');
        while(YES)
        {
            if(!scanBackslash) scanBackslash = max;
            if(!scanComment) scanComment = max;
            if(scanComment < scanBackslash)
            {
                isCommand = NO;
                break;
            }
            else if(scanBackslash < max)
            {
                scanBackslash += strlen(utf8Backslash);
                if (*(scanBackslash) == '%')
                {
                    ++scanBackslash;
                    scanBackslash = strstr(scanBackslash, utf8Backslash);
                    scanComment = strchr(scanBackslash, '%');
                }
                else if(!strncmp(scanBackslash, utf8Backslash, strlen(utf8Backslash)))
                {
                    scanBackslash += strlen(utf8Backslash);
                    scanBackslash = strstr(scanBackslash, utf8Backslash);
                }
                else
                {
                    isCommand = YES;
                    break;
                }
            }
            else
            {
                isCommand = YES;
                break;
            }
        }
        if(isCommand && (scanBackslash < max))
        {
            scanPtr = scanBackslash;
            if(!strncmp(scanPtr, "in", 2))
            {
                scanPtr+=2;
                if(!strncmp(scanPtr, "clude", 5))
                {
                    unsigned char bgroup = '{';//}
                    scanPtr+=5;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    if(* scanPtr == bgroup)
                    {//{
                        unsigned char egroup = '}';
                        scanPtr+=1;
                        //semi critical: read the comments here
                        scanBackslash = scanPtr;
                        scanPtr = strchr(scanPtr, egroup);
                        if(scanPtr)
                        {
                            NSString *  object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                            [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [labelMenu addItemWithTitle: title
                                                        action: @selector(scrollIncludeToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: title];
                                [MI setEnabled: ([[labelMenu title] length] > 0)];
                            }
                        }
                    }
                }
                else if(!strncmp(scanPtr, "put", 3))
                {
                    scanPtr+=3;
                    while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                    {
                        const char * SPACE = strchr(scanPtr, ' ');
                        const char * CR = strchr(scanPtr, '\r');
                        const char * LF = strchr(scanPtr, '\n');
                        scanBackslash = scanPtr;
                        scanPtr = SPACE? (CR? MIN(SPACE, CR): SPACE): CR;
                        scanPtr = scanPtr? (LF? MIN(LF, scanPtr): scanPtr): (LF? LF: strchr(scanPtr, '\0'));
                        {
                            NSString * object = [[NSString stringWithCString: scanBackslash
                                    length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                            NSString * title = ([object length] > 48)?
                                                    [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,43)]]: object;
                            if([title length])
                            {
                                NSMenuItem * MI = [labelMenu addItemWithTitle: title
                                                        action: @selector(scrollInputToVisible:)
                                                            keyEquivalent: [NSString string]];
                                [MI setTarget: self];
                                [MI setRepresentedObject: object];
                                [MI setEnabled: ([[labelMenu title] length] > 0)];
                            }
                        }
                    }
                }
            }
            else if(!strncmp(scanPtr, "label", 5))
            {
                unsigned char bgroup = '{';//}
                scanPtr+=5;
                while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                if(* scanPtr == bgroup)
                {//{
                    unsigned char egroup = '}';
                    const char * tag = scanPtr;
                    scanPtr+=1;
                    //semi critical: read the comments here
                    scanBackslash = scanPtr;
                    scanPtr = strchr(scanPtr, egroup);
                    if(scanPtr)
                    {
                        NSString * object = [[NSString stringWithCString: scanBackslash
                                length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                        NSString * title = ([object length] > 41)?
                                                [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,36)]]: object;
                        if([title length])
                        {
                            NSMenuItem * MI = [labelMenu addItemWithTitle:
                                                [NSString stringWithFormat: @"%4d %@", countL++, title]
                                                    action: @selector(scrollLabelToVisible:)
                                                        keyEquivalent: [NSString string]];
                            [MI setTarget: self];
                            [MI setTag: (tag - stringPtr)];
                            [MI setRepresentedObject: title];
                            [MI setEnabled: ([[labelMenu title] length] > 0)];
                        }
                    }
                }
            }
            else if(!strncmp(scanPtr, "ref", 3))
            {
                unsigned char bgroup = '{';//}
                scanPtr+=3;
                while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                if(* scanPtr == bgroup)
                {//{
                    unsigned char egroup = '}';
                    scanPtr+=1;
                    //semi critical: read the comments here
                    scanBackslash = scanPtr;
                    scanPtr = strchr(scanPtr, egroup);
                    if(scanPtr)
                    {
                        NSString * object = [[NSString stringWithCString: scanBackslash
                                length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                        NSString * title = ([object length] > 43)?
                                                [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,38)]]: object;
                        if([title length])
                        {
                            NSMenuItem * MI = [refMenu addItemWithTitle:
                                                    [NSString stringWithFormat: @"%4d %@", countR++, title]
                                                        action: @selector(scrollTaggedToVisible:)
                                                            keyEquivalent: [NSString string]];
                            [MI setTarget: self];
                            [MI setTag: scanBackslash - stringPtr];
                            [MI setRepresentedObject: title];
                            [MI setEnabled: ([[labelMenu title] length] > 0)];
                        }
                    }
                }
            }
            else if(!strncmp(scanPtr, "eqref", 5))
            {
                unsigned char bgroup = '{';//}
                scanPtr+=5;
                while((* scanPtr == ' ') || (* scanPtr == '\r') || (* scanPtr == '\n')) ++scanPtr;
                if(* scanPtr == bgroup)
                {//{
                    unsigned char egroup = '}';
                    scanPtr+=1;
                    //semi critical: read the comments here
                    scanBackslash = scanPtr;
                    scanPtr = strchr(scanPtr, egroup);
                    if(scanPtr)
                    {
                        NSString * object = [[NSString stringWithCString: scanBackslash
                                length: (unsigned)(scanPtr - scanBackslash)] stringByRemovingTrailingWhites];
                        NSString * title = ([object length] > 41)?
                                                [NSString stringWithFormat: @"%@[...]",
                                                        [object substringWithRange: NSMakeRange(0,36)]]: object;
                        if([title length])
                        {
                            NSMenuItem * MI = [refMenu addItemWithTitle:
                                                    [NSString stringWithFormat: @"%4d %@ (eq)", countR++, title]
                                                        action: @selector(scrollTaggedToVisible:)
                                                            keyEquivalent: [NSString string]];
                            [MI setTarget: self];
                            [MI setTag: scanBackslash - stringPtr];
                            [MI setRepresentedObject: title];
                            [MI setEnabled: ([[labelMenu title] length] > 0)];
                        }
                    }
                }
            }
        }
        else if(scanComment < max)
        {
            scanPtr = ++scanComment;
            {
                const char * CR = strchr(scanPtr, '\r');
                const char * LF = strchr(scanPtr, '\n');
                scanPtr = CR? (LF? MIN(CR, LF): CR): (LF? LF: strchr(scanPtr, '\0'));
            }
        }
        else
            break;
    }
    {
        NSMenuItem * MI = [labelMenu insertItemWithTitle: @"ref" action: NULL keyEquivalent: [NSString string] atIndex: 1];
        [MI setSubmenu: refMenu];
    }
    [sender setMenu: labelMenu];
    [sender setEnabled: YES];
    return;
}
@end

@implementation NSInvocation(iTMTeXDocumentNavigation)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  delayInvocationWithTarget:action:sender:untilNotificationWithName:isPostedFromObject:
+ (void) delayInvocationWithTarget: (id) target action: (SEL) action sender: (id) sender
untilNotificationWithName: (NSString *) name isPostedFromObject: (id) object;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
{
    NSInvocation * invocation = [NSInvocation invocationWithMethodSignature:
        [target methodSignatureForSelector: action]];
    [invocation retainArguments];
    [invocation setArgument: (sender? &sender: nil) atIndex: 2];
    [invocation setTarget: target];
    [invocation setSelector: action];
    [[NSNotificationCenter defaultCenter]
        addObserver: invocation selector: @selector(invokeNotified:) name: name object: object];
    [invocation retain];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  invokeNotified:
- (void) invokeNotified: (NSNotification *) aNotification;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
{
    [self invoke];
    [[NSNotificationCenter defaultCenter]
        removeObserver: self name: [aNotification name] object: [aNotification object]];
    [self autorelease];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(Navigation)

