//
//  iTMTeXWindow.m
//  iTeXMac
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  History:
//  +initialize added by jerome.laurens@u-bourgogne.fr (07/12/2001)
//  +frameIdentifier added by jerome.laurens@u-bourgogne.fr (07/12/2001)
//  MainWindow changed to iTMTeXWindow by jerome.laurens@u-bourgogne.fr (07/17/2001)
//  the outlet connected to MyDocument is replaced by the delegate by jerome.laurens@u-bourgogne.fr (07/17/2001)
//  -doChooseMethod: is removed by jerome.laurens@u-bourgogne.fr (07/17/2001)

#import <Foundation/NSString.h>
#import <Foundation/NSPathUtilities.h>
#import <Foundation/NSUserDefaults.h>
#import <Foundation/NSDictionary.h>
#import <AppKit/NSEvent.h>
#import <AppKit/NSDocumentController.h>
#import <AppKit/NSDocument.h>
#import "NSWindow(iTeXMac).h"
#import "iTMTeXWindow.h"
#import "iTMWindowsObserver.h"

@implementation iTMTeXWindow

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= initialize
+ (void) initialize;
/*"Sends an #{+initialize} to the iTMWindowsObserver class object. See the NSWindow category Observer.
Version History: jerome.laurens@u-bourgogne.fr (07/12/2001)
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super initialize];
    [iTMWindowsObserver initialize];
    [[NSUserDefaults standardUserDefaults] registerDefaults: [NSDictionary dictionaryWithObjectsAndKeys: 
                [NSNumber numberWithInt: iTMWindowFrameFixedMode], [iTMTeXWindow frameAutosaveModeKey],
                        nil]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= frameIdentifier
+ (NSString *) frameIdentifier;
/*"Related to the observation of the window position, see the NSWindow category Position.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    return @"Source Window";// return a hard string to allow subclassing
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= shouldBeObserved
+ (BOOL) shouldBeObserved;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
#if 0
- (BOOL)performMnemonic:(NSString *)aString
{
    NSLog(@"performMnemonic %@: <%@>", self, aString);
    return [super performMnemonic: aString];
}
- (BOOL)performKeyEquivalent:(NSEvent *)theEvent
{
    NSLog(@"performKeyEquivalent %@: <%@>", self, [theEvent charactersIgnoringModifiers]);
    return [super performKeyEquivalent: theEvent];
}
- (void)keyDown:(NSEvent *)theEvent
{
    NSLog(@"keyDown %@: <%@>", self, [theEvent charactersIgnoringModifiers]);
    [super keyDown: theEvent]; return ;
}
#endif
@end
@implementation iTMTeXWindow(iTMLaTeXToolsController)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  allowsLaTeXToolsPanel
- (BOOL) allowsLaTeXToolsPanel;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr (02/01/2002).
To do list:
"*/
{
    return YES;
}
@end
