/*
//  iTMTeXWindowController(Action).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Dec 08 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "NSString(iTeXMac).h"
#import "iTMTeXWindowController.h"
#import "iTMTeXWindowController(Action).h"
#import "iTMTextView.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXWindowController(Action)
/*"Description forthcoming."*/
@implementation iTMTeXWindowController(Action)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  highlightAndScrollLineToVisible:
- (void) highlightAndScrollLineToVisible: (int) aLine;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self mainTextView] highlightAndScrollLineToVisible: aLine];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  highlightAndScrollLineRangeToVisible:
- (void) highlightAndScrollLineRangeToVisible: (NSRange) aLineRange;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self mainTextView] highlightAndScrollLineRangeToVisible: aLineRange];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  highlightAndScrollRangeToVisible:
- (void) highlightAndScrollRangeToVisible: (NSRange) aRange;
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[self mainTextView] highlightAndScrollRangeToVisible: aRange];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  selectedLineChosen
- (void) selectedLineChosen: (NSTextField *) sender;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self highlightAndScrollLineToVisible: [sender intValue]];
    [self updateLineFieldSize];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  updateLineField
- (void) updateLineField;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSTextView * TV = [self mainTextView];
    [[self lineField] setIntValue: [[TV string] lineForRange: [TV selectedRange]]];
    [self updateLineFieldSize];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  updateNumberOfLines
- (void) updateNumberOfLines;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [[[self lineField] formatter] setMaximum:
            [NSDecimalNumber numberWithInt: [[[self textView] string] numberOfLines]]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  updateLineFieldSize
- (void) updateLineFieldSize;
/*"Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    float newWidth = [[[self lineField] stringValue] sizeWithAttributes:
            [NSDictionary dictionaryWithObjectsAndKeys:
                [[self lineField] font], NSFontAttributeName, nil]].width
                    + 8;
    float deltaWidth = newWidth - [[self lineField] frame].size.width;
    if((deltaWidth < -8) || (deltaWidth > 0))
    {
        NSPoint origin = [[self statusField] frame].origin;
        NSSize size = [[self statusField] frame].size;
        origin.x += deltaWidth;
        size.width -= deltaWidth;
        [[self statusField] setFrameOrigin: origin];
        [[self statusField] setFrameSize: size];
        size = [[self lineField] frame].size;
        size.width = newWidth;
        [[self lineField] setFrameSize: size];
    }
    [[[self lineField] superview] setNeedsDisplayInRect:
            NSUnionRect([[self lineField] frame], [[self statusField] frame])];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXWindowController(Action)

