/*
//  iTMUndoManager.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Sep 02 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMUndoManager.h"

NSString * const iTMUDSmartUndoKey = @"iTMUDSmartUndo";

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMUndoManager
/*"Description forthcoming."*/
@implementation iTMUndoManager
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  initialize;
+ (void) initialize;
/*"Description Forthcoming.
Version History: jerome.laurens@u-bourgogne.fr (12/18/2001).
To do list:
"*/
{
    [super initialize];
    [[NSUserDefaults standardUserDefaults] registerDefaults: [NSDictionary dictionaryWithObjectsAndKeys:
            [NSNumber numberWithBool: YES], iTMUDSmartUndoKey,
                nil]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  undo
- (void) undo;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if([[NSUserDefaults standardUserDefaults] boolForKey: iTMUDSmartUndoKey])
    {
        NSWindow * W = [NSApp mainWindow];
        if(![[[W windowController] document] isDocumentEdited])
        {
            NSString * undoMenuItemTitle = [self undoMenuItemTitle];
            NSString * titre;
            if([[self undoMenuItemTitle] hasPrefix: @"&"])
                titre = [undoMenuItemTitle substringWithRange: NSMakeRange(1, [undoMenuItemTitle length]-1)];
            else
                titre = undoMenuItemTitle;
            NSBeginAlertSheet(  nil,
                                titre,
                                [NSString stringWithFormat: NSLocalizedStringFromTableInBundle(@"Don't %@", @"Basic",
                                                            [NSBundle bundleForClass: [self class]], nil), titre],
                                nil,
                                [NSApp mainWindow],
                                self,
                                @selector(sheetDidEnd:returnCode:irrelevantInfo:),
                                NULL,
                                nil,
                                NSLocalizedStringFromTableInBundle(@"Undo past save?", @"Basic",
                            [NSBundle bundleForClass: [self class]],
                        "You are about to undo past the last point this file was saved. Do you want to do this?"));
            return;
        }
    }
    [super undo];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  irrelevantInfo:returnCode:irrelevantInfo:
- (void) sheetDidEnd: (NSWindow *) unused returnCode: (int) returnCode irrelevantInfo: (void *) irrelevant;
/*"Private use only. Description Forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if ((returnCode == NSOKButton) && ([self canUndo]))
    {
        [super undo];
    }
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMUndoManager

