/*
//  iTMTerminalController(UI).h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Jul 18 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import "iTMTerminalController.h"

extern NSString * const iTMStopItemIdentifier;

extern NSString * const iTMDefaultCommandKey;
extern NSString * const iTMDefaultScriptKey;
extern NSString * const iTMConsoleBehaviorKey;
extern NSString * const iTMLaTeXCommandKey;
extern NSString * const iTMLaTeXGSCommandKey;
extern NSString * const iTMSavePSEnabledKey;
extern NSString * const iTMLaTeXScriptCommandKey;
extern NSString * const iTMTeTeXBinariesPathKey;
extern NSString * const iTMTeXCommandKey;
extern NSString * const iTMTeXGSCommandKey;
extern NSString * const iTMTeXScriptCommandKey;

typedef enum _iTMEngineIndex
{
    kiTMTeXEngine=0,
    kiTMLaTeXEngine=1,
    kiTMBibTeXEngine=2,
    kiTMMakeIndexEngine=3
} iTMEngineIndex;


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTerminalController(UI)

@interface iTMTerminalController(UI)
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSTextField *) input;
- (void) setInput: (id) aInput;
- (NSTextView *) output;
- (void) setOutput: (id) aOutput;
/*"Main methods"*/
- (IBAction) performInput: (id) sender;
- (void) logCommand: (NSString *) aMessage;
- (void) logMessage: (NSString *) aMessage;
- (void) logError: (NSString *) aMessage;
- (void) eraseOutput;
/*"Overriden methods"*/
- (void) initUI;
- (void) deallocUI;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTerminalController(UI)
