/*
//  iTMTerminalController.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Jul 18 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import <AppKit/AppKit.h>

extern NSString * const iTMTCTaskKey;
extern NSString * const iTMTCUserInfoKey;
extern NSString * const iTMTCScriptKey;
extern NSString * const iTMTCInvocationKey;
extern NSString * const iTMTCOutputKey;

extern NSString * const iTMTaskTerminationStatus;
extern NSString * const iTMTerminalCurrentTaskKey;

extern NSString * const iTMTerminalBehaviorKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTerminalController

@interface iTMTerminalController : NSObject
{
@private
    IBOutlet NSTextField * _Input;
    IBOutlet NSTextView * _Output;
    BOOL _Listens;
    BOOL _NormalTermination;
    NSMutableArray * _TDs;
}
/*"Class methods"*/
+ (void) initialize;
/*"Public methods"*/
/*"Setters and Getters"*/
- (NSMutableArray *) taskDictionaries;
- (void) setTaskDictionaries: (NSMutableArray *) aMA;
- (NSTask *) currentTask;
/*"Main methods"*/
- (void) addShellTaskWithEnvironment: (NSDictionary *) aDictionary
standardInput: (NSString *) aScript
directory: (NSString *) aPath
delegate: (id) aDelegate
didExecuteSelector: (SEL) aSelector
userInfo: (NSDictionary *) aUI
restart: (BOOL) restart;
- (void) addTaskWithLaunchPath: (NSString *) aLaunchPath
environment: (NSDictionary *) aDictionary
arguments: (NSArray *) arguments
directory: (NSString *) aPath
delegate: (id) aDelegate
didExecuteSelector: (SEL) aSelector
userInfo: (NSDictionary *) aUI
restart: (BOOL) restart;
- (void) startFirstTask;
- (void) _taskDidTerminate: (NSNotification *) aNotification;
- (void) closeTerminal: (id) sender;
- (IBAction) standardInputString: (NSString *) aString verbose: (BOOL) aFlag;
- (void) outputReadCompletion: (NSNotification *) aNotification;
- (void) errorReadCompletion: (NSNotification *) aNotification;
- (void) listenIfNeeded;
- (void) listenToInput;
- (void) dontListenToInput;
- (void) listenToTask: (NSTask *) aTask;
/*"Overriden methods"*/
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTerminalController
