/*
//  NSString(iTeXMac).h
//  Finder Alias
//
//  Created by jerome.laurens@u-bourgogne.fr on Sat Jun 16 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import <Foundation/NSString.h>

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= NSString(iTeXMac)

@interface NSString(iTeXMac)
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSRange) rangeForLine: (int) aLine nextLine: (int *) aNextLinePtr;
- (NSRange) rangeForLineRange: (NSRange) aLineRange nextLine: (int *) aNextLinePtr;
- (NSRange) rangeContentForLine: (int) aLine nextLine: (int *) aNextLinePtr;
- (unsigned) lineForRange: (NSRange) aRange;
- (unsigned) numberOfLines;
- (BOOL) boolValue;
- (NSString *) commentedStringForKey: (NSString *) aKey value: (NSString *) aValue;
- (NSString *) stringForCommentedKey: (NSString *) aKey forRange: (NSRange) aRange effectiveRange: (NSRangePointer) aRangePtr inHeader: (BOOL) aFlag;
- (NSString *) stringByRemovingTrailingWhites;
- (NSString*) stringWithSubstring: (NSString*) oldString replacedByString: (NSString*) newString;
/*"Main methods"*/
- (BOOL) isBackslashAtIndex: (unsigned) index escaped: (BOOL *) aFlagPtr;
- (NSRange) groupRangeAtIndex: (unsigned) index;
- (NSRange) groupRangeAtIndex: (unsigned) index beginDelimiter: (unichar) bgroup endDelimiter: (unichar) egroup;
- (BOOL) isFinderAliasTraverseLink: (BOOL) aFlag isDirectory: (BOOL *) isDirectory;
- (NSString *) stringByResolvingFinderAliasesInPath;
- (NSString *) stringByResolvingSymlinksAndFinderAliasesInPath;
- (NSString *) stringByAbbreviatingWithDotRelativeToDirectory: (NSString *) aPath;
- (NSString *) shortestStringByAbbreviatingWithTildeInPath;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= NSString(iTeXMac)
