/*
//  iTMLogSyntaxParser.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Fri Dec 07 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMSyntaxParser.h"

extern NSString * const iTMUDLogRegularFontKey;
extern NSString * const iTMUDLogWarningFontKey;
extern NSString * const iTMUDLogErrorFontKey;
extern NSString * const iTMUDLogInfoFontKey;

extern NSString * const iTMUDLogRegularColorKey;
extern NSString * const iTMUDLogWarningColorKey;
extern NSString * const iTMUDLogErrorColorKey;
extern NSString * const iTMUDLogInfoColorKey;

extern NSString * const iTMLogInputAttributeName;

@interface iTMLogSyntaxParser: iTMSyntaxParser
+ (id) syntaxParser;
//- (id) init;
- (void) fontOrColorDidChange: (NSNotification *) aNotification;
- (NSDictionary *) attributedString: (NSAttributedString *) attributedString attributesAtIndex: (unsigned) aLocation
effectiveRange: (NSRangePointer) aRangePtr;
- (NSRange) attributedString: (NSAttributedString *) anAttributedString invalidRangeForCharactersInOldRange: (NSRange) aRange replacedWithString: (NSString *) aString;
- (void) attributedString: (NSAttributedString *) anAttributedString fixAttributesInRange: (NSRange) aRange;
- (NSRange) attributedString: (NSAttributedString *) attributedString rangeOfErrorFromIndex: (unsigned) charIndex cycle: (BOOL) cycle backwards: (BOOL) backwards;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMLogSyntaxParser

