/*
//  iTMSyntaxParser.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Wed Nov 07 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSObject.h>
#import "iTMTextStorage.h"

extern NSString * const iTMFontOrColorDidChangeNotification;

extern NSString * const iTMUDStandardFontKey;
extern NSString * const iTMUDStandardColorKey;

@class NSArray;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMSyntaxParser
@interface iTMSyntaxParser: NSObject
{
@private
    NSArray * _AsA;
    iTMTextStorage * _TS;
    BOOL _LayoutFinishedFlag;
}
/*"Class methods"*/
/*"Setters and Getters"*/
+ (id) syntaxParser;
- (id) attributesArray;
- (void) setAttributesArray: (id) argument;
- (BOOL) isITMCommentAtIndex: (unsigned) aLocation;
- (BOOL) isColoring;
- (iTMTextStorage *) textStorage;
- (void) setTextStorage: (iTMTextStorage *) TS;
/*"Main methods"*/
- (void) defaultsFontOrColorDidChange: (NSNotification *) aNotification;
- (void) fontOrColorDidChange: (NSNotification *) aNotification;
- (void) fixAttributesInRange: (NSRange) aRange;
- (void) replaceCharactersInRange: (NSRange) aRange withString: (NSString *) aString invalidRange: (NSRangePointer) aRangePtr;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

@interface iTMSyntaxParser(iTMAttributes)
- (NSDictionary *) attributesAtIndex: (unsigned) aLocation effectiveRange: (NSRangePointer) aRangePtr;
- (NSDictionary *) attributesAtIndex: (unsigned) aLocation longestEffectiveRange: (NSRangePointer) aRangePtr inRange: (NSRange) rangeLimit;
- (id) attribute: (NSString *) name atIndex: (unsigned) aLocation effectiveRange: (NSRangePointer) aRangePtr;
- (id) attribute: (NSString *) name atIndex: (unsigned) aLocation longestEffectiveRange: (NSRangePointer) aRangePtr inRange: (NSRange) rangeLimit;
@end

@interface iTMSyntaxParser(iTMSettings)
- (id) settings;
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMSyntaxParser
