/*
//  iTMTeXSyntaxParser.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Fri Dec 07 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMSyntaxParser.h"
#import "iTMTextStorage.h"

extern NSString * const iTMUDTeXRegularFontKey;
extern NSString * const iTMUDTeXCommandFontKey;
extern NSString * const iTMUDTeXCommentFontKey;
extern NSString * const iTMUDTeXMarkFontKey;
extern NSString * const iTMUDTeXDollarFontKey;
extern NSString * const iTMUDTeXDelimiterFontKey;

extern NSString * const iTMUDTeXStandardFontKey;
extern NSString * const iTMUDTeXStandardColorKey;

extern NSString * const iTMUDTeXRegularColorKey;
extern NSString * const iTMUDTeXCommandColorKey;
extern NSString * const iTMUDTeXCommentColorKey;
extern NSString * const iTMUDTeXMarkColorKey;
extern NSString * const iTMUDTeXDollarColorKey;
extern NSString * const iTMUDTeXDelimiterColorKey;

extern NSString * const iTMUDLigatureAttributeKey;
extern NSString * const iTMUDKernAttributeKey;
extern NSString * const iTMUDRegularTextKerningOnlyKey;

extern NSString * const iTMTeXInputAttributeName;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXSyntaxParser

@interface iTMTeXSyntaxParser : iTMSyntaxParser
{
@private
    NSArray * _AADs;
}
/*"Class methods"*/
+ (id) syntaxParser;
/*"Setters and Getters"*/
/*"Main methods"*/
- (void) fontOrColorDidChange: (NSNotification *) aNotification;
- (NSDictionary *) attributesAtIndex: (unsigned) aLocation
effectiveRange: (NSRangePointer) aRangePtr;
- (void) fixAttributesInRange: (NSRange) aRange;
- (BOOL) isRegularAtIndex: (unsigned) aLocation;
//- (BOOL) attributedString: (NSAttributedString *) anAttributedString isDelimiterAtIndex: (unsigned) aLocation;
- (BOOL) isITMCommentAtIndex: (unsigned) aLocation;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTeXSyntaxParser
