/*
//  iTMTextView.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Oct 16 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <AppKit/NSTextView.h>

extern NSString * const iTMUDAutoIndentNewlineKey;
extern NSString * const iTMUDSmartInsertKey;
extern NSString * const iTMUDUseSpacesAsTabsKey;
extern NSString * const iTMUDNumberOfSpacesForTabKey;
extern NSString * const iTMUDShiftDeleteKey;
extern NSString * const iTMUDSmartInsertDeleteEnabledKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTextView

@interface iTMTextView : NSTextView
{
@private
    struct __iTMTVFlags
    {
        unsigned int isEscaped: 1;
        unsigned int smartInsert: 1;
        unsigned int smartInsertIsGlobal: 1;
        unsigned int autoIndent: 1;
        unsigned int autoIndentIsGlobal: 1;
        unsigned int shiftDelete: 1;
        unsigned int shiftDeleteIsGlobal: 1;
        unsigned int tempAttrArePending: 1;
        unsigned int reserved: 24;
    } _iTMTVFlags;

}
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
- (void) highlightAndScrollLineToVisible: (int) aLine;
- (void) highlightAndScrollLineRangeToVisible: (NSRange) aLineRange;
- (void) highlightAndScrollRangeToVisible: (NSRange) aRange;
- (void) highlightRange: (NSRange) aRange cleanBefore: (BOOL) aFlag;
/*"Overriden methods"*/
- (void) insertText: (id) argument;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTextView
