/*
//  iTMPDFToolbarDelegate.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Jan 06 2002.
//  Copyright © 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMRepToolbarDelegate.h"
#import "iTMNavigationButton.h"
#import "iTMHistoryButton.h"
#import "iTMToolbarItem.h"

extern NSString * const iTMToolbarNavigationFieldItemIdentifier;
extern NSString * const iTMToolbarNavigationSetItemIdentifier;
extern NSString * const iTMToolbarPreviousSetItemIdentifier;
extern NSString * const iTMToolbarNextSetItemIdentifier;
extern NSString * const iTMToolbarPreviousMixedSetItemIdentifier;
extern NSString * const iTMToolbarNextMixedSetItemIdentifier;
extern NSString * const iTMToolbarFirstButtonItemIdentifier;
extern NSString * const iTMToolbarPreviousButtonItemIdentifier;
extern NSString * const iTMToolbarPreviousPreviousButtonItemIdentifier;
extern NSString * const iTMToolbarLastButtonItemIdentifier;
extern NSString * const iTMToolbarNextButtonItemIdentifier;
extern NSString * const iTMToolbarNextNextButtonItemIdentifier;
extern NSString * const iTMToolbarBackButtonItemIdentifier;
extern NSString * const iTMToolbarForwardButtonItemIdentifier;
extern NSString * const iTMToolbarHistorySetItemIdentifier;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPDFToolbarDelegate

@interface iTMPDFToolbarDelegate: iTMRepToolbarDelegate
{
@private
    NSString * __LastNavigationITII;
    NSTextField * _NavigationField;
    NSMenu * _BackMenu;
    NSMenu * _ForwardMenu;
}
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSTextField *) navigationFieldForToolbar;
- (NSTextField *) navigationFieldForPalette;
- (NSView *) navigationSetForToolbar;
- (NSView *) navigationSetForPalette;
- (NSView *) previousSet;
- (NSView *) previousMixedSet;
- (NSView *) nextMixedSet;
- (NSView *) nextSet;
- (NSView *) historySet;
- (iTMFirstButton *) firstButton;
- (iTMPreviousButton *) previousButton;
- (iTMPreviousPreviousButton *) previousPreviousButton;
- (iTMLastButton *) lastButton;
- (iTMNextButton *) nextButton;
- (iTMNextNextButton *) nextNextButton;
- (iTMBackButton *) backButton;
- (iTMForwardButton *) forwardButton;
- (NSTextField *) navigationField;
- (void) setNavigationField: (NSTextField *) aTextField;
- (NSMenu *) backMenu;
- (void) setBackMenu: (NSMenu *) aMenu;
- (NSMenu *) forwardMenu;
- (void) setForwardMenu: (NSMenu *) aMenu;
/*"Main methods"*/
- (NSArray *) toolbarDefaultItemIdentifiers: (NSToolbar*) aToolbar;
- (NSArray *) toolbarAllowedItemIdentifiers: (NSToolbar*) aToolbar;
- (NSToolbarItem *) toolbar: (NSToolbar *) aToolbar itemForItemIdentifier: (NSString *) anItemIdentifier willBeInsertedIntoToolbar: (BOOL) aFlag;
/*"Overriden methods"*/
- (id) init;
- (void) dealloc;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMPDFToolbarDelegate
