/*
//  iTMRepDocument.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Jun 24 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMRepAlbumView.h"

extern NSString * const iTMRepDocumentType;

extern NSString * const iTMUDSSetUpPageWhenBadPaperSizeKey;
extern NSString * const iTMUDPreferA4PaperKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMRepDocument  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

@interface iTMRepDocument : NSDocument
{
@private
    id _Data;
    id _Representation;
    id _RepresentationWC;
    id _Settings;
    NSDate * _FMD;
}
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSDate *) fileModificationDate;
- (void) setFileModificationDate: (NSDate *) argument;
- (NSData *) data;
- (void) setData: (NSData *) data;
- (id) representation;
- (void) setRepresentation: (id) aRepresentation;
- (id) representationWindow;
- (Class) representationWCClass;
- (id) representationWC;
- (void) setRepresentationWC: (id) aWC;
/*"Main methods"*/
- (void) makeRepresentationWC;
- (void) update;
/*"Overriden methods"*/
- (void) makeRepresentationWC;
@end

@interface iTMRepDocument(Cocoa)
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
/*"Overriden methods"*/
- (void) dealloc;
- (void) printShowingPrintPanel: (BOOL) aFlag;
- (BOOL) loadFileWrapperRepresentation: (NSFileWrapper *) wrapper ofType: (NSString *) docType;
- (BOOL) loadDataRepresentation: (NSData *) data ofType: (NSString *) aType;
- (NSData *) dataRepresentationOfType: (NSString *) aType;
- (void) makeWindowControllers;
@end


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMRepDocument


