/*
//  iTMPDFWindow.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Fri Jul 13 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import "NSWindow(iTeXMac).h"
#import "iTMPDFWindow.h"
#import "iTMWindowsObserver.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMPDFWindow
/*"Description forthcoming."*/
@implementation iTMPDFWindow
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= initialize
+ (void) initialize;
/*"Sends an #{+initialize} to the iTMWindowsObserver class object. See the NSWindow category Observer.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    [super initialize];
    [iTMWindowsObserver initialize];
    [[NSUserDefaults standardUserDefaults] registerDefaults: [NSDictionary dictionaryWithObjectsAndKeys: 
                @"0", [iTMPDFWindow frameAutosaveModeKey],
                        nil]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= frameIdentifier
+ (NSString *) frameIdentifier;
/*"Related to the observation of the window position, see the NSWindow category Position.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    return @"PDF Window";// return a hard string to allow subclassing
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= shouldBeObserved
+ (BOOL) shouldBeObserved;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMPDFWindow

