/*
//  iTMRepToolbarDelegate.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Sun Jan 06 2002.
//  Copyright © 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSNotification.h>
#import <Foundation/NSValue.h>
#import <Foundation/NSDecimalNumber.h>
#import <Foundation/Foundation.h>
#import <AppKit/NSTextField.h>
#import <AppKit/AppKit.h>
#import "iTMRepToolbarDelegate.h"
#import "NSMenu(iTeXMac).h"
#import "iTMHelpManager.h"
#import "iTMMixedButton.h"
#import "iTMMagnificationFormatter.h"

NSString * const iTMToolbarMagnificationFieldItemIdentifier = @"displayAtAtMagnification:";
NSString * const iTMToolbarMagnificationSetItemIdentifier = @"Magnification";

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepToolbarDelegate
/*"Description forthcoming."*/
@implementation iTMRepToolbarDelegate
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  init
- (id) init;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(self = [super init])
    {
        [self->__LastMagnificationITII release];
        self->__LastMagnificationITII = nil;
    }
    return self;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  dealloc
- (void) dealloc;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [__LastMagnificationITII release];
    __LastMagnificationITII = nil;
    [self setMagnificationField: nil];
    [self setMagStepper: nil];
    [super dealloc];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  setMagnification:
- (void) setMagnification: (NSDecimalNumber *) aMagnification;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if([aMagnification respondsToSelector: @selector(floatValue)])
        [[self magnificationField] setFloatValue: [aMagnification floatValue]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toolbarDefaultItemIdentifiers:
- (NSArray *) toolbarDefaultItemIdentifiers: (NSToolbar*) aToolbar;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [NSArray arrayWithObjects:
                NSToolbarPrintItemIdentifier,
                NSToolbarSeparatorItemIdentifier,
                NSToolbarFlexibleSpaceItemIdentifier,
                iTMToolbarMagnificationFieldItemIdentifier,
                NSToolbarFlexibleSpaceItemIdentifier,
                NSToolbarSeparatorItemIdentifier,
                iTMToolbarShowHelpItemIdentifier,
                    nil];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toolbarAllowedItemIdentifiers:
- (NSArray *) toolbarAllowedItemIdentifiers: (NSToolbar*) aToolbar;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [NSArray arrayWithObjects:
                iTMToolbarMagnificationFieldItemIdentifier,
                iTMToolbarMagnificationSetItemIdentifier,
                iTMToolbarShowHelpItemIdentifier,
                NSToolbarPrintItemIdentifier,
                NSToolbarSeparatorItemIdentifier,
                NSToolbarFlexibleSpaceItemIdentifier,
                NSToolbarSpaceItemIdentifier,
                    nil];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  toolbar:itemForItemIdentifier:willBeInsertedIntoToolbar:
- (NSToolbarItem *) toolbar: (NSToolbar *) aToolbar itemForItemIdentifier: (NSString *) anItemIdentifier willBeInsertedIntoToolbar: (BOOL) aFlag;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSToolbarItem * result;
    if([anItemIdentifier isEqualToString: iTMToolbarMagnificationFieldItemIdentifier])
    {
        result = [[NSToolbarItem alloc] initWithItemIdentifier: anItemIdentifier];
        if(aFlag)
            [result setView: [self magnificationFieldForToolbar]];
        else
            [result setView: [self magnificationFieldForPalette]];
    }
    else if([anItemIdentifier isEqualToString: iTMToolbarMagnificationSetItemIdentifier])
    {
        result = [[NSToolbarItem alloc] initWithItemIdentifier: anItemIdentifier];
        if(aFlag)
            [result setView: [self magnificationSetForToolbar]];
        else
            [result setView: [self magnificationSetForPalette]];
    }
    else
        return nil;
    [result setMinSize: [[result view] frame].size];
    [result setMaxSize: [[result view] frame].size];
    {
        NSString * identifier = [result itemIdentifier];
        [result setToolTip: NSLocalizedStringFromTableInBundle(identifier, @"BasicToolbarToolTip",
                                                        [NSBundle bundleForClass: [self class]], "")];
        [result setPaletteLabel: NSLocalizedStringFromTableInBundle(identifier, @"BasicToolbarPaletteLabel",
                                                        [NSBundle bundleForClass: [self class]], "")];
        [result setLabel: NSLocalizedStringFromTableInBundle(identifier, @"BasicToolbarLabel",
                                                        [NSBundle bundleForClass: [self class]], "")];
    }
    if(aFlag)
    {
        if((__LastMagnificationITII!=nil)&&![__LastMagnificationITII isEqualToString: anItemIdentifier])
        {
            BOOL removeFlag=NO;
            int index;
            for(index=0; index<[[aToolbar items] count]; ++index)
                if([[[[aToolbar items] objectAtIndex: index] itemIdentifier] isEqualToString: __LastMagnificationITII])
                {
                    removeFlag=YES;
                    break;
                }
            if(removeFlag)
                [aToolbar removeItemAtIndex: index];
        }
        [__LastMagnificationITII release];
        __LastMagnificationITII = [anItemIdentifier copy];
    }
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  magnificationFieldForPalette
- (NSView *) magnificationFieldForPalette;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    id result = [[NSView alloc] initWithFrame: NSMakeRect(0,0,60,32)];
    NSTextField * magnificationField = [[NSTextField alloc] initWithFrame: [[self magnificationField] frame]];
    [magnificationField setStringValue: @"100 %"];
    [magnificationField setFrameOrigin: NSMakePoint(3,6)];
    [result addSubview: magnificationField];
    [magnificationField release];
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  magnificationFieldForToolbar
- (NSView *) magnificationFieldForToolbar;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    id result = [[NSView alloc] initWithFrame: NSMakeRect(0,0,60,32)];
    NSTextField * magnificationField;
    magnificationField = [[self magnificationField] retain];
    [self setMagnificationField: nil];
    [[self magnificationField] setObjectValue: [magnificationField objectValue]];
    [magnificationField release];
    magnificationField = [[self magnificationField] retain];
    [magnificationField setFrameOrigin: NSMakePoint(3,6)];
    [result addSubview: magnificationField];
    [magnificationField release];
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  magnificationSetForPalette
- (NSView *) magnificationSetForPalette;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    id result = [[NSView alloc] initWithFrame: NSZeroRect];
    {
        NSStepper * stepper = [[NSStepper alloc] initWithFrame: [[self magStepper] frame]];
        [stepper setFrameOrigin: NSMakePoint(0,2)];
        [result addSubview: stepper];
        [result setFrameSize: NSUnionRect([stepper frame], [result frame]).size];
        [stepper release];
    }
    {
        NSTextField * magnificationField = [[NSTextField alloc] initWithFrame: [[self magnificationField] frame]];
        [magnificationField setStringValue: @"100 %"];
        [magnificationField setFrameOrigin: NSMakePoint([result frame].origin.x+[result frame].size.width+4,6)];
        [result addSubview: magnificationField];
        [magnificationField release];
        [result setFrameSize: NSUnionRect(NSInsetRect([magnificationField frame], -4, 0), [result frame]).size];
    }
    {
        iTMMixedButton * button = [[iTMMixedButton alloc] initWithFrame: NSMakeRect(0,0,16,26)];
        [button setTitle: [NSString string]];
        [button setContinuous: NO];
        [button setCenteredArrow: YES];
        [button setFrameOrigin: NSMakePoint([result frame].origin.x+[result frame].size.width,4)];
        [button setMenu: [[[NSMenu alloc] initWithTitle: @""] autorelease]];
        [[button menu] addItemWithTitle: @"Nothing" action: @selector(action:) keyEquivalent: [NSString string]];
        [result addSubview: button];
        [button release];
        [result setFrameSize: NSUnionRect([button frame], [result frame]).size];
    }
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  magnificationSetForToolbar
- (NSView *) magnificationSetForToolbar;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- 1.1.a6: 03/10/2002
To Do List:
"*/
{
    id result = [[NSView alloc] initWithFrame: NSZeroRect];
    {
        NSStepper * stepper = [[self magStepper] retain];
        [stepper setFrameOrigin: NSMakePoint(0,2)];
        [result addSubview: stepper];
        [result setFrameSize: NSUnionRect([stepper frame], [result frame]).size];
        [stepper release];
    }
    {
        NSTextField * magnificationField = [[self magnificationField] retain];
        [self setMagnificationField: nil];
        [[self magnificationField] setObjectValue: [magnificationField objectValue]];
        magnificationField = [[self magnificationField] retain];
        [magnificationField setFrameOrigin: NSMakePoint([result frame].origin.x+[result frame].size.width+4,6)];
        [result addSubview: magnificationField];
        [magnificationField release];
        [result setFrameSize: NSUnionRect(NSInsetRect([magnificationField frame], -4, 0), [result frame]).size];
    }
    {
        iTMMixedButton * button = [[iTMMixedButton alloc] initWithFrame: NSMakeRect(0,0,16,26)];
        [button setTitle: [NSString string]];
        [button setContinuous: NO];
        [button setCenteredArrow: YES];
        {
            NSMenu * menu = [[NSMenu allocWithZone: [NSMenu menuZone]] initWithTitle: @"Magnification"];
            [menu setMenuRepresentation: [[[NSMenuView alloc] initWithFrame: NSZeroRect] autorelease]];
            [[menu menuRepresentation] setFont: [NSFont menuFontOfSize: [NSFont smallSystemFontSize]]];
            {
                NSMenuItem * menuItem = [[NSApp mainMenu] deepItemWithAction: @selector(displayAtMagnification:)];
                NSEnumerator * menuEnumerator = [[[menuItem menu] itemArray] objectEnumerator];
                while(menuItem=[menuEnumerator nextObject])
                {
                    NSMenuItem * MI = [menuItem copy];
                    [MI setRepresentedObject: [menuItem representedObject]];
                    [menu addItem: MI];
                    [MI release];
                }
            }
            {
                BOOL shouldInsertSeparatorItem = NO;
                int shouldInsertSeparatorIndex = [menu numberOfItems];
                #warning missing items!!!
                NSMenuItem * menuItem = [[NSApp mainMenu] deepItemWithAction: @selector(toggleStickToWidth:)];
                NSEnumerator * menuEnumerator = [[[menuItem menu] itemArray] objectEnumerator];
                id MI;
                while(MI = [menuEnumerator nextObject])
                {
                    SEL action=[MI action];
                    if( action == @selector(displayAtFixedSize:) ||
                        action == @selector(displayFitToWidth:) ||
                        action == @selector(displayFitToHeight:) ||
                        action == @selector(displayFitToView:))
                    {
                        [menu addItem: [MI copyWithZone: [MI zone]]];
                        shouldInsertSeparatorItem = YES;
                    }
                }
                if(shouldInsertSeparatorItem)
                    [menu insertItem: [NSMenuItem separatorItem] atIndex: shouldInsertSeparatorIndex];
                shouldInsertSeparatorItem = NO;
                shouldInsertSeparatorIndex = [menu numberOfItems];
                menuEnumerator = [[[menuItem menu] itemArray] objectEnumerator];
                while(MI = [menuEnumerator nextObject])
                {
                    SEL action=[MI action];
                    if( action == @selector(toggleStickToWindow:) ||
                        action == @selector(toggleStickToWidth:) ||
                        action == @selector(toggleStickToHeight:) ||
                        action == @selector(toggleStickToView:))
                    {
                        [menu addItem: [MI copyWithZone: [MI zone]]];
                        shouldInsertSeparatorItem = YES;
                    }
                }
                if(shouldInsertSeparatorItem)
                    [menu insertItem: [NSMenuItem separatorItem] atIndex: shouldInsertSeparatorIndex];
            }
            [button setMenu: menu];
            [menu release];
        }
        [button setFrameOrigin: NSMakePoint([result frame].origin.x+[result frame].size.width,4)];
        [result addSubview: button];
        [button release];
        [result setFrameSize: NSUnionRect([button frame], [result frame]).size];
    }
    return [result autorelease];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= magnificationField
- (NSTextField *) magnificationField;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(!_MagnificationField)
    {
        _MagnificationField = [[NSTextField alloc] initWithFrame: NSZeroRect];
        [_MagnificationField setFormatter: [[[iTMMagnificationFormatter alloc] init] autorelease]];
        [_MagnificationField setAction: @selector(magnificationFieldSetMagnification:)];
        [_MagnificationField setAlignment: NSRightTextAlignment];
        [_MagnificationField setFrameSize: NSMakeSize([[[_MagnificationField formatter]
                stringForObjectValue: [NSDecimalNumber numberWithFloat: 64.0]]
                #warning APPENDING % ?
                        sizeWithAttributes: [NSDictionary dictionaryWithObjectsAndKeys:
                                [[_MagnificationField cell] font], NSFontAttributeName, nil]].width+8, 22)];
////        [_MagnificationField setEnabled: ([self representation] != nil)];
    }
    return _MagnificationField;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= setMagnificationField:
- (void) setMagnificationField: (NSTextField *) aTextField;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [_MagnificationField autorelease];
    _MagnificationField = [aTextField retain];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= magStepper
- (NSStepper *) magStepper;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(!_MagStepper)
    {
        NSRect frame = NSMakeRect(0,0,19,32);
        _MagStepper = [NSStepper alloc];
        _MagStepper = [_MagStepper initWithFrame: frame];
        [_MagStepper setIncrement: 1];
        [_MagStepper setValueWraps: 0];
        [_MagStepper setAction: @selector(displayAtStepperMagnification:)];
        [_MagStepper setTarget: nil];
    }
    return _MagStepper;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= setMagStepper:
- (void) setMagStepper: (NSStepper *) aStepper;
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if(![aStepper isEqual: _MagStepper])
    {
        [_MagStepper release];
        _MagStepper = [aStepper retain];
    }
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepToolbarDelegate

