/*
//  iTMRepWindow.m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Fri Jul 13 2001.
//  Copyright © 2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
*/

#import <AppKit/NSResponder.h>
#import <AppKit/AppKit.h>
#import "iTMRepWindow.h"
#import "iTMWindowsObserver.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepWindow
/*"Description forthcoming."*/
@implementation iTMRepWindow
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  initialize
+ (void) initialize;
/*"Sends an #{+initialize} to the iTMWindowsObserver class object. See the NSWindow category Observer.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    [super initialize];
    [iTMWindowsObserver initialize];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  frameIdentifier
+ (NSString *) frameIdentifier;
/*"Simply returns 'Preview Window Position'. Related to the observation of the window position, see the NSWindow category Position.
Added by jerome.laurens@u-bourgogne.fr (07/12/2001)"*/
{
    return @"Representation Window";
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  performMnemonic:
- (BOOL) performMnemonic: (NSString *) theString;
/*"Description Forthcoming.
Added by jerome.laurens@u-bourgogne.fr (01/24/2002)"*/
{
    if([theString isEqualToString: @"-"])
    {
        [[self firstResponder] doCommandBySelector: @selector(displayZoomOut:)];
        return YES;
    }
    else if([theString isEqualToString: @"+"])
    {
        [[self firstResponder] doCommandBySelector: @selector(displayZoomIn:)];
        return YES;
    }
    else if([theString length] == 1)
    {
        int mask = NSAlphaShiftKeyMask|NSShiftKeyMask|NSControlKeyMask|NSAlternateKeyMask|NSCommandKeyMask;
        if(([[NSApp currentEvent] modifierFlags] & mask) == NSAlternateKeyMask)
            switch([theString characterAtIndex: 0])
            {
                case NSUpArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollPageUp:)];
                    return YES;
                case NSDownArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollPageDown:)];
                    return YES;
                case NSLeftArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollPageLeft:)];
                    return YES;
                case NSRightArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollPageRight:)];
                    return YES;
                default:
                    break;
            }
        else if(!([[NSApp currentEvent] modifierFlags] & mask))
            switch([theString characterAtIndex: 0])
            {
                case NSUpArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollLineUp:)];
                    return YES;
                case NSDownArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollLineDown:)];
                    return YES;
                case NSLeftArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollCharacterLeft:)];
                    return YES;
                case NSRightArrowFunctionKey:
                    [[self firstResponder] doCommandBySelector: @selector(scrollCharacterRight:)];
                    return YES;
                default:
                    break;
            }

    }
    NSLog(@"performMnemonic");
    return [super performMnemonic: theString];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= shouldBeObserved
+ (BOOL) shouldBeObserved;
/*"YES.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMRepWindow

