/*
//  main.m
//  iTeXMac
//
//  Created by jlaurens on Fri Oct 26 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
 */

#import <Foundation/NSDistributedNotificationCenter.h>
#import <Foundation/NSString.h>
#import <Foundation/NSPathUtilities.h>
#import <Foundation/NSDictionary.h>
#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSProcessInfo.h>

int main(int argc, const char *argv[])
{
    int i;
    const char * fileName = "";
    const char * lineNumber = "";
    for(i = 1; i < argc; ++i)
    {
        if(!strcmp(argv[i], "-file"))
        {
            if(i<argc) fileName = argv[++i];
        }
        else if (!strcmp(argv[i], "-line"))
        {
            if(i<argc) lineNumber = argv[++i];
        }
    }
    {
        NSAutoreleasePool * AP = [[NSAutoreleasePool alloc] init];
        NSDictionary * dictionary = [NSDictionary dictionaryWithObjectsAndKeys:
            [[[[NSProcessInfo processInfo] environment] objectForKey: @"PWD"]
                    stringByAppendingPathComponent: [NSString stringWithCString: fileName]], @"fileName",
            [NSString stringWithCString: lineNumber], @"lineNumber",
                nil];
                
        [[NSDistributedNotificationCenter defaultCenter]
            postNotificationName: @"iTMTextEditorShouldOpenTextFile"
                object: nil
                    userInfo: dictionary
                        deliverImmediately: YES];
        [AP release];
    }
//    printf("iTMTextEditorShouldOpenTextFile distributed notification posted\nfile: <%s>, line: <%s>", fileName, lineNumber);
    return 0;
}
