/*
//  iTMMacroDocument(iTMOutlineViewDataSource).h
//  macros
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Jan 15 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import "iTMMacroDocument.h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument(iTMOutlineViewDataSource)

// Data Source Note: Specifying nil as the item will refer to the "root" item(s).
@interface iTMMacroDocument(iTMOutlineViewDataSource)
// required
- (id ) outlineView: (NSOutlineView *) outlineView child:(int)index ofItem: (id) item;
- (BOOL) outlineView: (NSOutlineView *) outlineView isItemExpandable: (id) item;
- (int) outlineView: (NSOutlineView *) outlineView numberOfChildrenOfItem: (id) item;
- (id) outlineView: (NSOutlineView *) outlineView objectValueForTableColumn: (NSTableColumn *) tableColumn byItem: (id) item;
@end
@interface iTMMacroDocument(iTMOutlineViewDataSourceOptional)
// optional
- (void) outlineView: (NSOutlineView *)outlineView setObjectValue: (id) object forTableColumn: (NSTableColumn *) tableColumn byItem: (id) item;
#if 0
- (id) outlineView: (NSOutlineView *) outlineView itemForPersistentObject: (id) object;
- (id) outlineView: (NSOutlineView *) outlineView persistentObjectForItem: (id) item;
#endif
@end
@interface iTMMacroDocument(iTMOutlineViewDataSourceDragAndDrop)
- (BOOL) outlineView: (NSOutlineView *) olv writeItems: (NSArray*) items toPasteboard: (NSPasteboard*) pboard;
    // This method is called after it has been determined that a drag should begin, but before the drag has been started.  To refuse the drag, return NO.  To start a drag, return YES and place the drag data onto the pasteboard (data, owner, etc...).  The drag image and other drag related information will be set up and provided by the outline view once this call returns with YES.  The items array is the list of items that will be participating in the drag.

- (NSDragOperation) outlineView: (NSOutlineView*) olv validateDrop: (id <NSDraggingInfo>) info proposedItem: (id) item proposedChildIndex: (int) index;
    // This method is used by NSOutlineView to determine a valid drop target.  Based on the mouse position, the outline view will suggest a proposed drop location.  This method must return a value that indicates which dragging operation the data source will perform.  The data source may "re-target" a drop if desired by calling setDropItem:dropChildIndex: and returning something other than NSDragOperationNone.  One may choose to re-target for various reasons (eg. for better visual feedback when inserting into a sorted position).

- (BOOL) outlineView: (NSOutlineView*) olv acceptDrop: (id <NSDraggingInfo>) info item: (id) item childIndex: (int) index;
    // This method is called when the mouse is released over an outline view that previously decided to allow a drop via the validateDrop method.  The data source should incorporate the data from the dragging pasteboard at this time.

@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument(iTMOutlineViewDataSource)
