/*
//  iTMMacroDocument.h
//  macros
//
//  Created by jerome.laurens@u-bourgogne.fr on Mon Jan 14 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

//#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMMacroSelectedText;
extern NSString * const iTMMacroDocumentType;
extern NSString * const iTMHelpMacrosEditorKey;

@class iTMMacroMenuItem;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument

@interface iTMMacroDocument : NSDocument
{
@private
    id _MM;
    id _MTV;
    id _OLV;
    id _TF;
    id _APU;
    id _SI;
}
/*"Class methods"*/
/*"Setters and Getters"*/
- (NSMenu *) rootMenu;
- (void) setRootMenu: (NSMenu *) argument;
- (id) outlineView;
- (void) setOutlineView: (id) argument;
- (id) selectedItem;
- (void) setSelectedItem: (id) argument;
- (id) actionPopUp;
- (void) setActionPopUp: (id) argument;
- (id) tooltipField;
- (void) setTooltipField: (id) argument;
- (id) macroTextView;
- (void) setMacroTextView: (id) argument;
- (NSAttributedString *) attributedSelectionDelimiter;
/*"Main methods"*/
- (void) updateMenuItemFromUI: (id) argument;
- (void) updateUIFromMenuItem: (id) argument;
- (BOOL) menuItemUsesMacro: (NSMenuItem *) menuItem;
- (void) menu: (NSMenu *) menu insertItem: (NSMenuItem *) item atIndex: (int) index;
- (void) menu: (NSMenu *) menu removeItemAtIndex: (int) index;
- (void) menuItem: (NSMenuItem *) menuItem setTitle: (NSString *) title;
- (NSString *) nameDisplayString;
- (void) validateUserInterfaceItems;
- (void) deepExpandItem: (NSMenuItem *) item;
/*"Overriden methods"*/
- (NSString *) windowNibName;
- (void) windowControllerDidLoadNib: (NSWindowController *) aController;
- (NSData *) dataRepresentationOfType: (NSString *) type;
- (BOOL) readFromFile: (NSString *) fileName ofType: (NSString *) type;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument
