/*
//  iTMTextMacro.h
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Feb 21 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

extern NSString * const iTMMacroNameKey;
extern NSString * const iTMMacroSelectionKey;
extern NSString * const iTMMacroInsertionKey;
extern NSString * const iTMMacroTabAnchorKey;
extern NSString * const iTMMacroTooltipKey;

extern NSString * const iTMUDTabAnchorStringKey;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTextMacro

@interface iTMTextMacro : NSString
{
@private
    NSString * _Before;
    NSString * _Selected;
    NSString * _After;
    NSString * _Tooltip;
}
/*"Class methods"*/
+ (id) macroV1WithBefore: (NSString *) before selected: (NSString *) selected after: (NSString *) after;
/*"Setters and Getters"*/
- (id) macroBefore;
- (void) setMacroBefore: (id) argument;
- (id) macroSelected;
- (void) setMacroSelected: (id) argument;
- (id) macroAfter;
- (void) setMacroAfter: (id) argument;
- (id) tooltip;
- (void) setTooltip: (id) argument;
- (NSString *) macroStringForName: (NSString *) name selection: (NSString *) selection indent: (NSString *) indentPrefix
    selectedRangePointer: (NSRangePointer) aRangePtr;
- (NSString *) string;
/*"Main methods"*/
/*"Overriden methods"*/
- (void) dealloc;
@end

@interface NSTextView (iTMTextMacro)
- (void) scrollToNextTabAnchor: (id) sender;
- (void) scrollToPreviousTabAnchor: (id) sender;
@end
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMTextMacro
