/*
//  iTMMacroDocument(iTMOutlineViewDelegate).m
//  macros
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Jan 15 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/NSString.h>
#import <Foundation/Foundation.h>
#import <AppKit/NSMenu.h>
#import <AppKit/NSOutlineView.h>
#import <AppKit/NSTableColumn.h>
#import <AppKit/AppKit.h>
#import "iTMMacroDocument.h"
#import "iTMMacroDocument(iTMOutlineViewDelegate).h"
#import "iTMMacroOutlineView.h"
#import "iTMRootMacrosMenu.h"
#import "iTMMacroMenuItem.h"

@interface iTMMacroDocument(iTMActionPrivate)
/*"Class methods"*/
/*"Setters and Getters"*/
/*"Main methods"*/
- (void) removeCurrentDragMenuItem;
- (void) removeCurrentDragMenuItems;
/*"Overriden methods"*/
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument(iTMOutlineViewDelegate)
/*"Description forthcoming."*/
@implementation iTMMacroDocument(iTMOutlineViewDelegate)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:willDisplayOutlineCell:forTableColumn:item:
- (void) outlineView: (NSOutlineView *) olv willDisplayOutlineCell: (id) cell forTableColumn: (NSTableColumn *) tableColumn item: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewSelectionDidChange:
- (void) outlineViewSelectionDidChange: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setSelectedItem: [[notification object] selectedItem]];
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldEditTableColumn:item:
- (BOOL) outlineView: (NSOutlineView *) olv shouldEditTableColumn: (NSTableColumn *) tableColumn item: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return [[tableColumn identifier]isEqualToString: @"iTM-MacroName"] && ![item isEqual: [NSMenuItem separatorItem]];
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldSelectTableColumn:
- (BOOL) outlineView: (NSOutlineView *) olv shouldSelectTableColumn: (NSTableColumn *) tableColumn;
// NSOutlineView specific
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if([[tableColumn identifier]isEqualToString: @"iTM-ChangeStatus"])
        [self outlineView: olvexpandEditedItems: [[self rootMenu]editedMacroItems]];
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:expandEditedItems:
- (void) outlineView: (NSOutlineView *) olv expandEditedItems: (NSArray *) items
/*"Description forthcoming. NOT COCOA
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    NSEnumerator * E = [items objectEnumerator];
    id item;
    while(item = [E nextObject])
        if([item hasSubmenu])
        {
            NSArray * RA = [[item submenu] editedMacroItems];
            if([RA count])
            {
                [olv expandItem: item];
                [self outlineView: olv expandEditedItems: RA];
            }
        }
    return;
}
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  selectionShouldChangeInOutlineView:
- (BOOL) selectionShouldChangeInOutlineView: (NSOutlineView *) olv
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [self setSelectedItem: [olv selectedItem]];
    return YES;
}
#endif
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldSelectItem:
- (BOOL) outlineView: (NSOutlineView *) olv shouldSelectItem: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:willDisplayCell:forTableColumn:item:
- (void) outlineView: (NSOutlineView *) olv willDisplayCell: (id) cell forTableColumn: (NSTableColumn *) tableColumn item: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldSelectTableColumn:
- (BOOL) outlineView: (NSOutlineView *) olv shouldSelectTableColumn: (NSTableColumn *) tableColumn;
// NSOutlineView specific
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldExpandItem:
- (BOOL) outlineView: (NSOutlineView *) olv shouldExpandItem: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:shouldCollapseItem:
- (BOOL) outlineView: (NSOutlineView *) olv shouldCollapseItem: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return YES;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineView:willDisplayOutlineCell:forTableColumn:item:
- (void) outlineView: (NSOutlineView *) olv willDisplayOutlineCell: (id) cell forTableColumn: (NSTableColumn *) tableColumn item: (id) item
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewColumnDidMove:
- (void) outlineViewColumnDidMove: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewColumnDidResize:
- (void) outlineViewColumnDidResize: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewSelectionIsChanging:
- (void) outlineViewSelectionIsChanging: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewItemWillExpand:
- (void) outlineViewItemWillExpand: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewItemDidExpand:
- (void) outlineViewItemDidExpand: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewItemWillCollapse:
- (void) outlineViewItemWillCollapse: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  outlineViewItemDidCollapse:
- (void) outlineViewItemDidCollapse: (NSNotification *) notification
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    return;
}
#endif
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroDocument(iTMOutlineViewDelegate)

