/*
//  iTMMacroOutlineView.m
//  macros
//
//  Created by jerome.laurens@u-bourgogne.fr on Tue Jan 15 2002.
//  Copyright (c) 2001 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/NSTableView.h>
#import <AppKit/NSOutlineView.h>
#import <AppKit/AppKit.h>
#import "iTMMacroOutlineView.h"

@implementation NSOutlineView(iTeXMac)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  selectedItem
- (id) selectedItem
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    if([selfnumberOfSelectedRows] == 1)
        return [self itemAtRow: [self selectedRow]];
    else
        return nil;
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  selectedItems
- (NSArray *) selectedItems
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    int numberOfSelectedRows = [selfnumberOfSelectedRows];
    if(numberOfSelectedRows > 0)
    {
        NSMutableArray * MA = [[[NSMutableArray alloc] initWithCapacity: numberOfSelectedRows] autorelease];
        NSEnumerator * E = [self selectedRowEnumerator];
        NSNumber * N;
        while(N = [E nextObject])
            [MA addObject: [self itemAtRow: [N intValue]]];
        return [[MA copy] autorelease];
    }
    else
        return nil;
}
@end

@interface NSObject(iTMOutlineView)
- (void) removeSelectedMenuItems: (id) sender;
- (void) removeCurrentDragMenuItem;
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroOutlineView
/*"Description forthcoming."*/
@implementation iTMMacroOutlineView
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  draggedImage:endedAt:operation:
- (void) draggedImage: (NSImage *) anImage endedAt: (NSPoint) aPoint operation: (NSDragOperation) operation
/*"Description forthcoming.
Version history: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
{
    [super draggedImage: anImage endedAt: aPoint operation: operation];
    if((operation == NSDragOperationMove) && [[self dataSource] respondsToSelector: @selector(removeCurrentDragMenuItem)])
        [[self dataSource] removeCurrentDragMenuItem];
    return;
}
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  iTMMacroOutlineView

