/*
//  iTMTeXDocument(iTMMacros).m
//  iTeXMac
//
//  Created by jerome.laurens@u-bourgogne.fr on Thu Aug 30 2001.
//  Copyright  2001-2002 Laurens'Tribune. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify it under the terms
//  of the GNU General Public License as published by the Free Software Foundation; either
//  version 2 of the License, or any later version, modified by the addendum below.
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details. You should have received a copy
//  of the GNU General Public License along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  GPL addendum: Any simple modification of the present code which purpose is to remove bug,
//  improve efficiency in both code execution and code reading or writing should be addressed
//  to the actual developper team.
//
//  Version history: (format "- date:contribution(contributor)") 
//  To Do List: (format "- proposition(percentage actually done)")
*/

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "iTMTeXDocument(iTMMacros).h"
#import "iTMMacrosController.h"
#import "NSMenu(iTeXMac).h"

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(iTMMacros)
/*"Description forthcoming. This should live in a separate controller (caching info is needed)."*/
@implementation iTMTeXDocument(iTMMacros)
#if 0
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  BUTTON()
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  docButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  gfxButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  mathButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  miscButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  textButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  tmplButton:
#define BUTTON(selector) - (void) selector: (id) sender;{return;}
/*"This is for validation process: the mark button will ask its target for the #{validateMarkButton:} below...
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List:
"*/
BUTTON(docButton);
BUTTON(gfxButton);
BUTTON(mathButton);
BUTTON(miscButton);
BUTTON(textButton);
BUTTON(tmplButton);
#endif
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  VALIDATEBUTTON(,)
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateDocButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateGfxButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMathButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateMiscButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTextButton:
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  validateTmplButton:
#define VALIDATEBUTTON(validateSelector, menuSelector)\
- (void) validateSelector: (id) sender;\
{\
    if(![sender menu] || ([[NSApp currentEvent] modifierFlags] & NSAlternateKeyMask))\
    {\
        NSMenu * menu = [[iTMMacrosController sharedMacrosController] menuSelector: self];\
        [menu deepMakeCellSizeSmall];\
        [sender setMenu: menu];\
    }\
    return;\
}
/*"Description forthcoming.
Version History: jerome.laurens@u-bourgogne.fr
- < 1.1: 03/10/2002
To Do List: ...
"*/
VALIDATEBUTTON(validateDocButton, docMacrosMenuForDocument);
VALIDATEBUTTON(validateGfxButton, gfxMacrosMenuForDocument);
VALIDATEBUTTON(validateMathButton, mathMacrosMenuForDocument);
VALIDATEBUTTON(validateMiscButton, miscMacrosMenuForDocument);
VALIDATEBUTTON(validateTextButton, textMacrosMenuForDocument);
VALIDATEBUTTON(validateTmplButton, templatesMenuForDocument);
@end

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= iTMTeXDocument(iTMMacros)

